/*
 * *** Please do not edit ! ***
 * @(#) dollar_dcgConnect_3.cs
 * @procedure $dcg_connect/3 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_dcgConnect_3 : Predicate {
    static internal readonly Predicate dollar_dcgConnect_3_1 = new Predicates.dollar_dcgConnect_3_1();
    static internal readonly Predicate dollar_dcgConnect_3_2 = new Predicates.dollar_dcgConnect_3_2();
    static internal readonly Predicate dollar_dcgConnect_3_3 = new Predicates.dollar_dcgConnect_3_3();
    static internal readonly Predicate dollar_dcgConnect_3_con = new Predicates.dollar_dcgConnect_3_con();
    static internal readonly Predicate dollar_dcgConnect_3_int = new Predicates.dollar_dcgConnect_3_int();
    static internal readonly Predicate dollar_dcgConnect_3_lis = new Predicates.dollar_dcgConnect_3_lis();
    static internal readonly Predicate dollar_dcgConnect_3_var = new Predicates.dollar_dcgConnect_3_var();

    public Term arg1, arg2, arg3;

    public dollar_dcgConnect_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_dcgConnect_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_dcgConnect_3_var,
                                   dollar_dcgConnect_3_int,
                                   dollar_dcgConnect_3_con,
                                   dollar_dcgConnect_3_var,
                                   dollar_dcgConnect_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$dcg_connect(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_dcgConnect_3_var : dollar_dcgConnect_3 {
    static internal readonly Predicate dollar_dcgConnect_3_var_1 = new Predicates.dollar_dcgConnect_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_dcgConnect_3_1, dollar_dcgConnect_3_var_1);
    }
}

sealed class dollar_dcgConnect_3_var_1 : dollar_dcgConnect_3 {
    static internal readonly Predicate dollar_dcgConnect_3_var_2 = new Predicates.dollar_dcgConnect_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_dcgConnect_3_2, dollar_dcgConnect_3_var_2);
    }
}

sealed class dollar_dcgConnect_3_var_2 : dollar_dcgConnect_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_dcgConnect_3_3);
    }
}

sealed class dollar_dcgConnect_3_int : dollar_dcgConnect_3 {
    static internal readonly Predicate dollar_dcgConnect_3_int_1 = new Predicates.dollar_dcgConnect_3_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_dcgConnect_3_2, dollar_dcgConnect_3_int_1);
    }
}

sealed class dollar_dcgConnect_3_int_1 : dollar_dcgConnect_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_dcgConnect_3_3);
    }
}

sealed class dollar_dcgConnect_3_con : dollar_dcgConnect_3 {
    static internal readonly Predicate dollar_dcgConnect_3_con_1 = new Predicates.dollar_dcgConnect_3_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_dcgConnect_3_2, dollar_dcgConnect_3_con_1);
    }
}

sealed class dollar_dcgConnect_3_con_1 : dollar_dcgConnect_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_dcgConnect_3_3);
    }
}

sealed class dollar_dcgConnect_3_lis : dollar_dcgConnect_3 {
    static internal readonly Predicate dollar_dcgConnect_3_lis_1 = new Predicates.dollar_dcgConnect_3_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_dcgConnect_3_2, dollar_dcgConnect_3_lis_1);
    }
}

sealed class dollar_dcgConnect_3_lis_1 : dollar_dcgConnect_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_dcgConnect_3_3);
    }
}

sealed class dollar_dcgConnect_3_1 : dollar_dcgConnect_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
        } else if (a1.isVariable() ){
            Term[] args = {engine.makeVariable(), engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        Term[] h2 = {engine.makeVariable(), engine.makeVariable()};
        a5 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_unify_2(a2, a5, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_dcgConnect_3_2 : dollar_dcgConnect_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("true");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a6 = args[0];
            if ( !s3.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a3.isVariable() ){
            a6 = engine.makeVariable();
            Term[] args = {a6, s3};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f1 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            if ( !a4.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a5.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a6.isVariable() ){
            Term[] args = {a4, a5};
            if ( !a6.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_dcgConnect_3_3 : dollar_dcgConnect_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        return cont;
    }
}
}

