/*
 * *** Please do not edit ! ***
 * @(#) Abolish_2.cs
 * @procedure abolish/2 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Abolish_2 : Predicate {
    static internal readonly Predicate Abolish_2_1 = new Predicates.Abolish_2_1();
    static internal readonly Predicate Abolish_2_2 = new Predicates.Abolish_2_2();
    static internal readonly Predicate Abolish_2_sub_1 = new Predicates.Abolish_2_sub_1();

    public Term arg1, arg2;

    public Abolish_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Abolish_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(Abolish_2_1, Abolish_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "abolish(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class Abolish_2_sub_1 : Abolish_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Abolish_2_2);
    }
}

sealed class Abolish_2_1 : Abolish_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        Term[] h2 = {a3, a4};
        a6 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_putTerm_3(a1, a6, s3, cont);
        p2 = new Predicates.dollar_cut_1(a5, p1);
        p3 = new Predicates.dollar_integer_1(a4, p2);
        p4 = new Predicates.dollar_atom_1(a3, p3);
        return new Predicates.dollar_getLevel_1(a5, p4);
    }
}

sealed class Abolish_2_2 : Abolish_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("functor");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("arity");
    static internal readonly Term[] h10 = {s3, s4};
    static internal readonly StructureTerm s5 = new StructureTerm(f2, h10);
    static internal readonly Term[] h11 = {s5};
    static internal readonly StructureTerm s6 = new StructureTerm(f1, h11);
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("abolish", 2);
    static internal readonly IntegerTerm s9 = new IntegerTerm(2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h8 = {a1, a2};
        a3 = new StructureTerm(f7, h8);
        return new Predicates.dollar_illarg_3(s6, a3, s9, cont);
    }
}
}

