/*
 * *** Please do not edit ! ***
 * @(#) Functor_3.cs
 * @procedure functor/3 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Functor_3 : Predicate {
    static internal readonly Predicate Functor_3_1 = new Predicates.Functor_3_1();
    static internal readonly Predicate Functor_3_2 = new Predicates.Functor_3_2();
    static internal readonly Predicate Functor_3_3 = new Predicates.Functor_3_3();
    static internal readonly Predicate Functor_3_4 = new Predicates.Functor_3_4();
    static internal readonly Predicate Functor_3_sub_1 = new Predicates.Functor_3_sub_1();

    public Term arg1, arg2, arg3;

    public Functor_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public Functor_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(Functor_3_1, Functor_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "functor(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class Functor_3_sub_1 : Functor_3 {
    static internal readonly Predicate Functor_3_sub_2 = new Predicates.Functor_3_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(Functor_3_2, Functor_3_sub_2);
    }
}

sealed class Functor_3_sub_2 : Functor_3 {
    static internal readonly Predicate Functor_3_sub_3 = new Predicates.Functor_3_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(Functor_3_3, Functor_3_sub_3);
    }
}

sealed class Functor_3_sub_3 : Functor_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Functor_3_4);
    }
}

sealed class Functor_3_1 : Functor_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_functor_3(a1, a2, a3, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_nonvar_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class Functor_3_2 : Functor_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_dummyBuilt__0_3(a1, a2, a3, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_integer_1(a3, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class Functor_3_3 : Functor_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("integer");
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("functor", 3);
    static internal readonly IntegerTerm s6 = new IntegerTerm(3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        Term[] h5 = {a1, a2, a3};
        a5 = new StructureTerm(f4, h5);
        p1 = new Predicates.dollar_illarg_3(s3, a5, s6, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_nonvar_1(a3, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class Functor_3_4 : Functor_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("functor", 3);
    static internal readonly IntegerTerm s4 = new IntegerTerm(3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        Term[] h3 = {a1, a2, a3};
        a4 = new StructureTerm(f2, h3);
        return new Predicates.dollar_illarg_3(s1, a4, s4, cont);
    }
}
}

