/*
 * *** Please do not edit ! ***
 * @(#) GetTerm_2.cs
 * @procedure get_term/2 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class GetTerm_2 : Predicate {
    static internal readonly Predicate GetTerm_2_1 = new Predicates.GetTerm_2_1();
    static internal readonly Predicate GetTerm_2_2 = new Predicates.GetTerm_2_2();
    static internal readonly Predicate GetTerm_2_3 = new Predicates.GetTerm_2_3();
    static internal readonly Predicate GetTerm_2_sub_1 = new Predicates.GetTerm_2_sub_1();

    public Term arg1, arg2;

    public GetTerm_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public GetTerm_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(GetTerm_2_1, GetTerm_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "get_term(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class GetTerm_2_sub_1 : GetTerm_2 {
    static internal readonly Predicate GetTerm_2_sub_2 = new Predicates.GetTerm_2_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(GetTerm_2_2, GetTerm_2_sub_2);
    }
}

sealed class GetTerm_2_sub_2 : GetTerm_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(GetTerm_2_3);
    }
}

sealed class GetTerm_2_1 : GetTerm_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_getTerm_2(a1, a2, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.Ground_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class GetTerm_2_2 : GetTerm_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("type", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("ground");
    static internal readonly Term[] h7 = {s2};
    static internal readonly StructureTerm s3 = new StructureTerm(f1, h7);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("get_term", 2);
    static internal readonly IntegerTerm s6 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        Term[] h5 = {a1, a2};
        a4 = new StructureTerm(f4, h5);
        p1 = new Predicates.dollar_illarg_3(s3, a4, s6, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_nonvar_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class GetTerm_2_3 : GetTerm_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("get_term", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        Term[] h3 = {a1, a2};
        a3 = new StructureTerm(f2, h3);
        return new Predicates.dollar_illarg_3(s1, a3, s4, cont);
    }
}
}

