/*
 * *** Please do not edit ! ***
 * @(#) Time_1.cs
 * @procedure time/1 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Time_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("runtime");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("RUN time = ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(" msec. ");

    public Term arg1;

    public Time_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Time_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = arg1.dereference();

        a4 = engine.makeVariable();
        a3 = new ListTerm(a4, s2);
        a2 = new ListTerm(engine.makeVariable(), a3);
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s4, p1);
        p3 = new Predicates.Write_1(a4, p2);
        p4 = new Predicates.Write_1(s3, p3);
        p5 = new Predicates.Statistics_2(s1, a2, p4);
        p6 = new Predicates.Once_1(a1, p5);
        return new Predicates.Statistics_2(s1, engine.makeVariable(), p6);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "time(" + arg1 + ")";
    }
}
}

