/*
 * *** Please do not edit ! ***
 * @(#) dollar_opAtoms_3.cs
 * @procedure $op_atoms/3 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_opAtoms_3 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_opAtoms_3 );
    static internal readonly Predicate dollar_opAtoms_3_1 = new Predicates.dollar_opAtoms_3_1();
    static internal readonly Predicate dollar_opAtoms_3_2 = new Predicates.dollar_opAtoms_3_2();
    static internal readonly Predicate dollar_opAtoms_3_3 = new Predicates.dollar_opAtoms_3_3();
    static internal readonly Predicate dollar_opAtoms_3_con = new Predicates.dollar_opAtoms_3_con();
    static internal readonly Predicate dollar_opAtoms_3_lis = new Predicates.dollar_opAtoms_3_lis();
    static internal readonly Predicate dollar_opAtoms_3_var = new Predicates.dollar_opAtoms_3_var();

    public Term arg1, arg2, arg3;

    public dollar_opAtoms_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_opAtoms_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_opAtoms_3_var,
                                   dollar_opAtoms_3_3,
                                   dollar_opAtoms_3_con,
                                   dollar_opAtoms_3_3,
                                   dollar_opAtoms_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$op_atoms(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_opAtoms_3_var : dollar_opAtoms_3 {
    static internal readonly Predicate dollar_opAtoms_3_var_1 = new Predicates.dollar_opAtoms_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_opAtoms_3_1, dollar_opAtoms_3_var_1);
    }
}

sealed class dollar_opAtoms_3_var_1 : dollar_opAtoms_3 {
    static internal readonly Predicate dollar_opAtoms_3_var_2 = new Predicates.dollar_opAtoms_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_opAtoms_3_2, dollar_opAtoms_3_var_2);
    }
}

sealed class dollar_opAtoms_3_var_2 : dollar_opAtoms_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_opAtoms_3_3);
    }
}

sealed class dollar_opAtoms_3_con : dollar_opAtoms_3 {
    static internal readonly Predicate dollar_opAtoms_3_con_1 = new Predicates.dollar_opAtoms_3_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_opAtoms_3_1, dollar_opAtoms_3_con_1);
    }
}

sealed class dollar_opAtoms_3_con_1 : dollar_opAtoms_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_opAtoms_3_3);
    }
}

sealed class dollar_opAtoms_3_lis : dollar_opAtoms_3 {
    static internal readonly Predicate dollar_opAtoms_3_lis_1 = new Predicates.dollar_opAtoms_3_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_opAtoms_3_2, dollar_opAtoms_3_lis_1);
    }
}

sealed class dollar_opAtoms_3_lis_1 : dollar_opAtoms_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_opAtoms_3_3);
    }
}

sealed class dollar_opAtoms_3_1 : dollar_opAtoms_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a3, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_opAtoms_3_2 : dollar_opAtoms_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_opAtoms_3(a5, a6, a3, cont);
        p2 = new Predicates._C_3(a2, a4, a6, p1);
        p3 = new Predicates.dollar_atom_1(a4, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_opAtoms_3_3 : dollar_opAtoms_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = new ListTerm(a1, s1);
        engine.aregs[1] = a4;
        engine.aregs[2] = a2;
        engine.aregs[3] = a3;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

