/*
 * *** Please do not edit ! ***
 * @(#) dollar_parseTokens_4.cs
 * @procedure $parse_tokens/4 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_parseTokens_4 : Predicate {

    public Term arg1, arg2, arg3, arg4;

    public dollar_parseTokens_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_parseTokens_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.dollar_parseTokens2_7(a2, a7, a8, a1, engine.makeVariable(), a10, a4, p1);
        p3 = new Predicates.dollar_parseTokensSkipSpaces_2(a9, a10, p2);
        p4 = new Predicates.dollar_cut_1(a5, p3);
        p5 = new Predicates.dollar_parseTokens1_5(a2, a7, a8, a6, a9, p4);
        p6 = new Predicates.dollar_parseTokensSkipSpaces_2(a3, a6, p5);
        return new Predicates.dollar_getLevel_1(a5, p6);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$parse_tokens(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

