/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeTermListArgs_4.cs
 * @procedure $write_term_list_args/4 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeTermListArgs_4 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_writeTermListArgs_4_1 = new Predicates.dollar_writeTermListArgs_4_1();
    static internal readonly Predicate dollar_writeTermListArgs_4_2 = new Predicates.dollar_writeTermListArgs_4_2();
    static internal readonly Predicate dollar_writeTermListArgs_4_3 = new Predicates.dollar_writeTermListArgs_4_3();
    static internal readonly Predicate dollar_writeTermListArgs_4_var = new Predicates.dollar_writeTermListArgs_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_writeTermListArgs_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_writeTermListArgs_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeTermListArgs_4_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_writeTermListArgs_4_var
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$write_term_list_args(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_writeTermListArgs_4_var : dollar_writeTermListArgs_4 {
    static internal readonly Predicate dollar_writeTermListArgs_4_var_1 = new Predicates.dollar_writeTermListArgs_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeTermListArgs_4_1, dollar_writeTermListArgs_4_var_1);
    }
}

sealed class dollar_writeTermListArgs_4_var_1 : dollar_writeTermListArgs_4 {
    static internal readonly Predicate dollar_writeTermListArgs_4_var_2 = new Predicates.dollar_writeTermListArgs_4_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeTermListArgs_4_2, dollar_writeTermListArgs_4_var_2);
    }
}

sealed class dollar_writeTermListArgs_4_var_2 : dollar_writeTermListArgs_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeTermListArgs_4_3);
    }
}

sealed class dollar_writeTermListArgs_4_1 : dollar_writeTermListArgs_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(999);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("punct");
    static internal readonly IntegerTerm s3 = new IntegerTerm(44);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s5 = new ListTerm(s3, s4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = new ListTerm(engine.makeVariable(), engine.makeVariable());
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTermListArgs_4(a6, s2, a3, a4, cont);
        p2 = new Predicates.dollar_put_1(s5, p1);
        p3 = new Predicates.dollar_writeSpaceIfNeeded_2(a9, s2, p2);
        p4 = new Predicates.dollar_writeTerm0_5(a5, s1, a2, a9, a4, p3);
        p5 = new Predicates.dollar_cut_1(a7, p4);
        p6 = new Predicates.dollar_unify_2(a6, a8, p5);
        p7 = new Predicates.dollar_nonvar_1(a6, p6);
        return new Predicates.dollar_getLevel_1(a7, p7);
    }
}

sealed class dollar_writeTermListArgs_4_2 : dollar_writeTermListArgs_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(999);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a5, s2, a2, a3, a4, cont);
        p2 = new Predicates.dollar_cut_1(a7, p1);
        p3 = new Predicates.dollar_unify_2(a6, s1, p2);
        p4 = new Predicates.dollar_nonvar_1(a6, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_writeTermListArgs_4_3 : dollar_writeTermListArgs_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(999);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("punct");
    static internal readonly IntegerTerm s3 = new IntegerTerm(124);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s5 = new ListTerm(s3, s4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_writeTerm0_5(a6, s1, s2, a3, a4, cont);
        p2 = new Predicates.dollar_put_1(s5, p1);
        p3 = new Predicates.dollar_writeSpaceIfNeeded_2(a7, s2, p2);
        return new Predicates.dollar_writeTerm0_5(a5, s1, a2, a7, a4, p3);
    }
}
}

