/*
 * *** Please do not edit ! ***
 * @(#) ParseTokens_2.cs
 * @procedure parse_tokens/2 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class ParseTokens_2 : Predicate {
    static internal readonly Predicate dollar_tokens_1_res0 = new Resources.resource_0_Inout_dollar_tokens_1();
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$tokens", 1);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1201);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(".");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s7 = new ListTerm(s5, s6);

    public Term arg1, arg2;

    public ParseTokens_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public ParseTokens_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        Term[] h2 = {a2};
        a5 = new StructureTerm(f1, h2);
        Term[] h3 = {a2};
        a6 = new ClosureTerm( dollar_tokens_1_res0, h3);
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_endExpImp_2(a4, a7, p1);
        p3 = new Predicates.dollar_parseTokens_4(a1, s4, a2, s7, p2);
        p4 = new Predicates.dollar_midExpImp_1(a7, p3);
        p5 = new Predicates.dollar_addExpRes_2(a5, a6, p4);
        p6 = new Predicates.dollar_beginImp_1(a4, p5);
        return new Predicates.dollar_getLevel_1(a3, p6);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "parse_tokens(" + arg1 + ", " + arg2 + ")";
    }
}
}

