/*
 * *** Please do not edit ! ***
 * @(#) dollar_listOfBody_3.cs
 * @procedure $list_of_body/3 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_listOfBody_3 : Predicate {
    static internal readonly Predicate dollar_listOfBody_3_1 = new Predicates.dollar_listOfBody_3_1();
    static internal readonly Predicate dollar_listOfBody_3_2 = new Predicates.dollar_listOfBody_3_2();
    static internal readonly Predicate dollar_listOfBody_3_var = new Predicates.dollar_listOfBody_3_var();

    public Term arg1, arg2, arg3;

    public dollar_listOfBody_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_listOfBody_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_listOfBody_3_var,
                                   dollar_listOfBody_3_2,
                                   dollar_listOfBody_3_2,
                                   dollar_listOfBody_3_var,
                                   dollar_listOfBody_3_2
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$list_of_body(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_listOfBody_3_var : dollar_listOfBody_3 {
    static internal readonly Predicate dollar_listOfBody_3_var_1 = new Predicates.dollar_listOfBody_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_listOfBody_3_1, dollar_listOfBody_3_var_1);
    }
}

sealed class dollar_listOfBody_3_var_1 : dollar_listOfBody_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_listOfBody_3_2);
    }
}

sealed class dollar_listOfBody_3_1 : dollar_listOfBody_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_listOfBody_3(a5, a6, a3, cont);
        p2 = new Predicates._C_3(a2, a4, a6, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_listOfBody_3_2 : dollar_listOfBody_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        return new Predicates._C_3(a2, a1, a3, cont);
    }
}
}

