/*
 * *** Please do not edit ! ***
 * @(#) dollar_spyKey_2.cs
 * @procedure $spy_key/2 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_spyKey_2 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);

    public Term arg1, arg2;

    public dollar_spyKey_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_spyKey_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        if ( !a1.unify(a2, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h2 = {a4, a5};
        a3 = new StructureTerm(f1, h2);
        p1 = new Predicates.dollar_integer_1(a5, cont);
        p2 = new Predicates.dollar_atom_1(a4, p1);
        return new Predicates.dollar_unify_2(a1, a3, p2);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$spy_key(" + arg1 + ", " + arg2 + ")";
    }
}
}

