/*
 * *** Please do not edit ! ***
 * @(#) dollar_traceInit_0.cs
 * @procedure $trace_init/0 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_traceInit_0 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$trace_flag", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$current_leash", 1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("$current_spy", 2);
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("off");
    static internal readonly Term[] h9 = {s7};
    static internal readonly StructureTerm s8 = new StructureTerm(f1, h9);

    public dollar_traceInit_0(Predicate cont) {
        this.cont = cont;
    }

    public dollar_traceInit_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4, p5;

        Term[] h2 = {engine.makeVariable()};
        a1 = new StructureTerm(f1, h2);
        Term[] h4 = {engine.makeVariable()};
        a2 = new StructureTerm(f3, h4);
        Term[] h6 = {engine.makeVariable(), engine.makeVariable()};
        a3 = new StructureTerm(f5, h6);
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_assertLeashes_1(a4, cont);
        p2 = new Predicates.dollar_fullLeash_1(a4, p1);
        p3 = new Predicates.Assert_1(s8, p2);
        p4 = new Predicates.Retractall_1(a3, p3);
        p5 = new Predicates.Retractall_1(a2, p4);
        return new Predicates.Retractall_1(a1, p5);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "$trace_init";
    }
}
}

