/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeDepth_1.cs
 * @procedure $write_depth/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeDepth_1 : Predicate {
    static internal readonly Predicate dollar_writeDepth_1_1 = new Predicates.dollar_writeDepth_1_1();
    static internal readonly Predicate dollar_writeDepth_1_2 = new Predicates.dollar_writeDepth_1_2();
    static internal readonly Predicate dollar_writeDepth_1_var = new Predicates.dollar_writeDepth_1_var();

    public Term arg1;

    public dollar_writeDepth_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeDepth_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeDepth_1_var,
                                   dollar_writeDepth_1_var,
                                   dollar_writeDepth_1_2,
                                   dollar_writeDepth_1_2,
                                   dollar_writeDepth_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_depth(" + arg1 + ")";
    }
}

sealed class dollar_writeDepth_1_var : dollar_writeDepth_1 {
    static internal readonly Predicate dollar_writeDepth_1_var_1 = new Predicates.dollar_writeDepth_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeDepth_1_1, dollar_writeDepth_1_var_1);
    }
}

sealed class dollar_writeDepth_1_var_1 : dollar_writeDepth_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeDepth_1_2);
    }
}

sealed class dollar_writeDepth_1_1 : dollar_writeDepth_1 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" + ");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_fastWrite_1(s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_writeDepth_1_2 : dollar_writeDepth_1 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" |");
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_writeDepth_1(a2, cont);
        p2 = new Predicates.dollar_minus_3(a1, s3, a2, p1);
        p3 = new Predicates.dollar_fastWrite_1(s2, p2);
        return new Predicates.dollar_greaterThan_2(a1, s1, p3);
    }
}
}

