/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateSwitchNores_4.cs
 * @procedure $generate_switch_nores/4 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateSwitchNores_4 : Predicate {
    static internal readonly Predicate dollar_generateSwitchNores_4_1 = new Predicates.dollar_generateSwitchNores_4_1();
    static internal readonly Predicate dollar_generateSwitchNores_4_2 = new Predicates.dollar_generateSwitchNores_4_2();
    static internal readonly Predicate dollar_generateSwitchNores_4_sub_1 = new Predicates.dollar_generateSwitchNores_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_generateSwitchNores_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_generateSwitchNores_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_generateSwitchNores_4_1, dollar_generateSwitchNores_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$generate_switch_nores(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_generateSwitchNores_4_sub_1 : dollar_generateSwitchNores_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSwitchNores_4_2);
    }
}

sealed class dollar_generateSwitchNores_4_1 : dollar_generateSwitchNores_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("constructor", 1);
    static internal readonly SymbolTerm s10 = SymbolTerm.makeSymbol("var");
    static internal readonly IntegerTerm s11 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            if ( !s2.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5, s2};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h4 = {a5, s2};
        a7 = new StructureTerm(f1, h4);
        Term[] h6 = {a7, s5};
        a6 = new StructureTerm(f3, h6);
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        Term[] h8 = {a5, s2};
        a12 = new StructureTerm(f1, h8);
        Term[] h9 = {a12};
        a11 = new StructureTerm(f7, h9);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        Term[] h12 = {a5, s2};
        a15 = new StructureTerm(f1, h12);
        a16 = engine.makeVariable();
        Term[] h13 = {a5, s2};
        a17 = new StructureTerm(f1, h13);
        p1 = new Predicates.dollar_generateStaticPred_5(a17, a14, a16, a9, s5, cont);
        p2 = new Predicates.dollar_generateNoswitchNores_5(a15, a14, a16, a13, a4, p1);
        p3 = new Predicates.dollar_selectType_4(a1, s10, s11, a14, p2);
        p4 = new Predicates._C_3(a10, a11, a13, p3);
        p5 = new Predicates._C_3(a8, a9, a10, p4);
        p6 = new Predicates._C_3(a3, a6, a8, p5);
        return new Predicates.dollar_neckCut_0(p6);
    }
}

sealed class dollar_generateSwitchNores_4_2 : dollar_generateSwitchNores_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("constructor", 1);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("var");
    static internal readonly IntegerTerm s7 = new IntegerTerm(1);
    static internal readonly SymbolTerm f8 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm s10 = SymbolTerm.makeSymbol("int");
    static internal readonly SymbolTerm s11 = SymbolTerm.makeSymbol("con");
    static internal readonly SymbolTerm s12 = SymbolTerm.makeSymbol("str");
    static internal readonly SymbolTerm s13 = SymbolTerm.makeSymbol("lis");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        Term[] h3 = {a2, s2};
        a5 = new StructureTerm(f1, h3);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        Term[] h5 = {a2};
        a9 = new StructureTerm(f4, h5);
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h9 = {a2, s6};
        a13 = new StructureTerm(f8, h9);
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a19 = engine.makeVariable();
        a20 = engine.makeVariable();
        a21 = engine.makeVariable();
        a22 = engine.makeVariable();
        a23 = engine.makeVariable();
        a24 = engine.makeVariable();
        a25 = engine.makeVariable();
        a26 = engine.makeVariable();
        p1 = new Predicates._C_3(a26, a21, a4, cont);
        p2 = new Predicates._C_3(a25, a19, a26, p1);
        p3 = new Predicates._C_3(a24, a17, a25, p2);
        p4 = new Predicates._C_3(a23, a15, a24, p3);
        p5 = new Predicates.dollar_generateStaticPred_5(a2, a11, a22, a7, s2, p4);
        p6 = new Predicates.dollar_genSwitchOnTermNores_10(a2, a11, a22, a12, a14, a16, a18, a20, a10, a23, p5);
        p7 = new Predicates.dollar_generateSw_7(a1, s13, a2, a11, a20, a21, s2, p6);
        p8 = new Predicates.dollar_generateSw_7(a1, s12, a2, a11, a18, a19, s2, p7);
        p9 = new Predicates.dollar_generateSw_7(a1, s11, a2, a11, a16, a17, s2, p8);
        p10 = new Predicates.dollar_generateSw_7(a1, s10, a2, a11, a14, a15, s2, p9);
        p11 = new Predicates.dollar_unify_2(a12, a13, p10);
        p12 = new Predicates.dollar_selectType_4(a1, s6, s7, a11, p11);
        p13 = new Predicates._C_3(a8, a9, a10, p12);
        p14 = new Predicates._C_3(a6, a7, a8, p13);
        return new Predicates._C_3(a3, a5, a6, p14);
    }
}
}

