/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateTries_4.cs
 * @procedure $generate_tries/4 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateTries_4 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly IntegerTerm s2 = new IntegerTerm(1);

    public Term arg1, arg2, arg3, arg4;

    public dollar_generateTries_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_generateTries_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_generateTries_6(a1, a5, a6, s2, a3, a4, cont);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$generate_tries(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

