/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompCall_5.cs
 * @procedure $precomp_call/5 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompCall_5 : Predicate {
    static internal readonly Predicate dollar_precompCall_5_1 = new Predicates.dollar_precompCall_5_1();
    static internal readonly Predicate dollar_precompCall_5_2 = new Predicates.dollar_precompCall_5_2();
    static internal readonly Predicate dollar_precompCall_5_sub_1 = new Predicates.dollar_precompCall_5_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_precompCall_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_precompCall_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_precompCall_5_1, dollar_precompCall_5_sub_1);
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$precomp_call(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_precompCall_5_sub_1 : dollar_precompCall_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_precompCall_5_2);
    }
}

sealed class dollar_precompCall_5_1 : dollar_precompCall_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a6 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a6 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a7 = ((ListTerm)a3).car;
            if ( !s1.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a7 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a7, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_precompCont_4(a6, a7, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_precompCall_5_2 : dollar_precompCall_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a8 = ((ListTerm)a3).car;
            a9 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_precompCall_5(a1, a7, a9, a10, a5, cont);
        return new Predicates.dollar_precompPut_5(a1, a6, a8, a4, a10, p1);
    }
}
}

