/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompRes_3.cs
 * @procedure $precomp_res/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompRes_3 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_precompRes_3_1 = new Predicates.dollar_precompRes_3_1();
    static internal readonly Predicate dollar_precompRes_3_2 = new Predicates.dollar_precompRes_3_2();
    static internal readonly Predicate dollar_precompRes_3_3 = new Predicates.dollar_precompRes_3_3();
    static internal readonly Predicate dollar_precompRes_3_var = new Predicates.dollar_precompRes_3_var();

    public Term arg1, arg2, arg3;

    public dollar_precompRes_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_precompRes_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_precompRes_3_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_precompRes_3_var,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$precomp_res(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_precompRes_3_var : dollar_precompRes_3 {
    static internal readonly Predicate dollar_precompRes_3_var_1 = new Predicates.dollar_precompRes_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_precompRes_3_1, dollar_precompRes_3_var_1);
    }
}

sealed class dollar_precompRes_3_var_1 : dollar_precompRes_3 {
    static internal readonly Predicate dollar_precompRes_3_var_2 = new Predicates.dollar_precompRes_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_precompRes_3_2, dollar_precompRes_3_var_2);
    }
}

sealed class dollar_precompRes_3_var_2 : dollar_precompRes_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_precompRes_3_3);
    }
}

sealed class dollar_precompRes_3_1 : dollar_precompRes_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("$more_imp");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_precompRes_3(a5, a7, a3, cont);
        p2 = new Predicates._C_3(a6, s2, a7, p1);
        p3 = new Predicates.dollar_precompRes_3(a4, a2, a6, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_precompRes_3_2 : dollar_precompRes_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("&", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_precompRes_3(a5, a6, a3, cont);
        p2 = new Predicates.dollar_precompRes_3(a4, a2, a6, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_precompRes_3_3 : dollar_precompRes_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("resource", 3);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$res", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("$add_res", 2);
    static internal readonly SymbolTerm f8 = SymbolTerm.makeSymbol("$closure", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
            a5 = args[1];
            a6 = args[2];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a4, a5, a6};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        Term[] h4 = {a8, a9};
        a12 = new StructureTerm(f3, h4);
        Term[] h5 = {a12, a7};
        a11 = new StructureTerm(f2, h5);
        a16 = new ListTerm(a10, s6);
        a15 = new ListTerm(a6, a16);
        a14 = new ListTerm(a5, a15);
        a13 = new ListTerm(a4, a14);
        a18 = engine.makeVariable();
        a20 = engine.makeVariable();
        a22 = engine.makeVariable();
        a24 = engine.makeVariable();
        a23 = new ListTerm(a24, s6);
        a21 = new ListTerm(a22, a23);
        a19 = new ListTerm(a20, a21);
        a17 = new ListTerm(a18, a19);
        Term[] h9 = {a10, a6};
        a26 = new StructureTerm(f8, h9);
        Term[] h10 = {a4, a26};
        a25 = new StructureTerm(f7, h10);
        p1 = new Predicates._C_3(a2, a25, a3, cont);
        p2 = new Predicates.dollar_compileResource_4(a18, a20, a22, a24, p1);
        p3 = new Predicates.dollar_copyTerm_2(a13, a17, p2);
        p4 = new Predicates.dollar_unify_2(a10, a11, p3);
        p5 = new Predicates.dollar_functor_3(a4, a8, a9, p4);
        return new Predicates.dollar_incResCounter_1(a7, p5);
    }
}
}

