/*
 * *** Please do not edit ! ***
 * @(#) dollar_treatDisj_3.cs
 * @procedure $treat_disj/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_treatDisj_3 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_treatDisj_3_1 = new Predicates.dollar_treatDisj_3_1();
    static internal readonly Predicate dollar_treatDisj_3_2 = new Predicates.dollar_treatDisj_3_2();
    static internal readonly Predicate dollar_treatDisj_3_var = new Predicates.dollar_treatDisj_3_var();

    public Term arg1, arg2, arg3;

    public dollar_treatDisj_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_treatDisj_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_treatDisj_3_var,
                                   dollar_fail_0,
                                   dollar_treatDisj_3_1,
                                   dollar_fail_0,
                                   dollar_treatDisj_3_2
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$treat_disj(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_treatDisj_3_var : dollar_treatDisj_3 {
    static internal readonly Predicate dollar_treatDisj_3_var_1 = new Predicates.dollar_treatDisj_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_treatDisj_3_1, dollar_treatDisj_3_var_1);
    }
}

sealed class dollar_treatDisj_3_var_1 : dollar_treatDisj_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_treatDisj_3_2);
    }
}

sealed class dollar_treatDisj_3_1 : dollar_treatDisj_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a3, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_treatDisj_3_2 : dollar_treatDisj_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("disj", 4);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(";", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f1 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            a6 = args[0];
            a7 = args[1];
            a8 = args[2];
            a9 = args[3];
        } else if (a4.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a6, a7, a8, a9};
            if ( !a4.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f2 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a10 = args[0];
            a11 = args[1];
        } else if (a6.isVariable() ){
            a10 = engine.makeVariable();
            a11 = engine.makeVariable();
            Term[] args = {a10, a11};
            if ( !a6.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a10, a11};
        a12 = new StructureTerm(f2, h3);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = new ListTerm(a16, a15);
        Term[] h4 = {a10, a11};
        a18 = new StructureTerm(f2, h4);
        a19 = engine.makeVariable();
        p1 = new Predicates.dollar_treatDisj_3(a5, a19, a3, cont);
        p2 = new Predicates.dollar_makeDummyClauses_4(a18, a8, a2, a19, p1);
        p3 = new Predicates.eq_stop_stop_2(a8, a17, p2);
        p4 = new Predicates.dollar_makeDummyName_2(a7, a16, p3);
        p5 = new Predicates.dollar_intersectVars_3(a13, a14, a15, p4);
        p6 = new Predicates.dollar_variables_2(a9, a14, p5);
        return new Predicates.dollar_variables_2(a12, a13, p6);
    }
}
}

