/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeCsTo_String_3.cs
 * @procedure $write_cs_toString/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeCsTo_String_3 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(4);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("public override string ToString() {");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);
    static internal readonly IntegerTerm s5 = new IntegerTerm(8);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("return ");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("}");
    static internal readonly ListTerm s8 = new ListTerm(s7, s3);

    public Term arg1, arg2, arg3;

    public dollar_writeCsTo_String_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_writeCsTo_String_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = new ListTerm(s6, a5);
        p1 = new Predicates.dollar_writelnStream_3(a1, s1, s8, cont);
        p2 = new Predicates.dollar_writelnStream_3(a1, s5, a6, p1);
        p3 = new Predicates.dollar_writelnStream_3(a1, s1, s4, p2);
        p4 = new Predicates.dollar_wjTo_StringArgs_3(a4, a3, a5, p3);
        p5 = new Predicates.dollar_atomToString_2(a2, a4, p4);
        return new Predicates.dollar_nl_1(a1, p5);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$write_cs_toString(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

