/*
 * *** Please do not edit ! ***
 * @(#) dollar_assignFunctor_4.cs
 * @procedure $assign_functor/4 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assignFunctor_4 : Predicate {
    static internal readonly Predicate dollar_assignFunctor_4_1 = new Predicates.dollar_assignFunctor_4_1();
    static internal readonly Predicate dollar_assignFunctor_4_2 = new Predicates.dollar_assignFunctor_4_2();
    static internal readonly Predicate dollar_assignFunctor_4_sub_1 = new Predicates.dollar_assignFunctor_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_assignFunctor_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_assignFunctor_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_assignFunctor_4_1, dollar_assignFunctor_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$assign_functor(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_assignFunctor_4_sub_1 : dollar_assignFunctor_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assignFunctor_4_2);
    }
}

sealed class dollar_assignFunctor_4_1 : dollar_assignFunctor_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$f_n", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("f", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        Term[] h2 = {engine.makeVariable(), engine.makeVariable()};
        a6 = new StructureTerm(f1, h2);
        a7 = engine.makeVariable();
        Term[] h4 = {engine.makeVariable()};
        a8 = new StructureTerm(f3, h4);
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.dollar_unify_2(a2, a8, p1);
        p3 = new Predicates.dollar_nonvar_1(a7, p2);
        p4 = new Predicates.dollar_assignReg_5(a1, a2, a7, a3, a4, p3);
        p5 = new Predicates.dollar_unify_2(a1, a6, p4);
        return new Predicates.dollar_getLevel_1(a5, p5);
    }
}

sealed class dollar_assignFunctor_4_2 : dollar_assignFunctor_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$f_n", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("f", 1);
    static internal readonly IntegerTerm s6 = new IntegerTerm(1);
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("yes");
    static internal readonly ListTerm s8 = new ListTerm(s7, s3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {engine.makeVariable(), engine.makeVariable()};
        a5 = new StructureTerm(f1, h2);
        a7 = engine.makeVariable();
        a9 = engine.makeVariable();
        a11 = engine.makeVariable();
        a13 = engine.makeVariable();
        a12 = new ListTerm(a13, s3);
        a10 = new ListTerm(a11, a12);
        a8 = new ListTerm(a9, a10);
        a6 = new ListTerm(a7, a8);
        Term[] h5 = {a9};
        a14 = new StructureTerm(f4, h5);
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a19 = new ListTerm(a2, s8);
        a18 = new ListTerm(a1, a19);
        a17 = new ListTerm(a18, a13);
        a23 = new ListTerm(a16, s3);
        a22 = new ListTerm(a11, a23);
        a21 = new ListTerm(a15, a22);
        a20 = new ListTerm(a7, a21);
        p1 = new Predicates.dollar_unify_2(a4, a20, cont);
        p2 = new Predicates.dollar_unify_2(a16, a17, p1);
        p3 = new Predicates.dollar_plus_3(a9, s6, a15, p2);
        p4 = new Predicates.dollar_unify_2(a2, a14, p3);
        p5 = new Predicates.dollar_unify_2(a3, a6, p4);
        return new Predicates.dollar_unify_2(a1, a5, p5);
    }
}
}

