/*
 * *** Please do not edit ! ***
 * @(#) dollar_changeName_2.cs
 * @procedure $change_name/2 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_changeName_2 : Predicate {
    static internal readonly Predicate dollar_changeName_2_1 = new Predicates.dollar_changeName_2_1();
    static internal readonly Predicate dollar_changeName_2_2 = new Predicates.dollar_changeName_2_2();
    static internal readonly Predicate dollar_changeName_2_sub_1 = new Predicates.dollar_changeName_2_sub_1();

    public Term arg1, arg2;

    public dollar_changeName_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_changeName_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_changeName_2_1, dollar_changeName_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$change_name(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_changeName_2_sub_1 : dollar_changeName_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_changeName_2_2);
    }
}

sealed class dollar_changeName_2_1 : dollar_changeName_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a4 = new ListTerm(a5, a6);
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = new ListTerm(a9, a6);
        p1 = new Predicates.eq_stop_stop_2(a2, a10, cont);
        p2 = new Predicates.Name_2(a9, a8, p1);
        p3 = new Predicates.dollar_changeName0_2(a7, a8, p2);
        p4 = new Predicates.Name_2(a5, a7, p3);
        p5 = new Predicates.dollar_cut_1(a3, p4);
        p6 = new Predicates.dollar_atom_1(a5, p5);
        p7 = new Predicates.eq_stop_stop_2(a1, a4, p6);
        return new Predicates.dollar_getLevel_1(a3, p7);
    }
}

sealed class dollar_changeName_2_2 : dollar_changeName_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("Invalid Input!, Can not rename");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_nl_0(cont);
        return new Predicates.Write_1(s1, p1);
    }
}
}

