/*
 * *** Please do not edit ! ***
 * @(#) dollar_compChunk_5.cs
 * @procedure $comp_chunk/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compChunk_5 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_compChunk_5_1 = new Predicates.dollar_compChunk_5_1();
    static internal readonly Predicate dollar_compChunk_5_2 = new Predicates.dollar_compChunk_5_2();
    static internal readonly Predicate dollar_compChunk_5_3 = new Predicates.dollar_compChunk_5_3();
    static internal readonly Predicate dollar_compChunk_5_4 = new Predicates.dollar_compChunk_5_4();
    static internal readonly Predicate dollar_compChunk_5_lis = new Predicates.dollar_compChunk_5_lis();
    static internal readonly Predicate dollar_compChunk_5_var = new Predicates.dollar_compChunk_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_compChunk_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_compChunk_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compChunk_5_var,
                                   dollar_fail_0,
                                   dollar_compChunk_5_1,
                                   dollar_fail_0,
                                   dollar_compChunk_5_lis
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$comp_chunk(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_compChunk_5_var : dollar_compChunk_5 {
    static internal readonly Predicate dollar_compChunk_5_var_1 = new Predicates.dollar_compChunk_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compChunk_5_1, dollar_compChunk_5_var_1);
    }
}

sealed class dollar_compChunk_5_var_1 : dollar_compChunk_5 {
    static internal readonly Predicate dollar_compChunk_5_var_2 = new Predicates.dollar_compChunk_5_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compChunk_5_2, dollar_compChunk_5_var_2);
    }
}

sealed class dollar_compChunk_5_var_2 : dollar_compChunk_5 {
    static internal readonly Predicate dollar_compChunk_5_var_3 = new Predicates.dollar_compChunk_5_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compChunk_5_3, dollar_compChunk_5_var_3);
    }
}

sealed class dollar_compChunk_5_var_3 : dollar_compChunk_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compChunk_5_4);
    }
}

sealed class dollar_compChunk_5_lis : dollar_compChunk_5 {
    static internal readonly Predicate dollar_compChunk_5_lis_1 = new Predicates.dollar_compChunk_5_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compChunk_5_2, dollar_compChunk_5_lis_1);
    }
}

sealed class dollar_compChunk_5_lis_1 : dollar_compChunk_5 {
    static internal readonly Predicate dollar_compChunk_5_lis_2 = new Predicates.dollar_compChunk_5_lis_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compChunk_5_3, dollar_compChunk_5_lis_2);
    }
}

sealed class dollar_compChunk_5_lis_2 : dollar_compChunk_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compChunk_5_4);
    }
}

sealed class dollar_compChunk_5_1 : dollar_compChunk_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a5, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compChunk_5_2 : dollar_compChunk_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f1 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a8 = args[0];
            if ( !s2.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a6.isVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a8, s2};
            if ( !a6.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a8, s2};
        a9 = new StructureTerm(f1, h3);
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_compChunk_5(a7, a2, a3, a10, a5, cont);
        p2 = new Predicates._C_3(a4, a9, a10, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_compChunk_5_3 : dollar_compChunk_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f1 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a6.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a6.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a8, s2};
        a10 = new StructureTerm(f1, h3);
        a11 = engine.makeVariable();
        a12 = new ListTerm(a9, a7);
        p1 = new Predicates.dollar_compChunk_5(a12, a2, a3, a11, a5, cont);
        p2 = new Predicates._C_3(a4, a10, a11, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_compChunk_5_4 : dollar_compChunk_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_compChunk_5(a7, a8, a3, a9, a5, cont);
        p2 = new Predicates.dollar_compInstr_5(a6, a2, a8, a4, a9, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}
}

