/*
 * *** Please do not edit ! ***
 * @(#) dollar_compInstr_5.cs
 * @procedure $comp_instr/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compInstr_5 : Predicate {
    static internal readonly Predicate dollar_compInstr_5_1 = new Predicates.dollar_compInstr_5_1();
    static internal readonly Predicate dollar_compInstr_5_2 = new Predicates.dollar_compInstr_5_2();
    static internal readonly Predicate dollar_compInstr_5_3 = new Predicates.dollar_compInstr_5_3();
    static internal readonly Predicate dollar_compInstr_5_4 = new Predicates.dollar_compInstr_5_4();
    static internal readonly Predicate dollar_compInstr_5_5 = new Predicates.dollar_compInstr_5_5();
    static internal readonly Predicate dollar_compInstr_5_6 = new Predicates.dollar_compInstr_5_6();
    static internal readonly Predicate dollar_compInstr_5_var = new Predicates.dollar_compInstr_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_compInstr_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_compInstr_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compInstr_5_var,
                                   dollar_compInstr_5_6,
                                   dollar_compInstr_5_6,
                                   dollar_compInstr_5_var,
                                   dollar_compInstr_5_6
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$comp_instr(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_compInstr_5_var : dollar_compInstr_5 {
    static internal readonly Predicate dollar_compInstr_5_var_1 = new Predicates.dollar_compInstr_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compInstr_5_1, dollar_compInstr_5_var_1);
    }
}

sealed class dollar_compInstr_5_var_1 : dollar_compInstr_5 {
    static internal readonly Predicate dollar_compInstr_5_var_2 = new Predicates.dollar_compInstr_5_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compInstr_5_2, dollar_compInstr_5_var_2);
    }
}

sealed class dollar_compInstr_5_var_2 : dollar_compInstr_5 {
    static internal readonly Predicate dollar_compInstr_5_var_3 = new Predicates.dollar_compInstr_5_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compInstr_5_3, dollar_compInstr_5_var_3);
    }
}

sealed class dollar_compInstr_5_var_3 : dollar_compInstr_5 {
    static internal readonly Predicate dollar_compInstr_5_var_4 = new Predicates.dollar_compInstr_5_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compInstr_5_4, dollar_compInstr_5_var_4);
    }
}

sealed class dollar_compInstr_5_var_4 : dollar_compInstr_5 {
    static internal readonly Predicate dollar_compInstr_5_var_5 = new Predicates.dollar_compInstr_5_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compInstr_5_5, dollar_compInstr_5_var_5);
    }
}

sealed class dollar_compInstr_5_var_5 : dollar_compInstr_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compInstr_5_6);
    }
}

sealed class dollar_compInstr_5_1 : dollar_compInstr_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("get", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_genGet_6(a6, a7, a2, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compInstr_5_2 : dollar_compInstr_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_genPut_6(a6, a7, a2, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compInstr_5_3 : dollar_compInstr_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put_cont", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_genPutCont_6(a6, a7, a2, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compInstr_5_4 : dollar_compInstr_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put_free_vars", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_genPutFreeVars_6(a6, a7, a2, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compInstr_5_5 : dollar_compInstr_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put_closure", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
            a8 = args[2];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            Term[] args = {a6, a7, a8};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_genPutClosure_7(a6, a7, a8, a2, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compInstr_5_6 : dollar_compInstr_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates._C_3(a4, a1, a5, cont);
    }
}
}

