/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileAllPredicates_0.cs
 * @procedure $compile_all_predicates/0 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileAllPredicates_0 : Predicate {
    static internal readonly Predicate dollar_compileAllPredicates_0_1 = new Predicates.dollar_compileAllPredicates_0_1();
    static internal readonly Predicate dollar_compileAllPredicates_0_2 = new Predicates.dollar_compileAllPredicates_0_2();
    static internal readonly Predicate dollar_compileAllPredicates_0_sub_1 = new Predicates.dollar_compileAllPredicates_0_sub_1();

    public dollar_compileAllPredicates_0(Predicate cont) {
        this.cont = cont;
    }

    public dollar_compileAllPredicates_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_compileAllPredicates_0_1, dollar_compileAllPredicates_0_sub_1);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "$compile_all_predicates";
    }
}

sealed class dollar_compileAllPredicates_0_sub_1 : dollar_compileAllPredicates_0 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compileAllPredicates_0_2);
    }
}

sealed class dollar_compileAllPredicates_0_1 : dollar_compileAllPredicates_0 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$internal_predicates", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("/", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        Term[] h2 = {a2, a3};
        a1 = new StructureTerm(f1, h2);
        a4 = engine.makeVariable();
        Term[] h5 = {a2, a3};
        a5 = new StructureTerm(f4, h5);
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_dummyPlcs__1_2(a6, a7, p1);
        p3 = new Predicates.dollar_nl_1(a7, p2);
        p4 = new Predicates.dollar_generateCs_2(a7, a4, p3);
        p5 = new Predicates.dollar_dummyPlcs__0_6(a2, a3, a6, a7, engine.makeVariable(), engine.makeVariable(), p4);
        p6 = new Predicates.dollar_createClassName_2(a5, engine.makeVariable(), p5);
        p7 = new Predicates.dollar_compilePredicate_4(a2, a3, a4, s3, p6);
        return new Predicates.Clause_2(a1, engine.makeVariable(), p7);
    }
}

sealed class dollar_compileAllPredicates_0_2 : dollar_compileAllPredicates_0 {

    public override Predicate exec( Prolog engine ) {
        return engine.cont;
    }
}
}

