/*
 * *** Please do not edit ! ***
 * @(#) dollar_compilePredWithRes_4.cs
 * @procedure $compile_pred_with_res/4 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compilePredWithRes_4 : Predicate {
    static internal readonly Predicate dollar_compilePredWithRes_4_1 = new Predicates.dollar_compilePredWithRes_4_1();
    static internal readonly Predicate dollar_compilePredWithRes_4_2 = new Predicates.dollar_compilePredWithRes_4_2();
    static internal readonly Predicate dollar_compilePredWithRes_4_3 = new Predicates.dollar_compilePredWithRes_4_3();
    static internal readonly Predicate dollar_compilePredWithRes_4_con = new Predicates.dollar_compilePredWithRes_4_con();
    static internal readonly Predicate dollar_compilePredWithRes_4_lis = new Predicates.dollar_compilePredWithRes_4_lis();
    static internal readonly Predicate dollar_compilePredWithRes_4_var = new Predicates.dollar_compilePredWithRes_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_compilePredWithRes_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_compilePredWithRes_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compilePredWithRes_4_var,
                                   dollar_compilePredWithRes_4_3,
                                   dollar_compilePredWithRes_4_con,
                                   dollar_compilePredWithRes_4_3,
                                   dollar_compilePredWithRes_4_lis
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$compile_pred_with_res(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_compilePredWithRes_4_var : dollar_compilePredWithRes_4 {
    static internal readonly Predicate dollar_compilePredWithRes_4_var_1 = new Predicates.dollar_compilePredWithRes_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePredWithRes_4_1, dollar_compilePredWithRes_4_var_1);
    }
}

sealed class dollar_compilePredWithRes_4_var_1 : dollar_compilePredWithRes_4 {
    static internal readonly Predicate dollar_compilePredWithRes_4_var_2 = new Predicates.dollar_compilePredWithRes_4_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compilePredWithRes_4_2, dollar_compilePredWithRes_4_var_2);
    }
}

sealed class dollar_compilePredWithRes_4_var_2 : dollar_compilePredWithRes_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePredWithRes_4_3);
    }
}

sealed class dollar_compilePredWithRes_4_con : dollar_compilePredWithRes_4 {
    static internal readonly Predicate dollar_compilePredWithRes_4_con_1 = new Predicates.dollar_compilePredWithRes_4_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePredWithRes_4_1, dollar_compilePredWithRes_4_con_1);
    }
}

sealed class dollar_compilePredWithRes_4_con_1 : dollar_compilePredWithRes_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePredWithRes_4_3);
    }
}

sealed class dollar_compilePredWithRes_4_lis : dollar_compilePredWithRes_4 {
    static internal readonly Predicate dollar_compilePredWithRes_4_lis_1 = new Predicates.dollar_compilePredWithRes_4_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePredWithRes_4_2, dollar_compilePredWithRes_4_lis_1);
    }
}

sealed class dollar_compilePredWithRes_4_lis_1 : dollar_compilePredWithRes_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePredWithRes_4_3);
    }
}

sealed class dollar_compilePredWithRes_4_1 : dollar_compilePredWithRes_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_generateRootWithRes_4(s1, a2, a3, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compilePredWithRes_4_2 : dollar_compilePredWithRes_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = new ListTerm(a5, s1);
        a7 = engine.makeVariable();
        a8 = new ListTerm(a5, s1);
        p1 = new Predicates.dollar_compileOnePred_4(a8, a2, a7, a4, cont);
        p2 = new Predicates.dollar_generateRootWithRes_4(a6, a2, a3, a7, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_compilePredWithRes_4_3 : dollar_compilePredWithRes_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_compilePred0_5(a1, a2, s1, a5, a4, cont);
        return new Predicates.dollar_generateRootWithRes_4(a1, a2, a3, a5, p1);
    }
}
}

