/*
 * *** Please do not edit ! ***
 * @(#) dollar_compilePred0_5.cs
 * @procedure $compile_pred0/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compilePred0_5 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_compilePred0_5_1 = new Predicates.dollar_compilePred0_5_1();
    static internal readonly Predicate dollar_compilePred0_5_2 = new Predicates.dollar_compilePred0_5_2();
    static internal readonly Predicate dollar_compilePred0_5_var = new Predicates.dollar_compilePred0_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_compilePred0_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_compilePred0_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compilePred0_5_var,
                                   dollar_fail_0,
                                   dollar_compilePred0_5_1,
                                   dollar_fail_0,
                                   dollar_compilePred0_5_2
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$compile_pred0(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_compilePred0_5_var : dollar_compilePred0_5 {
    static internal readonly Predicate dollar_compilePred0_5_var_1 = new Predicates.dollar_compilePred0_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePred0_5_1, dollar_compilePred0_5_var_1);
    }
}

sealed class dollar_compilePred0_5_var_1 : dollar_compilePred0_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePred0_5_2);
    }
}

sealed class dollar_compilePred0_5_1 : dollar_compilePred0_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a5, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compilePred0_5_2 : dollar_compilePred0_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("comment", 1);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f8 = SymbolTerm.makeSymbol("exec_method", 4);
    static internal readonly SymbolTerm s9 = SymbolTerm.makeSymbol("normal");
    static internal readonly IntegerTerm s11 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        Term[] h2 = {a8};
        a9 = new StructureTerm(f1, h2);
        a10 = engine.makeVariable();
        Term[] h5 = {a2, a3};
        a12 = new StructureTerm(f4, h5);
        Term[] h7 = {a12, s6};
        a11 = new StructureTerm(f3, h7);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a20 = engine.makeVariable();
        a22 = engine.makeVariable();
        a21 = new ListTerm(a22, s6);
        a19 = new ListTerm(a20, a21);
        a23 = engine.makeVariable();
        Term[] h10 = {a2, a19, s9, a23};
        a18 = new StructureTerm(f8, h10);
        a24 = engine.makeVariable();
        a25 = engine.makeVariable();
        a28 = new ListTerm(a22, s6);
        a27 = new ListTerm(engine.makeVariable(), a28);
        a26 = new ListTerm(a20, a27);
        a29 = engine.makeVariable();
        p1 = new Predicates.dollar_compilePred0_5(a7, a2, a29, a24, a5, cont);
        p2 = new Predicates.dollar_plus_3(a3, s11, a29, p1);
        p3 = new Predicates.dollar_unify_2(a25, a26, p2);
        p4 = new Predicates.dollar_gatherStaticResPred_2(a23, a14, p3);
        p5 = new Predicates.dollar_compileClause_5(a6, a16, a25, a23, s6, p4);
        p6 = new Predicates._C_3(a17, a18, a24, p5);
        p7 = new Predicates._C_3(a15, a16, a17, p6);
        p8 = new Predicates._C_3(a13, a14, a15, p7);
        p9 = new Predicates._C_3(a10, a11, a13, p8);
        p10 = new Predicates._C_3(a4, a9, a10, p9);
        return new Predicates.dollar_copyTerm_2(a6, a8, p10);
    }
}
}

