/*
 * *** Please do not edit ! ***
 * @(#) dollar_compilePred_4.cs
 * @procedure $compile_pred/4 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compilePred_4 : Predicate {
    static internal readonly Predicate dollar_compilePred_4_1 = new Predicates.dollar_compilePred_4_1();
    static internal readonly Predicate dollar_compilePred_4_2 = new Predicates.dollar_compilePred_4_2();
    static internal readonly Predicate dollar_compilePred_4_3 = new Predicates.dollar_compilePred_4_3();
    static internal readonly Predicate dollar_compilePred_4_con = new Predicates.dollar_compilePred_4_con();
    static internal readonly Predicate dollar_compilePred_4_lis = new Predicates.dollar_compilePred_4_lis();
    static internal readonly Predicate dollar_compilePred_4_var = new Predicates.dollar_compilePred_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_compilePred_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_compilePred_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compilePred_4_var,
                                   dollar_compilePred_4_3,
                                   dollar_compilePred_4_con,
                                   dollar_compilePred_4_3,
                                   dollar_compilePred_4_lis
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$compile_pred(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_compilePred_4_var : dollar_compilePred_4 {
    static internal readonly Predicate dollar_compilePred_4_var_1 = new Predicates.dollar_compilePred_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePred_4_1, dollar_compilePred_4_var_1);
    }
}

sealed class dollar_compilePred_4_var_1 : dollar_compilePred_4 {
    static internal readonly Predicate dollar_compilePred_4_var_2 = new Predicates.dollar_compilePred_4_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_compilePred_4_2, dollar_compilePred_4_var_2);
    }
}

sealed class dollar_compilePred_4_var_2 : dollar_compilePred_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePred_4_3);
    }
}

sealed class dollar_compilePred_4_con : dollar_compilePred_4 {
    static internal readonly Predicate dollar_compilePred_4_con_1 = new Predicates.dollar_compilePred_4_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePred_4_1, dollar_compilePred_4_con_1);
    }
}

sealed class dollar_compilePred_4_con_1 : dollar_compilePred_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePred_4_3);
    }
}

sealed class dollar_compilePred_4_lis : dollar_compilePred_4 {
    static internal readonly Predicate dollar_compilePred_4_lis_1 = new Predicates.dollar_compilePred_4_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compilePred_4_2, dollar_compilePred_4_lis_1);
    }
}

sealed class dollar_compilePred_4_lis_1 : dollar_compilePred_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compilePred_4_3);
    }
}

sealed class dollar_compilePred_4_1 : dollar_compilePred_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compilePred_4_2 : dollar_compilePred_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("comment", 1);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("constructor", 1);
    static internal readonly SymbolTerm f8 = SymbolTerm.makeSymbol("exec_method", 4);
    static internal readonly SymbolTerm s9 = SymbolTerm.makeSymbol("root_one_nores");
    static internal readonly SymbolTerm f11 = SymbolTerm.makeSymbol("extra_methods", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        Term[] h3 = {a6};
        a7 = new StructureTerm(f2, h3);
        a8 = engine.makeVariable();
        Term[] h5 = {a2, s1};
        a9 = new StructureTerm(f4, h5);
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        Term[] h7 = {a2};
        a15 = new StructureTerm(f6, h7);
        a16 = engine.makeVariable();
        a19 = engine.makeVariable();
        a21 = engine.makeVariable();
        a20 = new ListTerm(a21, s1);
        a18 = new ListTerm(a19, a20);
        a22 = engine.makeVariable();
        Term[] h10 = {a2, a18, s9, a22};
        a17 = new StructureTerm(f8, h10);
        a23 = engine.makeVariable();
        Term[] h12 = {a2};
        a24 = new StructureTerm(f11, h12);
        a25 = engine.makeVariable();
        a28 = new ListTerm(a21, s1);
        a27 = new ListTerm(engine.makeVariable(), a28);
        a26 = new ListTerm(a19, a27);
        p1 = new Predicates.dollar_unify_2(a25, a26, cont);
        p2 = new Predicates.dollar_gatherStaticResPred_2(a22, a11, p1);
        p3 = new Predicates.dollar_compileClause_5(a5, a13, a25, a22, s1, p2);
        p4 = new Predicates._C_3(a23, a24, a4, p3);
        p5 = new Predicates._C_3(a16, a17, a23, p4);
        p6 = new Predicates._C_3(a14, a15, a16, p5);
        p7 = new Predicates._C_3(a12, a13, a14, p6);
        p8 = new Predicates._C_3(a10, a11, a12, p7);
        p9 = new Predicates._C_3(a8, a9, a10, p8);
        p10 = new Predicates._C_3(a3, a7, a8, p9);
        p11 = new Predicates.dollar_copyTerm_2(a5, a6, p10);
        return new Predicates.dollar_neckCut_0(p11);
    }
}

sealed class dollar_compilePred_4_3 : dollar_compilePred_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_compilePred0_5(a1, a2, s1, a5, a4, cont);
        return new Predicates.dollar_generateSwitchNores_4(a1, a2, a3, a5, p1);
    }
}
}

