/*
 * *** Please do not edit ! ***
 * @(#) dollar_constants_1.cs
 * @procedure $constants/1 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_constants_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("+");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("-");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("*");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("/");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("\\");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("^");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("<");
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol(">");
    static internal readonly SymbolTerm s9 = SymbolTerm.makeSymbol("=");
    static internal readonly SymbolTerm s10 = SymbolTerm.makeSymbol("`");
    static internal readonly SymbolTerm s11 = SymbolTerm.makeSymbol("~");
    static internal readonly SymbolTerm s12 = SymbolTerm.makeSymbol(":");
    static internal readonly SymbolTerm s13 = SymbolTerm.makeSymbol(".");
    static internal readonly SymbolTerm s14 = SymbolTerm.makeSymbol("?");
    static internal readonly SymbolTerm s15 = SymbolTerm.makeSymbol("@");
    static internal readonly SymbolTerm s16 = SymbolTerm.makeSymbol("#");
    static internal readonly SymbolTerm s17 = SymbolTerm.makeSymbol("&");
    static internal readonly SymbolTerm s18 = SymbolTerm.makeSymbol(";");
    static internal readonly SymbolTerm s19 = SymbolTerm.makeSymbol("!");
    static internal readonly SymbolTerm s20 = SymbolTerm.makeSymbol(",");
    static internal readonly SymbolTerm s21 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s22 = new ListTerm(s20, s21);
    static internal readonly ListTerm s23 = new ListTerm(s19, s22);
    static internal readonly ListTerm s24 = new ListTerm(s18, s23);
    static internal readonly ListTerm s25 = new ListTerm(s17, s24);
    static internal readonly ListTerm s26 = new ListTerm(s16, s25);
    static internal readonly ListTerm s27 = new ListTerm(s15, s26);
    static internal readonly ListTerm s28 = new ListTerm(s14, s27);
    static internal readonly ListTerm s29 = new ListTerm(s13, s28);
    static internal readonly ListTerm s30 = new ListTerm(s12, s29);
    static internal readonly ListTerm s31 = new ListTerm(s11, s30);
    static internal readonly ListTerm s32 = new ListTerm(s10, s31);
    static internal readonly ListTerm s33 = new ListTerm(s9, s32);
    static internal readonly ListTerm s34 = new ListTerm(s8, s33);
    static internal readonly ListTerm s35 = new ListTerm(s7, s34);
    static internal readonly ListTerm s36 = new ListTerm(s6, s35);
    static internal readonly ListTerm s37 = new ListTerm(s5, s36);
    static internal readonly ListTerm s38 = new ListTerm(s4, s37);
    static internal readonly ListTerm s39 = new ListTerm(s3, s38);
    static internal readonly ListTerm s40 = new ListTerm(s2, s39);
    static internal readonly ListTerm s41 = new ListTerm(s1, s40);

    public Term arg1;

    public dollar_constants_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_constants_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1;
        a1 = arg1.dereference();

        if ( !s41.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$constants(" + arg1 + ")";
    }
}
}

