/*
 * *** Please do not edit ! ***
 * @(#) dollar_createClassName_2.cs
 * @procedure $create_class_name/2 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_createClassName_2 : Predicate {
    static internal readonly Predicate dollar_createClassName_2_1 = new Predicates.dollar_createClassName_2_1();
    static internal readonly Predicate dollar_createClassName_2_2 = new Predicates.dollar_createClassName_2_2();
    static internal readonly Predicate dollar_createClassName_2_sub_1 = new Predicates.dollar_createClassName_2_sub_1();

    public Term arg1, arg2;

    public dollar_createClassName_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_createClassName_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_createClassName_2_1, dollar_createClassName_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$create_class_name(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_createClassName_2_sub_1 : dollar_createClassName_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_createClassName_2_2);
    }
}

sealed class dollar_createClassName_2_1 : dollar_createClassName_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$res", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("resource_");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("_");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        Term[] h3 = {a6, a7};
        a5 = new StructureTerm(f2, h3);
        a8 = engine.makeVariable();
        Term[] h4 = {a5, a8};
        a4 = new StructureTerm(f1, h4);
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a19 = new ListTerm(a7, s7);
        a18 = new ListTerm(s6, a19);
        a17 = new ListTerm(a10, a18);
        a16 = new ListTerm(s6, a17);
        a15 = new ListTerm(a11, a16);
        a14 = new ListTerm(s6, a15);
        a13 = new ListTerm(a8, a14);
        a12 = new ListTerm(s5, a13);
        p1 = new Predicates.dollar_listToString_2(a12, a2, cont);
        p2 = new Predicates.dollar_changeName_2(a9, a11, p1);
        p3 = new Predicates.dollar_changeName_2(a6, a10, p2);
        p4 = new Predicates.dollar_fileName_1(a9, p3);
        p5 = new Predicates.dollar_cut_1(a3, p4);
        p6 = new Predicates.dollar_unify_2(a1, a4, p5);
        return new Predicates.dollar_getLevel_1(a3, p6);
    }
}

sealed class dollar_createClassName_2_2 : dollar_createClassName_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = new ListTerm(a3, s1);
        p1 = new Predicates.dollar_listToString_2(a4, a2, cont);
        return new Predicates.dollar_createPredName_2(a1, a3, p1);
    }
}
}

