/*
 * *** Please do not edit ! ***
 * @(#) dollar_extractDisj_5.cs
 * @procedure $extract_disj/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_extractDisj_5 : Predicate {
    static internal readonly Predicate dollar_extractDisj_5_1 = new Predicates.dollar_extractDisj_5_1();
    static internal readonly Predicate dollar_extractDisj_5_2 = new Predicates.dollar_extractDisj_5_2();
    static internal readonly Predicate dollar_extractDisj_5_3 = new Predicates.dollar_extractDisj_5_3();
    static internal readonly Predicate dollar_extractDisj_5_4 = new Predicates.dollar_extractDisj_5_4();
    static internal readonly Predicate dollar_extractDisj_5_5 = new Predicates.dollar_extractDisj_5_5();
    static internal readonly Predicate dollar_extractDisj_5_6 = new Predicates.dollar_extractDisj_5_6();
    static internal readonly Predicate dollar_extractDisj_5_7 = new Predicates.dollar_extractDisj_5_7();
    static internal readonly Predicate dollar_extractDisj_5_con = new Predicates.dollar_extractDisj_5_con();
    static internal readonly Predicate dollar_extractDisj_5_int = new Predicates.dollar_extractDisj_5_int();
    static internal readonly Predicate dollar_extractDisj_5_lis = new Predicates.dollar_extractDisj_5_lis();
    static internal readonly Predicate dollar_extractDisj_5_var = new Predicates.dollar_extractDisj_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_extractDisj_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_extractDisj_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_extractDisj_5_var,
                                   dollar_extractDisj_5_int,
                                   dollar_extractDisj_5_con,
                                   dollar_extractDisj_5_var,
                                   dollar_extractDisj_5_lis
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$extract_disj(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_extractDisj_5_var : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_var_1 = new Predicates.dollar_extractDisj_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_extractDisj_5_1, dollar_extractDisj_5_var_1);
    }
}

sealed class dollar_extractDisj_5_var_1 : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_var_2 = new Predicates.dollar_extractDisj_5_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_extractDisj_5_2, dollar_extractDisj_5_var_2);
    }
}

sealed class dollar_extractDisj_5_var_2 : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_var_3 = new Predicates.dollar_extractDisj_5_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_extractDisj_5_3, dollar_extractDisj_5_var_3);
    }
}

sealed class dollar_extractDisj_5_var_3 : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_var_4 = new Predicates.dollar_extractDisj_5_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_extractDisj_5_4, dollar_extractDisj_5_var_4);
    }
}

sealed class dollar_extractDisj_5_var_4 : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_var_5 = new Predicates.dollar_extractDisj_5_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_extractDisj_5_5, dollar_extractDisj_5_var_5);
    }
}

sealed class dollar_extractDisj_5_var_5 : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_var_6 = new Predicates.dollar_extractDisj_5_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_extractDisj_5_6, dollar_extractDisj_5_var_6);
    }
}

sealed class dollar_extractDisj_5_var_6 : dollar_extractDisj_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_extractDisj_5_7);
    }
}

sealed class dollar_extractDisj_5_int : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_int_1 = new Predicates.dollar_extractDisj_5_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_extractDisj_5_6, dollar_extractDisj_5_int_1);
    }
}

sealed class dollar_extractDisj_5_int_1 : dollar_extractDisj_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_extractDisj_5_7);
    }
}

sealed class dollar_extractDisj_5_con : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_con_1 = new Predicates.dollar_extractDisj_5_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_extractDisj_5_6, dollar_extractDisj_5_con_1);
    }
}

sealed class dollar_extractDisj_5_con_1 : dollar_extractDisj_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_extractDisj_5_7);
    }
}

sealed class dollar_extractDisj_5_lis : dollar_extractDisj_5 {
    static internal readonly Predicate dollar_extractDisj_5_lis_1 = new Predicates.dollar_extractDisj_5_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_extractDisj_5_6, dollar_extractDisj_5_lis_1);
    }
}

sealed class dollar_extractDisj_5_lis_1 : dollar_extractDisj_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_extractDisj_5_7);
    }
}

sealed class dollar_extractDisj_5_1 : dollar_extractDisj_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("&", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a2.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_extractDisj_5(a7, a9, a3, a10, a5, cont);
        p2 = new Predicates.dollar_extractDisj_5(a6, a8, a3, a4, a10, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_extractDisj_5_2 : dollar_extractDisj_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a2.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_extractDisj_5(a7, a9, a3, a10, a5, cont);
        p2 = new Predicates.dollar_extractDisj_5(a6, a8, a3, a4, a10, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_extractDisj_5_3 : dollar_extractDisj_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("-<>", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            if ( !a6.unify(args[0],  engine.trail) )
                return engine.fail();
            a8 = args[1];
        } else if (a2.isVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a6, a8};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_extractDisj_5(a7, a8, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_extractDisj_5_4 : dollar_extractDisj_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=>", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
            a7 = args[1];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            Term[] args = {a6, a7};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            if ( !a6.unify(args[0],  engine.trail) )
                return engine.fail();
            a8 = args[1];
        } else if (a2.isVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a6, a8};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_extractDisj_5(a7, a8, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_extractDisj_5_5 : dollar_extractDisj_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("!", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a6 = args[0];
        } else if (a1.isVariable() ){
            a6 = engine.makeVariable();
            Term[] args = {a6};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a7 = args[0];
        } else if (a2.isVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {a7};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_extractDisj_5(a6, a7, a3, a4, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_extractDisj_5_6 : dollar_extractDisj_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("disj", 4);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$dummy_counter", 1);
    static internal readonly IntegerTerm s5 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        Term[] h2 = {a7, a8, a2, a3};
        a9 = new StructureTerm(f1, h2);
        Term[] h4 = {engine.makeVariable()};
        a10 = new StructureTerm(f3, h4);
        a11 = engine.makeVariable();
        Term[] h6 = {a11};
        a12 = new StructureTerm(f3, h6);
        p1 = new Predicates.Assert_1(a12, cont);
        p2 = new Predicates.dollar_plus_3(a8, s5, a11, p1);
        p3 = new Predicates.Retract_1(a10, p2);
        p4 = new Predicates._C_3(a4, a9, a5, p3);
        p5 = new Predicates.dollar_dummyCounter_1(a8, p4);
        p6 = new Predicates.dollar_cut_1(a6, p5);
        p7 = new Predicates.dollar_isDisj_2(a1, a7, p6);
        return new Predicates.dollar_getLevel_1(a6, p7);
    }
}

sealed class dollar_extractDisj_5_7 : dollar_extractDisj_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !a1.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a5, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}
}

