/*
 * *** Please do not edit ! ***
 * @(#) dollar_genPutClosure_7.cs
 * @procedure $gen_put_closure/7 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genPutClosure_7 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("put_closure", 3);

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_genPutClosure_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_genPutClosure_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();
        a5 = arg5.dereference();
        a6 = arg6.dereference();
        a7 = arg7.dereference();

        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        Term[] h3 = {a1, a2, a8};
        a10 = new StructureTerm(f2, h3);
        p1 = new Predicates._C_3(a6, a10, a7, cont);
        p2 = new Predicates.dollar_unify_2(a3, a8, p1);
        p3 = new Predicates.dollar_unify_2(a9, s1, p2);
        p4 = new Predicates.dollar_assignReg_5(engine.makeVariable(), a8, a9, a4, a5, p3);
        return new Predicates.dollar_neckCut_0(p4);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$gen_put_closure(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}
}

