/*
 * *** Please do not edit ! ***
 * @(#) dollar_genStaticArgs_8.cs
 * @procedure $gen_static_args/8 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genStaticArgs_8 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_genStaticArgs_8_1 = new Predicates.dollar_genStaticArgs_8_1();
    static internal readonly Predicate dollar_genStaticArgs_8_2 = new Predicates.dollar_genStaticArgs_8_2();
    static internal readonly Predicate dollar_genStaticArgs_8_3 = new Predicates.dollar_genStaticArgs_8_3();
    static internal readonly Predicate dollar_genStaticArgs_8_lis = new Predicates.dollar_genStaticArgs_8_lis();
    static internal readonly Predicate dollar_genStaticArgs_8_var = new Predicates.dollar_genStaticArgs_8_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8;

    public dollar_genStaticArgs_8(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Term a8, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        arg8 = a8; 
        this.cont = cont;
    }

    public dollar_genStaticArgs_8(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        arg8 = args[7]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.aregs[8] = arg8;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_genStaticArgs_8_var,
                                   dollar_fail_0,
                                   dollar_genStaticArgs_8_1,
                                   dollar_fail_0,
                                   dollar_genStaticArgs_8_lis
                                   );
    }

    public override int arity() { return 8; }

    public override string ToString() {
        return "$gen_static_args(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ", " + arg8 + ")";
    }
}

sealed class dollar_genStaticArgs_8_var : dollar_genStaticArgs_8 {
    static internal readonly Predicate dollar_genStaticArgs_8_var_1 = new Predicates.dollar_genStaticArgs_8_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genStaticArgs_8_1, dollar_genStaticArgs_8_var_1);
    }
}

sealed class dollar_genStaticArgs_8_var_1 : dollar_genStaticArgs_8 {
    static internal readonly Predicate dollar_genStaticArgs_8_var_2 = new Predicates.dollar_genStaticArgs_8_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genStaticArgs_8_2, dollar_genStaticArgs_8_var_2);
    }
}

sealed class dollar_genStaticArgs_8_var_2 : dollar_genStaticArgs_8 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genStaticArgs_8_3);
    }
}

sealed class dollar_genStaticArgs_8_lis : dollar_genStaticArgs_8 {
    static internal readonly Predicate dollar_genStaticArgs_8_lis_1 = new Predicates.dollar_genStaticArgs_8_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genStaticArgs_8_2, dollar_genStaticArgs_8_lis_1);
    }
}

sealed class dollar_genStaticArgs_8_lis_1 : dollar_genStaticArgs_8 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genStaticArgs_8_3);
    }
}

sealed class dollar_genStaticArgs_8_1 : dollar_genStaticArgs_8 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        a8 = engine.aregs[8].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !a3.unify(a4, engine.trail) ) return engine.fail();
        if ( !a5.unify(a6, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a8, a7, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_genStaticArgs_8_2 : dollar_genStaticArgs_8 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        a8 = engine.aregs[8].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a9 = ((ListTerm)a1).car;
            a10 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a11 = ((ListTerm)a2).car;
            a12 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a11 = engine.makeVariable();
            a12 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a11, a12), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        Term[] h2 = {a9, a11};
        a15 = new StructureTerm(f1, h2);
        a16 = engine.makeVariable();
        p1 = new Predicates.dollar_genStaticArgs_8(a10, a12, a16, a4, a14, a6, a7, a8, cont);
        p2 = new Predicates.dollar_delete_3(a3, a15, a16, p1);
        p3 = new Predicates.dollar_cut_1(a13, p2);
        p4 = new Predicates.dollar_assignFunctor_4(a9, a11, a5, a14, p3);
        return new Predicates.dollar_getLevel_1(a13, p4);
    }
}

sealed class dollar_genStaticArgs_8_3 : dollar_genStaticArgs_8 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        a8 = engine.aregs[8].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a9 = ((ListTerm)a1).car;
            a10 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a11 = ((ListTerm)a2).car;
            a12 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a11 = engine.makeVariable();
            a12 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a11, a12), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a13 = engine.makeVariable();
        Term[] h3 = {a9, a11};
        a14 = new StructureTerm(f2, h3);
        a15 = engine.makeVariable();
        p1 = new Predicates.dollar_genStaticArgs_8(a10, a12, a15, a4, a13, a6, a7, a8, cont);
        p2 = new Predicates.dollar_delete_3(a3, a14, a15, p1);
        return new Predicates.dollar_assignReg_5(a9, a11, s1, a5, a13, p2);
    }
}
}

