/*
 * *** Please do not edit ! ***
 * @(#) dollar_genStaticTerms_5.cs
 * @procedure $gen_static_terms/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genStaticTerms_5 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_genStaticTerms_5_1 = new Predicates.dollar_genStaticTerms_5_1();
    static internal readonly Predicate dollar_genStaticTerms_5_2 = new Predicates.dollar_genStaticTerms_5_2();
    static internal readonly Predicate dollar_genStaticTerms_5_var = new Predicates.dollar_genStaticTerms_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_genStaticTerms_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_genStaticTerms_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_genStaticTerms_5_var,
                                   dollar_fail_0,
                                   dollar_genStaticTerms_5_1,
                                   dollar_fail_0,
                                   dollar_genStaticTerms_5_2
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$gen_static_terms(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_genStaticTerms_5_var : dollar_genStaticTerms_5 {
    static internal readonly Predicate dollar_genStaticTerms_5_var_1 = new Predicates.dollar_genStaticTerms_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genStaticTerms_5_1, dollar_genStaticTerms_5_var_1);
    }
}

sealed class dollar_genStaticTerms_5_var_1 : dollar_genStaticTerms_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genStaticTerms_5_2);
    }
}

sealed class dollar_genStaticTerms_5_1 : dollar_genStaticTerms_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a5, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_genStaticTerms_5_2 : dollar_genStaticTerms_5 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a6 = ((ListTerm)a1).car;
            a7 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_genStaticTerms_5(a8, a9, a3, a10, a5, cont);
        return new Predicates.dollar_genStatic_7(a6, a7, a8, a2, a9, a4, a10, p1);
    }
}
}

