/*
 * *** Please do not edit ! ***
 * @(#) dollar_genStatic_7.cs
 * @procedure $gen_static/7 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genStatic_7 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_genStatic_7_1 = new Predicates.dollar_genStatic_7_1();
    static internal readonly Predicate dollar_genStatic_7_2 = new Predicates.dollar_genStatic_7_2();
    static internal readonly Predicate dollar_genStatic_7_3 = new Predicates.dollar_genStatic_7_3();
    static internal readonly Predicate dollar_genStatic_7_4 = new Predicates.dollar_genStatic_7_4();
    static internal readonly Predicate dollar_genStatic_7_5 = new Predicates.dollar_genStatic_7_5();
    static internal readonly Predicate dollar_genStatic_7_6 = new Predicates.dollar_genStatic_7_6();
    static internal readonly Predicate dollar_genStatic_7_7 = new Predicates.dollar_genStatic_7_7();
    static internal readonly Predicate dollar_genStatic_7_var = new Predicates.dollar_genStatic_7_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_genStatic_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_genStatic_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_genStatic_7_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_genStatic_7_var,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$gen_static(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}

sealed class dollar_genStatic_7_var : dollar_genStatic_7 {
    static internal readonly Predicate dollar_genStatic_7_var_1 = new Predicates.dollar_genStatic_7_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genStatic_7_1, dollar_genStatic_7_var_1);
    }
}

sealed class dollar_genStatic_7_var_1 : dollar_genStatic_7 {
    static internal readonly Predicate dollar_genStatic_7_var_2 = new Predicates.dollar_genStatic_7_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genStatic_7_2, dollar_genStatic_7_var_2);
    }
}

sealed class dollar_genStatic_7_var_2 : dollar_genStatic_7 {
    static internal readonly Predicate dollar_genStatic_7_var_3 = new Predicates.dollar_genStatic_7_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genStatic_7_3, dollar_genStatic_7_var_3);
    }
}

sealed class dollar_genStatic_7_var_3 : dollar_genStatic_7 {
    static internal readonly Predicate dollar_genStatic_7_var_4 = new Predicates.dollar_genStatic_7_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genStatic_7_4, dollar_genStatic_7_var_4);
    }
}

sealed class dollar_genStatic_7_var_4 : dollar_genStatic_7 {
    static internal readonly Predicate dollar_genStatic_7_var_5 = new Predicates.dollar_genStatic_7_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genStatic_7_5, dollar_genStatic_7_var_5);
    }
}

sealed class dollar_genStatic_7_var_5 : dollar_genStatic_7 {
    static internal readonly Predicate dollar_genStatic_7_var_6 = new Predicates.dollar_genStatic_7_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genStatic_7_6, dollar_genStatic_7_var_6);
    }
}

sealed class dollar_genStatic_7_var_6 : dollar_genStatic_7 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genStatic_7_7);
    }
}

sealed class dollar_genStatic_7_1 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("should");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("not");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("be");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("an");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("unbound");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("variable");
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s9 = new ListTerm(s7, s8);
    static internal readonly ListTerm s10 = new ListTerm(s6, s9);
    static internal readonly ListTerm s11 = new ListTerm(s5, s10);
    static internal readonly ListTerm s12 = new ListTerm(s4, s11);
    static internal readonly ListTerm s13 = new ListTerm(s3, s12);
    static internal readonly ListTerm s14 = new ListTerm(s2, s13);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a8, engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a10 = new ListTerm(a8, s14);
        p1 = new Predicates.dollar_unify_2(a7, a6, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        p3 = new Predicates.dollar_message_1(a10, p2);
        p4 = new Predicates.dollar_cut_1(a9, p3);
        p5 = new Predicates.dollar_var_1(a8, p4);
        return new Predicates.dollar_getLevel_1(a9, p5);
    }
}

sealed class dollar_genStatic_7_2 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("floating");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("point");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("numbers");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("are");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("not");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("supported");
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s9 = new ListTerm(s7, s8);
    static internal readonly ListTerm s10 = new ListTerm(s6, s9);
    static internal readonly ListTerm s11 = new ListTerm(s5, s10);
    static internal readonly ListTerm s12 = new ListTerm(s4, s11);
    static internal readonly ListTerm s13 = new ListTerm(s3, s12);
    static internal readonly ListTerm s14 = new ListTerm(s2, s13);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a8, engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a7, a6, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        p3 = new Predicates.dollar_message_1(s14, p2);
        p4 = new Predicates.dollar_cut_1(a9, p3);
        p5 = new Predicates.Float_1(a8, p4);
        return new Predicates.dollar_getLevel_1(a9, p5);
    }
}

sealed class dollar_genStatic_7_3 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("put_static_int", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        if ( !a4.unify(a5, engine.trail) ) return engine.fail();
        a10 = engine.makeVariable();
        Term[] h3 = {a8, a9};
        a11 = new StructureTerm(f2, h3);
        p1 = new Predicates._C_3(a6, a11, a7, cont);
        p2 = new Predicates.dollar_cut_1(a10, p1);
        p3 = new Predicates.dollar_integer_1(a8, p2);
        return new Predicates.dollar_getLevel_1(a10, p3);
    }
}

sealed class dollar_genStatic_7_4 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("put_static_con", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        if ( !a4.unify(a5, engine.trail) ) return engine.fail();
        a10 = engine.makeVariable();
        Term[] h3 = {a8, a9};
        a11 = new StructureTerm(f2, h3);
        p1 = new Predicates._C_3(a6, a11, a7, cont);
        p2 = new Predicates.dollar_cut_1(a10, p1);
        p3 = new Predicates.dollar_atom_1(a8, p2);
        return new Predicates.dollar_getLevel_1(a10, p3);
    }
}

sealed class dollar_genStatic_7_5 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$f_n", 2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("put_static_con", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        if ( !a4.unify(a5, engine.trail) ) return engine.fail();
        a10 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        Term[] h3 = {a12, a13};
        a11 = new StructureTerm(f2, h3);
        Term[] h5 = {a12, a13, a9};
        a14 = new StructureTerm(f4, h5);
        p1 = new Predicates._C_3(a6, a14, a7, cont);
        p2 = new Predicates.dollar_cut_1(a10, p1);
        p3 = new Predicates.dollar_unify_2(a8, a11, p2);
        p4 = new Predicates.Ground_1(a8, p3);
        return new Predicates.dollar_getLevel_1(a10, p4);
    }
}

sealed class dollar_genStatic_7_6 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("put_static_list", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a11 = new ListTerm(a12, a13);
        a15 = new ListTerm(a13, s2);
        a14 = new ListTerm(a12, a15);
        a17 = engine.makeVariable();
        a19 = engine.makeVariable();
        a18 = new ListTerm(a19, s2);
        a16 = new ListTerm(a17, a18);
        a20 = engine.makeVariable();
        Term[] h4 = {a17, a19, a9};
        a21 = new StructureTerm(f3, h4);
        p1 = new Predicates._C_3(a20, a21, a7, cont);
        p2 = new Predicates.dollar_genStaticArgs_8(a14, a16, a2, a3, a4, a5, a6, a20, p1);
        p3 = new Predicates.dollar_cut_1(a10, p2);
        p4 = new Predicates.dollar_unify_2(a8, a11, p3);
        return new Predicates.dollar_getLevel_1(a10, p4);
    }
}

sealed class dollar_genStatic_7_7 : dollar_genStatic_7 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$f_n", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("put_static_str_args", 2);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("h", 1);
    static internal readonly SymbolTerm f9 = SymbolTerm.makeSymbol("put_static_str", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29, a30, a31, a32, a33;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a8 = args[0];
            a9 = args[1];
        } else if (a1.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            Term[] args = {a8, a9};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a10 = new ListTerm(a11, a12);
        a13 = engine.makeVariable();
        Term[] h3 = {a11, a13};
        a15 = new StructureTerm(f2, h3);
        a14 = new ListTerm(a15, a12);
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a16 = new ListTerm(a17, a18);
        a19 = engine.makeVariable();
        a20 = engine.makeVariable();
        a22 = engine.makeVariable();
        a24 = engine.makeVariable();
        a25 = engine.makeVariable();
        a23 = new ListTerm(a24, a25);
        a21 = new ListTerm(a22, a23);
        a26 = engine.makeVariable();
        a28 = new ListTerm(a26, a25);
        a27 = new ListTerm(a22, a28);
        Term[] h7 = {a24};
        a30 = new StructureTerm(f6, h7);
        Term[] h8 = {a18, a30};
        a29 = new StructureTerm(f5, h8);
        a31 = engine.makeVariable();
        Term[] h10 = {a24};
        a33 = new StructureTerm(f6, h10);
        Term[] h11 = {a17, a33, a9};
        a32 = new StructureTerm(f9, h11);
        p1 = new Predicates._C_3(a31, a32, a7, cont);
        p2 = new Predicates._C_3(a20, a29, a31, p1);
        p3 = new Predicates.dollar_unify_2(a5, a27, p2);
        p4 = new Predicates.dollar_plus_3(a24, s4, a26, p3);
        p5 = new Predicates.dollar_unify_2(a19, a21, p4);
        p6 = new Predicates.dollar_genStaticArgs_8(a14, a16, a2, a3, a4, a19, a6, a20, p5);
        p7 = new Predicates.dollar_functor_3(a8, engine.makeVariable(), a13, p6);
        return new Predicates.eq_stop_stop_2(a8, a10, p7);
    }
}
}

