/*
 * *** Please do not edit ! ***
 * @(#) dollar_genUnifyVar_4.cs
 * @procedure $gen_unify_var/4 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genUnifyVar_4 : Predicate {
    static internal readonly Predicate dollar_genUnifyVar_4_1 = new Predicates.dollar_genUnifyVar_4_1();
    static internal readonly Predicate dollar_genUnifyVar_4_2 = new Predicates.dollar_genUnifyVar_4_2();
    static internal readonly Predicate dollar_genUnifyVar_4_3 = new Predicates.dollar_genUnifyVar_4_3();
    static internal readonly Predicate dollar_genUnifyVar_4_int = new Predicates.dollar_genUnifyVar_4_int();
    static internal readonly Predicate dollar_genUnifyVar_4_lis = new Predicates.dollar_genUnifyVar_4_lis();
    static internal readonly Predicate dollar_genUnifyVar_4_str = new Predicates.dollar_genUnifyVar_4_str();
    static internal readonly Predicate dollar_genUnifyVar_4_var = new Predicates.dollar_genUnifyVar_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_genUnifyVar_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_genUnifyVar_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_genUnifyVar_4_var,
                                   dollar_genUnifyVar_4_int,
                                   dollar_genUnifyVar_4_var,
                                   dollar_genUnifyVar_4_str,
                                   dollar_genUnifyVar_4_lis
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$gen_unify_var(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_genUnifyVar_4_var : dollar_genUnifyVar_4 {
    static internal readonly Predicate dollar_genUnifyVar_4_var_1 = new Predicates.dollar_genUnifyVar_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genUnifyVar_4_1, dollar_genUnifyVar_4_var_1);
    }
}

sealed class dollar_genUnifyVar_4_var_1 : dollar_genUnifyVar_4 {
    static internal readonly Predicate dollar_genUnifyVar_4_var_2 = new Predicates.dollar_genUnifyVar_4_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genUnifyVar_4_2, dollar_genUnifyVar_4_var_2);
    }
}

sealed class dollar_genUnifyVar_4_var_2 : dollar_genUnifyVar_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genUnifyVar_4_3);
    }
}

sealed class dollar_genUnifyVar_4_int : dollar_genUnifyVar_4 {
    static internal readonly Predicate dollar_genUnifyVar_4_int_1 = new Predicates.dollar_genUnifyVar_4_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genUnifyVar_4_2, dollar_genUnifyVar_4_int_1);
    }
}

sealed class dollar_genUnifyVar_4_int_1 : dollar_genUnifyVar_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genUnifyVar_4_3);
    }
}

sealed class dollar_genUnifyVar_4_str : dollar_genUnifyVar_4 {
    static internal readonly Predicate dollar_genUnifyVar_4_str_1 = new Predicates.dollar_genUnifyVar_4_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genUnifyVar_4_2, dollar_genUnifyVar_4_str_1);
    }
}

sealed class dollar_genUnifyVar_4_str_1 : dollar_genUnifyVar_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genUnifyVar_4_3);
    }
}

sealed class dollar_genUnifyVar_4_lis : dollar_genUnifyVar_4 {
    static internal readonly Predicate dollar_genUnifyVar_4_lis_1 = new Predicates.dollar_genUnifyVar_4_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genUnifyVar_4_2, dollar_genUnifyVar_4_lis_1);
    }
}

sealed class dollar_genUnifyVar_4_lis_1 : dollar_genUnifyVar_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genUnifyVar_4_3);
    }
}

sealed class dollar_genUnifyVar_4_1 : dollar_genUnifyVar_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("void");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("unify_void", 1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);
    static internal readonly Term[] h5 = {s3};
    static internal readonly StructureTerm s4 = new StructureTerm(f2, h5);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates._C_3(a3, s4, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_genUnifyVar_4_2 : dollar_genUnifyVar_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("unify_var", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a5 = engine.makeVariable();
        Term[] h3 = {a1};
        a6 = new StructureTerm(f2, h3);
        p1 = new Predicates._C_3(a3, a6, a4, cont);
        p2 = new Predicates.dollar_unify_2(a2, s1, p1);
        p3 = new Predicates.dollar_cut_1(a5, p2);
        p4 = new Predicates.dollar_var_1(a2, p3);
        return new Predicates.dollar_getLevel_1(a5, p4);
    }
}

sealed class dollar_genUnifyVar_4_3 : dollar_genUnifyVar_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_val", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {a1};
        a5 = new StructureTerm(f1, h2);
        return new Predicates._C_3(a3, a5, a4, cont);
    }
}
}

