/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateNoswitchNores_5.cs
 * @procedure $generate_noswitch_nores/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateNoswitchNores_5 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("sub");
    static internal readonly IntegerTerm s5 = new IntegerTerm(1);
    static internal readonly Term[] h20 = {s4, s5};
    static internal readonly StructureTerm s6 = new StructureTerm(f3, h20);
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("exec_method", 4);
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("root_nores");
    static internal readonly SymbolTerm f9 = SymbolTerm.makeSymbol("try", 2);
    static internal readonly SymbolTerm f14 = SymbolTerm.makeSymbol("extra_methods", 1);
    static internal readonly SymbolTerm f16 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly IntegerTerm s19 = new IntegerTerm(2);

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_generateNoswitchNores_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_generateNoswitchNores_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();
        a5 = arg5.dereference();

        if ( a3.isList() ){
            a6 = ((ListTerm)a3).car;
            if ( !s1.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a6 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a6, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f2 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            if ( !a1.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !s6.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a6.isVariable() ){
            Term[] args = {a1, s6};
            if ( !a6.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a7 = new ListTerm(a8, a9);
        Term[] h10 = {a1, a8};
        a13 = new StructureTerm(f2, h10);
        Term[] h11 = {a1, s6};
        a14 = new StructureTerm(f2, h11);
        Term[] h12 = {a13, a14};
        a12 = new StructureTerm(f9, h12);
        a11 = new ListTerm(a12, s1);
        Term[] h13 = {a1, s1, s8, a11};
        a10 = new StructureTerm(f7, h13);
        a15 = engine.makeVariable();
        Term[] h15 = {a1};
        a16 = new StructureTerm(f14, h15);
        a17 = engine.makeVariable();
        Term[] h17 = {a1, s6};
        a19 = new StructureTerm(f2, h17);
        Term[] h18 = {a19, s1};
        a18 = new StructureTerm(f16, h18);
        a20 = engine.makeVariable();
        p1 = new Predicates.dollar_generateTries2_6(a9, a1, s4, s19, a20, a5, cont);
        p2 = new Predicates._C_3(a17, a18, a20, p1);
        p3 = new Predicates._C_3(a15, a16, a17, p2);
        p4 = new Predicates._C_3(a4, a10, a15, p3);
        p5 = new Predicates.dollar_unify_2(a2, a7, p4);
        return new Predicates.dollar_neckCut_0(p5);
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$generate_noswitch_nores(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}
}

