/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateSw1_6.cs
 * @procedure $generate_sw1/6 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateSw1_6 : Predicate {
    static internal readonly Predicate dollar_generateSw1_6_1 = new Predicates.dollar_generateSw1_6_1();
    static internal readonly Predicate dollar_generateSw1_6_2 = new Predicates.dollar_generateSw1_6_2();
    static internal readonly Predicate dollar_generateSw1_6_3 = new Predicates.dollar_generateSw1_6_3();
    static internal readonly Predicate dollar_generateSw1_6_con = new Predicates.dollar_generateSw1_6_con();
    static internal readonly Predicate dollar_generateSw1_6_lis = new Predicates.dollar_generateSw1_6_lis();
    static internal readonly Predicate dollar_generateSw1_6_var = new Predicates.dollar_generateSw1_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_generateSw1_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_generateSw1_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_generateSw1_6_var,
                                   dollar_generateSw1_6_3,
                                   dollar_generateSw1_6_con,
                                   dollar_generateSw1_6_3,
                                   dollar_generateSw1_6_lis
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$generate_sw1(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_generateSw1_6_var : dollar_generateSw1_6 {
    static internal readonly Predicate dollar_generateSw1_6_var_1 = new Predicates.dollar_generateSw1_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSw1_6_1, dollar_generateSw1_6_var_1);
    }
}

sealed class dollar_generateSw1_6_var_1 : dollar_generateSw1_6 {
    static internal readonly Predicate dollar_generateSw1_6_var_2 = new Predicates.dollar_generateSw1_6_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_generateSw1_6_2, dollar_generateSw1_6_var_2);
    }
}

sealed class dollar_generateSw1_6_var_2 : dollar_generateSw1_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSw1_6_3);
    }
}

sealed class dollar_generateSw1_6_con : dollar_generateSw1_6 {
    static internal readonly Predicate dollar_generateSw1_6_con_1 = new Predicates.dollar_generateSw1_6_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSw1_6_1, dollar_generateSw1_6_con_1);
    }
}

sealed class dollar_generateSw1_6_con_1 : dollar_generateSw1_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSw1_6_3);
    }
}

sealed class dollar_generateSw1_6_lis : dollar_generateSw1_6 {
    static internal readonly Predicate dollar_generateSw1_6_lis_1 = new Predicates.dollar_generateSw1_6_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSw1_6_2, dollar_generateSw1_6_lis_1);
    }
}

sealed class dollar_generateSw1_6_lis_1 : dollar_generateSw1_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSw1_6_3);
    }
}

sealed class dollar_generateSw1_6_1 : dollar_generateSw1_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("$fail");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.unify(a4, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_generateSw1_6_2 : dollar_generateSw1_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("+", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f2 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            if ( !a3.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a7.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a4.isVariable() ){
            Term[] args = {a3, a7};
            if ( !a4.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_generateSw1_6_3 : dollar_generateSw1_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {a3, a2};
        a7 = new StructureTerm(f1, h2);
        Term[] h5 = {a4, s4};
        a8 = new StructureTerm(f3, h5);
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_generateTries_4(a1, a4, a9, a6, cont);
        p2 = new Predicates._C_3(a5, a8, a9, p1);
        return new Predicates.dollar_unify_2(a4, a7, p2);
    }
}
}

