/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateSwitch_6.cs
 * @procedure $generate_switch/6 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateSwitch_6 : Predicate {
    static internal readonly Predicate dollar_generateSwitch_6_1 = new Predicates.dollar_generateSwitch_6_1();
    static internal readonly Predicate dollar_generateSwitch_6_2 = new Predicates.dollar_generateSwitch_6_2();
    static internal readonly Predicate dollar_generateSwitch_6_3 = new Predicates.dollar_generateSwitch_6_3();
    static internal readonly Predicate dollar_generateSwitch_6_4 = new Predicates.dollar_generateSwitch_6_4();
    static internal readonly Predicate dollar_generateSwitch_6_con = new Predicates.dollar_generateSwitch_6_con();
    static internal readonly Predicate dollar_generateSwitch_6_int = new Predicates.dollar_generateSwitch_6_int();
    static internal readonly Predicate dollar_generateSwitch_6_lis = new Predicates.dollar_generateSwitch_6_lis();
    static internal readonly Predicate dollar_generateSwitch_6_str = new Predicates.dollar_generateSwitch_6_str();
    static internal readonly Predicate dollar_generateSwitch_6_var = new Predicates.dollar_generateSwitch_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_generateSwitch_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_generateSwitch_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_generateSwitch_6_var,
                                   dollar_generateSwitch_6_int,
                                   dollar_generateSwitch_6_con,
                                   dollar_generateSwitch_6_str,
                                   dollar_generateSwitch_6_lis
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$generate_switch(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_generateSwitch_6_var : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_var_1 = new Predicates.dollar_generateSwitch_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSwitch_6_1, dollar_generateSwitch_6_var_1);
    }
}

sealed class dollar_generateSwitch_6_var_1 : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_var_2 = new Predicates.dollar_generateSwitch_6_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_generateSwitch_6_2, dollar_generateSwitch_6_var_2);
    }
}

sealed class dollar_generateSwitch_6_var_2 : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_var_3 = new Predicates.dollar_generateSwitch_6_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_generateSwitch_6_3, dollar_generateSwitch_6_var_3);
    }
}

sealed class dollar_generateSwitch_6_var_3 : dollar_generateSwitch_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSwitch_6_4);
    }
}

sealed class dollar_generateSwitch_6_int : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_int_1 = new Predicates.dollar_generateSwitch_6_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSwitch_6_3, dollar_generateSwitch_6_int_1);
    }
}

sealed class dollar_generateSwitch_6_int_1 : dollar_generateSwitch_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSwitch_6_4);
    }
}

sealed class dollar_generateSwitch_6_con : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_con_1 = new Predicates.dollar_generateSwitch_6_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSwitch_6_1, dollar_generateSwitch_6_con_1);
    }
}

sealed class dollar_generateSwitch_6_con_1 : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_con_2 = new Predicates.dollar_generateSwitch_6_con_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_generateSwitch_6_3, dollar_generateSwitch_6_con_2);
    }
}

sealed class dollar_generateSwitch_6_con_2 : dollar_generateSwitch_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSwitch_6_4);
    }
}

sealed class dollar_generateSwitch_6_str : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_str_1 = new Predicates.dollar_generateSwitch_6_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSwitch_6_3, dollar_generateSwitch_6_str_1);
    }
}

sealed class dollar_generateSwitch_6_str_1 : dollar_generateSwitch_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSwitch_6_4);
    }
}

sealed class dollar_generateSwitch_6_lis : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_lis_1 = new Predicates.dollar_generateSwitch_6_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateSwitch_6_2, dollar_generateSwitch_6_lis_1);
    }
}

sealed class dollar_generateSwitch_6_lis_1 : dollar_generateSwitch_6 {
    static internal readonly Predicate dollar_generateSwitch_6_lis_2 = new Predicates.dollar_generateSwitch_6_lis_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_generateSwitch_6_3, dollar_generateSwitch_6_lis_2);
    }
}

sealed class dollar_generateSwitch_6_lis_2 : dollar_generateSwitch_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateSwitch_6_4);
    }
}

sealed class dollar_generateSwitch_6_1 : dollar_generateSwitch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_generateSwitch_6_2 : dollar_generateSwitch_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            if ( !a1.unify(new ListTerm(engine.makeVariable(), s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_generateSwitch_6_3 : dollar_generateSwitch_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("top");
    static internal readonly SymbolTerm s10 = SymbolTerm.makeSymbol("var");
    static internal readonly IntegerTerm s11 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a7 = args[0];
            if ( !s2.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {a7, s2};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( !s3.unify(a4, engine.trail) ) return engine.fail();
        Term[] h6 = {a7, s2};
        a10 = new StructureTerm(f1, h6);
        Term[] h8 = {a10, s7};
        a9 = new StructureTerm(f5, h8);
        Term[] h9 = {a9, s3};
        a8 = new StructureTerm(f4, h9);
        a11 = engine.makeVariable();
        Term[] h12 = {a7, s2};
        a12 = new StructureTerm(f1, h12);
        p1 = new Predicates.dollar_generateNoswitch_4(a12, a3, a11, a6, cont);
        p2 = new Predicates.dollar_selectType_4(a1, s10, s11, a3, p1);
        p3 = new Predicates._C_3(a5, a8, a11, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_generateSwitch_6_4 : dollar_generateSwitch_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("top");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("var");
    static internal readonly IntegerTerm s8 = new IntegerTerm(1);
    static internal readonly SymbolTerm s10 = SymbolTerm.makeSymbol("int");
    static internal readonly SymbolTerm s11 = SymbolTerm.makeSymbol("con");
    static internal readonly SymbolTerm s12 = SymbolTerm.makeSymbol("str");
    static internal readonly SymbolTerm s13 = SymbolTerm.makeSymbol("lis");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        Term[] h4 = {a2, s3};
        a8 = new StructureTerm(f2, h4);
        Term[] h6 = {a8, s5};
        a7 = new StructureTerm(f1, h6);
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h9 = {a2, s7};
        a13 = new StructureTerm(f2, h9);
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a19 = engine.makeVariable();
        a20 = engine.makeVariable();
        p1 = new Predicates.dollar_genSwitchOnTerm_10(a2, a3, a4, a12, a14, a16, a18, a20, a10, s5, cont);
        p2 = new Predicates.dollar_generateSw_7(a1, s13, a2, a3, a20, a19, a6, p1);
        p3 = new Predicates.dollar_generateSw_7(a1, s12, a2, a3, a18, a17, a19, p2);
        p4 = new Predicates.dollar_generateSw_7(a1, s11, a2, a3, a16, a15, a17, p3);
        p5 = new Predicates.dollar_generateSw_7(a1, s10, a2, a3, a14, a11, a15, p4);
        p6 = new Predicates.dollar_unify_2(a12, a13, p5);
        p7 = new Predicates._C_3(a9, a10, a11, p6);
        p8 = new Predicates.dollar_selectType_4(a1, s7, s8, a3, p7);
        return new Predicates._C_3(a5, a7, a9, p8);
    }
}
}

