/*
 * *** Please do not edit ! ***
 * @(#) dollar_incResCounter_1.cs
 * @procedure $inc_res_counter/1 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_incResCounter_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$res_counter", 1);
    static internal readonly IntegerTerm s3 = new IntegerTerm(1);

    public Term arg1;

    public dollar_incResCounter_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_incResCounter_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = arg1.dereference();

        Term[] h2 = {a1};
        a2 = new StructureTerm(f1, h2);
        a3 = engine.makeVariable();
        Term[] h4 = {a3};
        a4 = new StructureTerm(f1, h4);
        p1 = new Predicates.Assert_1(a4, cont);
        p2 = new Predicates.dollar_plus_3(a1, s3, a3, p1);
        return new Predicates.Retract_1(a2, p2);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$inc_res_counter(" + arg1 + ")";
    }
}
}

