/*
 * *** Please do not edit ! ***
 * @(#) dollar_intersectSortedVars_3.cs
 * @procedure $intersect_sorted_vars/3 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_intersectSortedVars_3 : Predicate {
    static internal readonly Predicate dollar_intersectSortedVars_3_1 = new Predicates.dollar_intersectSortedVars_3_1();
    static internal readonly Predicate dollar_intersectSortedVars_3_2 = new Predicates.dollar_intersectSortedVars_3_2();
    static internal readonly Predicate dollar_intersectSortedVars_3_3 = new Predicates.dollar_intersectSortedVars_3_3();
    static internal readonly Predicate dollar_intersectSortedVars_3_4 = new Predicates.dollar_intersectSortedVars_3_4();
    static internal readonly Predicate dollar_intersectSortedVars_3_5 = new Predicates.dollar_intersectSortedVars_3_5();
    static internal readonly Predicate dollar_intersectSortedVars_3_con = new Predicates.dollar_intersectSortedVars_3_con();
    static internal readonly Predicate dollar_intersectSortedVars_3_lis = new Predicates.dollar_intersectSortedVars_3_lis();
    static internal readonly Predicate dollar_intersectSortedVars_3_var = new Predicates.dollar_intersectSortedVars_3_var();

    public Term arg1, arg2, arg3;

    public dollar_intersectSortedVars_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_intersectSortedVars_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_intersectSortedVars_3_var,
                                   dollar_intersectSortedVars_3_2,
                                   dollar_intersectSortedVars_3_con,
                                   dollar_intersectSortedVars_3_2,
                                   dollar_intersectSortedVars_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$intersect_sorted_vars(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_intersectSortedVars_3_var : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_var_1 = new Predicates.dollar_intersectSortedVars_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_intersectSortedVars_3_1, dollar_intersectSortedVars_3_var_1);
    }
}

sealed class dollar_intersectSortedVars_3_var_1 : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_var_2 = new Predicates.dollar_intersectSortedVars_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_intersectSortedVars_3_2, dollar_intersectSortedVars_3_var_2);
    }
}

sealed class dollar_intersectSortedVars_3_var_2 : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_var_3 = new Predicates.dollar_intersectSortedVars_3_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_intersectSortedVars_3_3, dollar_intersectSortedVars_3_var_3);
    }
}

sealed class dollar_intersectSortedVars_3_var_3 : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_var_4 = new Predicates.dollar_intersectSortedVars_3_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_intersectSortedVars_3_4, dollar_intersectSortedVars_3_var_4);
    }
}

sealed class dollar_intersectSortedVars_3_var_4 : dollar_intersectSortedVars_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_intersectSortedVars_3_5);
    }
}

sealed class dollar_intersectSortedVars_3_con : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_con_1 = new Predicates.dollar_intersectSortedVars_3_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_intersectSortedVars_3_1, dollar_intersectSortedVars_3_con_1);
    }
}

sealed class dollar_intersectSortedVars_3_con_1 : dollar_intersectSortedVars_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_intersectSortedVars_3_2);
    }
}

sealed class dollar_intersectSortedVars_3_lis : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_lis_1 = new Predicates.dollar_intersectSortedVars_3_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_intersectSortedVars_3_2, dollar_intersectSortedVars_3_lis_1);
    }
}

sealed class dollar_intersectSortedVars_3_lis_1 : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_lis_2 = new Predicates.dollar_intersectSortedVars_3_lis_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_intersectSortedVars_3_3, dollar_intersectSortedVars_3_lis_2);
    }
}

sealed class dollar_intersectSortedVars_3_lis_2 : dollar_intersectSortedVars_3 {
    static internal readonly Predicate dollar_intersectSortedVars_3_lis_3 = new Predicates.dollar_intersectSortedVars_3_lis_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_intersectSortedVars_3_4, dollar_intersectSortedVars_3_lis_3);
    }
}

sealed class dollar_intersectSortedVars_3_lis_3 : dollar_intersectSortedVars_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_intersectSortedVars_3_5);
    }
}

sealed class dollar_intersectSortedVars_3_1 : dollar_intersectSortedVars_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_intersectSortedVars_3_2 : dollar_intersectSortedVars_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_intersectSortedVars_3_3 : dollar_intersectSortedVars_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            if ( !a4.unify(((ListTerm)a3).car, engine.trail) )
                return engine.fail();
            a8 = ((ListTerm)a3).cdr;
        } else if ( a3.isVariable() ){
            a8 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a4, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_intersectSortedVars_3(a5, a7, a8, cont);
        p2 = new Predicates.dollar_cut_1(a9, p1);
        p3 = new Predicates.dollar_equalityOfTerm_2(a4, a6, p2);
        return new Predicates.dollar_getLevel_1(a9, p3);
    }
}

sealed class dollar_intersectSortedVars_3_4 : dollar_intersectSortedVars_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        a9 = new ListTerm(a6, a7);
        p1 = new Predicates.dollar_intersectSortedVars_3(a5, a9, a3, cont);
        p2 = new Predicates.dollar_cut_1(a8, p1);
        p3 = new Predicates.dollar_before_2(a4, a6, p2);
        return new Predicates.dollar_getLevel_1(a8, p3);
    }
}

sealed class dollar_intersectSortedVars_3_5 : dollar_intersectSortedVars_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a6 = ((ListTerm)a2).car;
            a7 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a8 = engine.makeVariable();
        a9 = new ListTerm(a4, a5);
        p1 = new Predicates.dollar_intersectSortedVars_3(a9, a7, a3, cont);
        p2 = new Predicates.dollar_cut_1(a8, p1);
        p3 = new Predicates.dollar_after_2(a4, a6, p2);
        return new Predicates.dollar_getLevel_1(a8, p3);
    }
}
}

