/*
 * *** Please do not edit ! ***
 * @(#) dollar_isDisj_2.cs
 * @procedure $is_disj/2 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_isDisj_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_isDisj_2_1 = new Predicates.dollar_isDisj_2_1();
    static internal readonly Predicate dollar_isDisj_2_2 = new Predicates.dollar_isDisj_2_2();
    static internal readonly Predicate dollar_isDisj_2_3 = new Predicates.dollar_isDisj_2_3();
    static internal readonly Predicate dollar_isDisj_2_4 = new Predicates.dollar_isDisj_2_4();
    static internal readonly Predicate dollar_isDisj_2_5 = new Predicates.dollar_isDisj_2_5();
    static internal readonly Predicate dollar_isDisj_2_var = new Predicates.dollar_isDisj_2_var();

    public Term arg1, arg2;

    public dollar_isDisj_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_isDisj_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_isDisj_2_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_isDisj_2_var,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$is_disj(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_isDisj_2_var : dollar_isDisj_2 {
    static internal readonly Predicate dollar_isDisj_2_var_1 = new Predicates.dollar_isDisj_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_isDisj_2_1, dollar_isDisj_2_var_1);
    }
}

sealed class dollar_isDisj_2_var_1 : dollar_isDisj_2 {
    static internal readonly Predicate dollar_isDisj_2_var_2 = new Predicates.dollar_isDisj_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_isDisj_2_2, dollar_isDisj_2_var_2);
    }
}

sealed class dollar_isDisj_2_var_2 : dollar_isDisj_2 {
    static internal readonly Predicate dollar_isDisj_2_var_3 = new Predicates.dollar_isDisj_2_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_isDisj_2_3, dollar_isDisj_2_var_3);
    }
}

sealed class dollar_isDisj_2_var_3 : dollar_isDisj_2 {
    static internal readonly Predicate dollar_isDisj_2_var_4 = new Predicates.dollar_isDisj_2_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_isDisj_2_4, dollar_isDisj_2_var_4);
    }
}

sealed class dollar_isDisj_2_var_4 : dollar_isDisj_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_isDisj_2_5);
    }
}

sealed class dollar_isDisj_2_1 : dollar_isDisj_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("fail");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("!");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            if ( !s3.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a5, s3};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.isStructure() ){
            if (f4 != ((StructureTerm)a5).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a5).args;
            if ( !a3.unify(args[0],  engine.trail) )
                return engine.fail();
            a6 = args[1];
        } else if (a5.isVariable() ){
            a6 = engine.makeVariable();
            Term[] args = {a3, a6};
            if ( !a5.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f4 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            if ( !s5.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a4.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a6.isVariable() ){
            Term[] args = {s5, a4};
            if ( !a6.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_isDisj_2_2 : dollar_isDisj_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("!");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a3.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a7 = args[0];
            if ( !a4.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a7 = engine.makeVariable();
            Term[] args = {a7, a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.isStructure() ){
            if (f3 != ((StructureTerm)a7).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a7).args;
            if ( !a5.unify(args[0],  engine.trail) )
                return engine.fail();
            a8 = args[1];
        } else if (a7.isVariable() ){
            a8 = engine.makeVariable();
            Term[] args = {a5, a8};
            if ( !a7.unify(new StructureTerm(f3, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a8.isStructure() ){
            if (f3 != ((StructureTerm)a8).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a8).args;
            if ( !s4.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a6.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a8.isVariable() ){
            Term[] args = {s4, a6};
            if ( !a8.unify(new StructureTerm(f3, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_isDisj_2_3 : dollar_isDisj_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            if ( !a3.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !a4.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            Term[] args = {a3, a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_isDisj_2_4 : dollar_isDisj_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("not", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("true");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("!");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("fail");
    static internal readonly Term[] h8 = {s5, s6};
    static internal readonly StructureTerm s7 = new StructureTerm(f4, h8);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
            if ( !s3.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4, s3};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f4 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            if ( !a3.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !s7.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a4.isVariable() ){
            Term[] args = {a3, s7};
            if ( !a4.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_isDisj_2_5 : dollar_isDisj_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("\\+", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("true");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol(",", 2);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("!");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("fail");
    static internal readonly Term[] h8 = {s5, s6};
    static internal readonly StructureTerm s7 = new StructureTerm(f4, h8);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
            if ( !s3.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4, s3};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isStructure() ){
            if (f4 != ((StructureTerm)a4).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a4).args;
            if ( !a3.unify(args[0],  engine.trail) )
                return engine.fail();
            if ( !s7.unify(args[1],  engine.trail) )
                return engine.fail();
        } else if (a4.isVariable() ){
            Term[] args = {a3, s7};
            if ( !a4.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return cont;
    }
}
}

