/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompCont_4.cs
 * @procedure $precomp_cont/4 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompCont_4 : Predicate {
    static internal readonly Predicate dollar_precompCont_4_1 = new Predicates.dollar_precompCont_4_1();
    static internal readonly Predicate dollar_precompCont_4_2 = new Predicates.dollar_precompCont_4_2();
    static internal readonly Predicate dollar_precompCont_4_var = new Predicates.dollar_precompCont_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_precompCont_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_precompCont_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_precompCont_4_var,
                                   dollar_precompCont_4_2,
                                   dollar_precompCont_4_var,
                                   dollar_precompCont_4_2,
                                   dollar_precompCont_4_2
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$precomp_cont(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_precompCont_4_var : dollar_precompCont_4 {
    static internal readonly Predicate dollar_precompCont_4_var_1 = new Predicates.dollar_precompCont_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_precompCont_4_1, dollar_precompCont_4_var_1);
    }
}

sealed class dollar_precompCont_4_var_1 : dollar_precompCont_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_precompCont_4_2);
    }
}

sealed class dollar_precompCont_4_1 : dollar_precompCont_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("cont");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a4, a3, cont);
        p2 = new Predicates.dollar_unify_2(s1, a2, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_precompCont_4_2 : dollar_precompCont_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put_cont", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a5 = new ListTerm(a6, a7);
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = new ListTerm(a6, a8);
        Term[] h2 = {a10, a2};
        a12 = new StructureTerm(f1, h2);
        p1 = new Predicates._C_3(a9, a12, a4, cont);
        p2 = new Predicates.eq_stop_stop_2(a10, a11, p1);
        p3 = new Predicates.dollar_precompCall_5(a6, a7, a8, a3, a9, p2);
        return new Predicates.eq_stop_stop_2(a1, a5, p3);
    }
}
}

