/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompPut_5.cs
 * @procedure $precomp_put/5 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompPut_5 : Predicate {
    static internal readonly Predicate dollar_precompPut_5_1 = new Predicates.dollar_precompPut_5_1();
    static internal readonly Predicate dollar_precompPut_5_2 = new Predicates.dollar_precompPut_5_2();
    static internal readonly Predicate dollar_precompPut_5_sub_1 = new Predicates.dollar_precompPut_5_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_precompPut_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_precompPut_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_precompPut_5_1, dollar_precompPut_5_sub_1);
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$precomp_put(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_precompPut_5_sub_1 : dollar_precompPut_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_precompPut_5_2);
    }
}

sealed class dollar_precompPut_5_1 : dollar_precompPut_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$closure", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("put_free_vars", 2);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("put_closure", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        Term[] h2 = {a8, a9};
        a7 = new StructureTerm(f1, h2);
        a11 = engine.makeVariable();
        Term[] h4 = {a9, a11};
        a10 = new StructureTerm(f3, h4);
        a12 = engine.makeVariable();
        Term[] h6 = {a8, a11, a3};
        a13 = new StructureTerm(f5, h6);
        p1 = new Predicates._C_3(a12, a13, a5, cont);
        p2 = new Predicates._C_3(a4, a10, a12, p1);
        p3 = new Predicates.dollar_cut_1(a6, p2);
        p4 = new Predicates.dollar_unify_2(a2, a7, p3);
        p5 = new Predicates.dollar_nonvar_1(a2, p4);
        p6 = new Predicates.dollar_dummyPlcs__9_1(a1, p5);
        return new Predicates.dollar_getLevel_1(a6, p6);
    }
}

sealed class dollar_precompPut_5_2 : dollar_precompPut_5 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {a2, a3};
        a6 = new StructureTerm(f1, h2);
        return new Predicates._C_3(a4, a6, a5, cont);
    }
}
}

