/*
 * *** Please do not edit ! ***
 * @(#) dollar_transformBody1_3.cs
 * @procedure $transform_body1/3 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_transformBody1_3 : Predicate {
    static internal readonly Predicate dollar_transformBody1_3_1 = new Predicates.dollar_transformBody1_3_1();
    static internal readonly Predicate dollar_transformBody1_3_2 = new Predicates.dollar_transformBody1_3_2();
    static internal readonly Predicate dollar_transformBody1_3_3 = new Predicates.dollar_transformBody1_3_3();
    static internal readonly Predicate dollar_transformBody1_3_var = new Predicates.dollar_transformBody1_3_var();

    public Term arg1, arg2, arg3;

    public dollar_transformBody1_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_transformBody1_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_transformBody1_3_var,
                                   dollar_transformBody1_3_1,
                                   dollar_transformBody1_3_1,
                                   dollar_transformBody1_3_var,
                                   dollar_transformBody1_3_1
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$transform_body1(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_transformBody1_3_var : dollar_transformBody1_3 {
    static internal readonly Predicate dollar_transformBody1_3_var_1 = new Predicates.dollar_transformBody1_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_transformBody1_3_1, dollar_transformBody1_3_var_1);
    }
}

sealed class dollar_transformBody1_3_var_1 : dollar_transformBody1_3 {
    static internal readonly Predicate dollar_transformBody1_3_var_2 = new Predicates.dollar_transformBody1_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_transformBody1_3_2, dollar_transformBody1_3_var_2);
    }
}

sealed class dollar_transformBody1_3_var_2 : dollar_transformBody1_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_transformBody1_3_3);
    }
}

sealed class dollar_transformBody1_3_1 : dollar_transformBody1_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_var_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_transformBody1_3_2 : dollar_transformBody1_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$cut", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("$neck_cut");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a5 = ((ListTerm)a2).car;
            a6 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.isStructure() ){
            if (f1 != ((StructureTerm)a5).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a5).args;
            if ( !a4.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a5.isVariable() ){
            Term[] args = {a4};
            if ( !a5.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            if ( !s2.unify(((ListTerm)a3).car, engine.trail) )
                return engine.fail();
            if ( !a6.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            if ( !a3.unify(new ListTerm(s2, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_transformBody1_3_3 : dollar_transformBody1_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$cut", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$get_level", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a4 = args[0];
        } else if (a1.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a3.isList() ){
            a5 = ((ListTerm)a3).car;
            if ( !a2.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            a5 = engine.makeVariable();
            if ( !a3.unify(new ListTerm(a5, a2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a5.isStructure() ){
            if (f2 != ((StructureTerm)a5).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a5).args;
            if ( !a4.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a5.isVariable() ){
            Term[] args = {a4};
            if ( !a5.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return cont;
    }
}
}

