/*
 * *** Please do not edit ! ***
 * @(#) dollar_transform_2.cs
 * @procedure $transform/2 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_transform_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("cont");

    public Term arg1, arg2;

    public dollar_transform_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_transform_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        p1 = new Predicates.dollar_transform_3(a1, s1, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$transform(" + arg1 + ", " + arg2 + ")";
    }
}
}

