/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjConstructorArgsForCall_3.cs
 * @procedure $wj_constructor_args_for_call/3 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjConstructorArgsForCall_3 : Predicate {
    static internal readonly Predicate dollar_wjConstructorArgsForCall_3_1 = new Predicates.dollar_wjConstructorArgsForCall_3_1();
    static internal readonly Predicate dollar_wjConstructorArgsForCall_3_2 = new Predicates.dollar_wjConstructorArgsForCall_3_2();
    static internal readonly Predicate dollar_wjConstructorArgsForCall_3_sub_1 = new Predicates.dollar_wjConstructorArgsForCall_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_wjConstructorArgsForCall_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_wjConstructorArgsForCall_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_wjConstructorArgsForCall_3_1, dollar_wjConstructorArgsForCall_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$wj_constructor_args_for_call(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_wjConstructorArgsForCall_3_sub_1 : dollar_wjConstructorArgsForCall_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_wjConstructorArgsForCall_3_2);
    }
}

sealed class dollar_wjConstructorArgsForCall_3_1 : dollar_wjConstructorArgsForCall_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("this.cont = cont;");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s5 = new ListTerm(s3, s4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_writelnStream_3(a1, s2, s5, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_greaterThan_2(a2, a5, p2);
        p4 = new Predicates.dollar_minus_3(a3, s1, a5, p3);
        return new Predicates.dollar_getLevel_1(a4, p4);
    }
}

sealed class dollar_wjConstructorArgsForCall_3_2 : dollar_wjConstructorArgsForCall_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("arg");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(" = ");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("args[");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("]; ");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s8 = new ListTerm(s6, s7);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        a9 = new ListTerm(a2, s8);
        a8 = new ListTerm(s5, a9);
        a7 = new ListTerm(s4, a8);
        a6 = new ListTerm(a4, a7);
        a5 = new ListTerm(s3, a6);
        p1 = new Predicates.dollar_wjConstructorArgsForCall_3(a1, a4, a3, cont);
        p2 = new Predicates.dollar_writelnStream_3(a1, s2, a5, p1);
        return new Predicates.dollar_plus_3(a2, s1, a4, p2);
    }
}
}

