/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjPublicArgDecl_2.cs
 * @procedure $wj_public_arg_decl/2 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjPublicArgDecl_2 : Predicate {
    static internal readonly Predicate dollar_wjPublicArgDecl_2_1 = new Predicates.dollar_wjPublicArgDecl_2_1();
    static internal readonly Predicate dollar_wjPublicArgDecl_2_2 = new Predicates.dollar_wjPublicArgDecl_2_2();
    static internal readonly Predicate dollar_wjPublicArgDecl_2_sub_1 = new Predicates.dollar_wjPublicArgDecl_2_sub_1();

    public Term arg1, arg2;

    public dollar_wjPublicArgDecl_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_wjPublicArgDecl_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_wjPublicArgDecl_2_1, dollar_wjPublicArgDecl_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$wj_public_arg_decl(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_wjPublicArgDecl_2_sub_1 : dollar_wjPublicArgDecl_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_wjPublicArgDecl_2_2);
    }
}

sealed class dollar_wjPublicArgDecl_2_1 : dollar_wjPublicArgDecl_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_lessOrEqual_2(a2, s1, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}

sealed class dollar_wjPublicArgDecl_2_2 : dollar_wjPublicArgDecl_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);
    static internal readonly IntegerTerm s2 = new IntegerTerm(4);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("public Term ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("arg");
    static internal readonly IntegerTerm s5 = new IntegerTerm(1);
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol(";");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.dollar_wjAssignNumber_5(a1, a2, s4, s5, s6, p1);
        p3 = new Predicates.Write_2(a1, s3, p2);
        p4 = new Predicates.dollar_tab_2(a1, s2, p3);
        p5 = new Predicates.dollar_nl_1(a1, p4);
        return new Predicates.dollar_greaterThan_2(a2, s1, p5);
    }
}
}

