/*
 * *** Please do not edit ! ***
 * @(#) Plcs_1.cs
 * @procedure plcs/1 in plcs.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Plcs_1 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol(".pl");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("{translating ");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(" into C#...}");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("runtime");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("{");
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol(" translated, ");
    static internal readonly SymbolTerm s9 = SymbolTerm.makeSymbol(" msec}");

    public Term arg1;

    public Plcs_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Plcs_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14, p15;
        a1 = arg1.dereference();

        a2 = new ListTerm(a1, s3);
        a3 = engine.makeVariable();
        a6 = engine.makeVariable();
        a5 = new ListTerm(a6, s2);
        a4 = new ListTerm(engine.makeVariable(), a5);
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s9, p1);
        p3 = new Predicates.Write_1(a6, p2);
        p4 = new Predicates.Write_1(s8, p3);
        p5 = new Predicates.Write_1(a3, p4);
        p6 = new Predicates.Write_1(s7, p5);
        p7 = new Predicates.Statistics_2(s6, a4, p6);
        p8 = new Predicates.dollar_compileAllPredicates_0(p7);
        p9 = new Predicates.dollar_readInProgram_1(a3, p8);
        p10 = new Predicates.dollar_plcsInit_1(a1, p9);
        p11 = new Predicates.Statistics_2(s6, engine.makeVariable(), p10);
        p12 = new Predicates.dollar_nl_0(p11);
        p13 = new Predicates.Write_1(s5, p12);
        p14 = new Predicates.Write_1(a3, p13);
        p15 = new Predicates.Write_1(s4, p14);
        return new Predicates.dollar_listToString_2(a2, a3, p15);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "plcs(" + arg1 + ")";
    }
}
}

