/*
 * *** Please do not edit ! ***
 * @(#) WaitForOne_1.cs
 * @procedure wait_for_one/1 in wf.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class WaitForOne_1 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$call_spin", 2);

    public Term arg1;

    public WaitForOne_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public WaitForOne_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        Term[] h2 = {a1, a2};
        a3 = new StructureTerm(f1, h2);
        p1 = new Predicates.Once_1(a3, cont);
        p2 = new Predicates.BacktrackableLock_1(a2, p1);
        return new Predicates.dollar_getConcurrentRoot_2(a1, a2, p2);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "wait_for_one(" + arg1 + ")";
    }
}
}

