/*
 * @(#)dollar_abs_2.cs
 *  $B=R8l(B $abs/2
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_abs_2 : Predicate {
		Term arg1, arg2;

		public dollar_abs_2(Term a1, Term a2, Predicate cont){
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_abs_2(){}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ){
			Term a2;
			a2 = arg2.dereference();

			try {
				int x = engine.evalTerm(arg1);
				if( !a2.unify(new IntegerTerm(System.Math.Abs(x)), engine.trail) ) 
					return engine.fail();
			} catch (ArithException) {
				return engine.abort("{TYPE ERROR: " + 
					this + 
					" -arg 1: expected expression, found " +
					arg1 + "}\n");
			}
			return cont;
		}

		public override int arity() { return 2; }

		public override string ToString() {
			return "$abs(" + arg1 + "," + arg2 + ")";
		}
	}

}