/*
 * @(#)dollar_java_constructor_2.cs
 * $B=R8l(B $java_constructor/2
 */

// import java.lang.*;
// import java.lang.reflect.*;

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System;
	using System.Reflection;

	public sealed class dollar_csConstructor_2 : Predicate {
		Term arg1, arg2;

		public dollar_csConstructor_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}

		public dollar_csConstructor_2() {}

		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			Type type = null; // Class clazz = null;
			object instance = null; // Object instance = null;
			try {
				if ( a1.isSymbol() ) { // $B0z?t$J$7%3%s%9%H%i%/%?(B
					type = AssemblyList.GetAnyType( ((SymbolTerm)a1).name );
					// clazz = Class.forName(((SymbolTerm)a1).name());
					instance = Activator.CreateInstance( type );
					// instance = clazz.newInstance();
				}
				else if ( a1.isStructure() ) { // $B0z?tM-$j(B
					type = AssemblyList.GetAnyType(((StructureTerm)a1).functor.name);
					// clazz = Class.forName(((StructureTerm)a1).functor().name());
					Term[] args = ((StructureTerm)a1).args;
					int arity = ((StructureTerm)a1).arity;
					object[] initArgs = new object[arity];	
					for (int i=0; i<arity; i++) {
						initArgs[i] = args[i].toCsObject();
					}

					ConstructorInfo[] cons = type.GetConstructors( );				
					// Constructor[] cons = clazz.getConstructors();
					if (cons.Length == 0)
						return engine.fail();
					ConstructorInfo con = null;
					for (int i=0; i<cons.Length; i++){
						if ( callable(cons[i].GetParameters(), initArgs) ){
							con = cons[i];
							break;
						}
					}
					if (con == null)
						return engine.fail();
					instance = con.Invoke( initArgs );
					// instance = con.newInstance(initArgs);
				}
				else {
					return engine.abort("{TYPE ERROR: " + this +
						" expected atom or compound, found " + 
						a1 + "}\n");
				}
				/*
			} catch (SecurityException e7) {
				e7.printStackTrace();
				return engine.abort("{SECURITY ERROR: " + this + 
					" expected accessible class, found " + a1 + "}\n");
			} catch (InstantiationException e2) {
				e2.printStackTrace();
				return engine.abort("{INSTANTIATION ERROR: " + this + "}\n");
			} catch (IllegalAccessException e3) {
				e3.printStackTrace();
				return engine.abort("{ILLEGAL ACCESS ERROR: " + this + "}\n");
			} catch (IllegalArgumentException e5) {
				e5.printStackTrace();
				return engine.abort("{ILLEGAL ARGUMENT ERROR: " + this + "}\n");
			} catch (InvocationTargetException e4) {
				e4.getTargetException().printStackTrace();
				return engine.abort("{INVOCATION TARGET ERROR: " + this + "}\n");
			} catch (ClassNotFoundException e1) {
				e1.printStackTrace();
				return engine.abort("{CLASS NOT FOUND ERROR: " + this + "}\n");
				*/
			} catch (Exception e) {
				Console.Out.WriteLine( e );
				return engine.abort("{CSHARP ERROR: " + this + "}\n");
			}
			// $BBhFs0z?t$H%$%s%9%?%s%9$r(Bunify
			if ( !a2.unify(new CsObjectTerm(instance), engine.trail) ) 
				return engine.fail();
			return cont;
		}

		private bool callable(System.Reflection.ParameterInfo[] paraInfo, object[] args){
			Type[] paraTypes = new Type[ paraInfo.Length ];
			for( int i = 0; i < paraInfo.Length; i++ )	
				paraTypes[ i ] = paraInfo[ i ].ParameterType;

			int arity = paraTypes.Length;
			if (arity != args.Length)
				return false;
			for (int i=0; i<arity; i++) {
					/*
				if ( paraTypes[i].Equals(AssemblyList.GetAnyType("System.Int32")) ){
					if ( args[i] is Int32 )
						continue;
					else
						return false;
				}
				if ( paraTypes[i].Equals("System.Boolean") ){
					if ( args[i] is Boolean )
						continue;
					else
						return false;
				}
					*/
				if( !( paraTypes[ i ].IsInstanceOfType( args[ i ] ) ) )
						return false;

					    //if (! paraTypes[i].isInstance(args[i]) )
						//	 return false;
			}
			return true;
		}

		private void checkModifier(int mod) {
			/*
			if (Modifier.isPublic (mod) ) System.out.println("public");
			if (Modifier.isPrivate(mod) ) System.out.println("private");
			if (Modifier.isProtected(mod) ) System.out.println("protected");
			if (Modifier.isStatic(mod) ) System.out.println("static");
			if (Modifier.isFinal(mod) ) System.out.println("final");
			*/
			
			/* JJC: maybe put this back in when rest is working. 
			 * 
			if (Modifier.isPrivate(mod)) {
				Console.WriteLine("{MODIFIER ERROR: " + this + " - arg 1: " +
						   " private method can not be invoked}\n");
			}
			*/
			
			return;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$cs_constructor(" + arg1 + "," + arg2 + ")";
		}
	}

}