/*
 * @(#)dollar_java_term_2.cs
 * $B=R8l(B $java_term/2
 */

// import java.lang.*;
// import java.lang.reflect.*;


namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_csTerm_2 : Predicate {
		Term arg1, arg2;

		public dollar_csTerm_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_csTerm_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.dereference(); // Prolog Term
			a2 = arg2.dereference(); // C# Term

			Term pterm, jterm;
			if ( a1.isVariable() ){
				if ( ! a2.isCsObject() )
					return engine.fail();
				pterm = ((CsObjectTerm)a2).toPrologTerm();
				if ( ! a1.unify(pterm, engine.trail) )
					return engine.fail();
				return cont;
			}
			if ( a2.isVariable() ){
				jterm = new CsObjectTerm(a1.toCsObject());
				if ( ! a2.unify(jterm, engine.trail) )
					return engine.fail();
				return cont;
			}

			if ( ! a2.isCsObject() )
				return engine.fail();
			pterm = ((CsObjectTerm)a2).toPrologTerm();
			jterm = new CsObjectTerm(a1.toCsObject());
			if ( ! pterm.unify(jterm, engine.trail) )
				return engine.fail();
			return cont;
		}

		public override int arity() { return 2; }
		public override string ToString() {
			return "$cs_term(" + arg1 + "," + arg2 + ")";
		}
	}

}