namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System.IO;
	using System.Reflection;
	using Microsoft.CSharp;
	using System.CodeDom.Compiler;
	using System.Collections.Specialized;

	public sealed class dollar_csc_2 : Predicate {
		Term arg1;
		Term arg2;

		public dollar_csc_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_csc_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			string loader = 

@"

// entry point for the user's Psharp application.

namespace JJC.Psharp.Lang {

		using System.Reflection;

        class Loader {
		static void Main(string[] args) {
                        if( args.Length == 0 )" +
				"                                args = new string[] { \"Main\" };\n" +
				"			Assembly a = System.Reflection.Assembly.Load( \"Psharp\" );\n" +
				"			a.GetType( \"JJC.Psharp.Lang.PrologMain\" ).GetMethod( \"Main\" ).\n" + 
				"                                Invoke( a.CreateInstance( \"JJC.Psharp.Lang.PrologMain\" ),\n" +
				@"                                        new object[] { args } );
		}
	}
}
";
				try {
					System.CodeDom.Compiler.CompilerParameters cp = new
						System.CodeDom.Compiler.CompilerParameters(
						new string[] { Assembly.GetAssembly( this.GetType( ) ).Location } );
					//cp.OutputAssembly = "MyAssembly.dll";
					cp.GenerateInMemory = true;
					cp.GenerateExecutable = false;
					cp.CompilerOptions = ( "" );

					System.CodeDom.Compiler.ICodeCompiler compiler = 
						new Microsoft.CSharp.CSharpCodeProvider().CreateCompiler();

					string program = ( (SymbolTerm)a1 ).name + loader;
			
					CompilerResults res = compiler.CompileAssemblyFromSource( cp, program );
					System.Collections.Specialized.StringEnumerator ste =
						res.Output.GetEnumerator();
					while( ste.MoveNext( ) ) 
						System.Console.WriteLine( ste.Current );

					Assembly a = res.CompiledAssembly;
					CsObjectTerm ot = new CsObjectTerm( a );
					if( !a2.unify( ot, engine.trail ) )
						return engine.fail( );
					return cont;			
			
				} catch( System.Exception e ) {
					System.Console.WriteLine( e.Message );
					return engine.fail();
				}
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$csc(" + arg1 + ", " + arg2 + ")";
		}
	}
}