/*
 *  @(#)dollar_flushOutput_1.cs
 *  $B=R8l(B $flush_output/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_flushOutput_1 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		private static SymbolTerm SYM_user_output = SymbolTerm.makeSymbol("user_output");
		private static SymbolTerm SYM_user_error = SymbolTerm.makeSymbol("user_error");
		Term arg1;

		public dollar_flushOutput_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_flushOutput_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();
			object obj;
	
			if ( a1.isVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_output) ) {
				engine.user_output.Flush();
				return cont;
			}
			if ( a1.Equals(SYM_user_error) ) {
				engine.user_error.Flush();
				return cont;
			}
			if ( !a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//	    return null;
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is TextWriter) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" -arg 1: expected stream, found " +
					a1 + "}\n");
				//return null;
			}
			((TextWriter)obj).Flush();
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$flush_output(" + arg1 + ")";
		}
	}

}