namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_getConcurrentRoot_2 : Predicate {
		Term arg1;
		Term arg2;

		public dollar_getConcurrentRoot_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_getConcurrentRoot_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.dereference( );
			Term a2 = arg2.dereference( );

			if( !a1.isVariable( ) )
				return engine.fail( );
			VariableTerm vt = (VariableTerm)a1;
			if( vt.concurrentRoot == null )
				return engine.fail( );
			if( !( a2.unify( vt.concurrentRoot.csObject, engine.trail ) ) )
				return engine.fail( );
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$get_concurrent_root(" + arg1 + ", " + arg2 + ")";
		}	
	}

}