/*
 *  @(#) dollar_get_1.cs
 *  $B=R8l(B get0/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_get_1 : Predicate {
		Term arg1;

		public dollar_get_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_get_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();
			int input;

			try { 
				//	    if ( !engine.current_input.Ready() ){
				//		engine.abort("{IO ERROR: " + this + 
				//			     " current stream is not available}\n");
				//		return null;
				//	    }
				input = engine.current_input.Read();
				while( input <= ' ') {
					input = engine.current_input.Read();
				}
				if( !a1.unify(new IntegerTerm(input), engine.trail) )
					return engine.fail();
			} catch (IOException) {
				return engine.abort("{IO Error: " + this + "}");
			}
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$get(" + arg1 + ")";
		}
	}

}