namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;
	using System.IO;

	public sealed class dollar_resultStringWriter_2 : Predicate {
		Term arg1;
		Term arg2;

		public dollar_resultStringWriter_2(Term a1, Term a2, Predicate cont) {
			arg1 = a1;
			arg2 = a2;
			this.cont = cont;
		}
		public dollar_resultStringWriter_2() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			arg2 = args[1];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1, a2;
			a1 = arg1.dereference();
			a2 = arg2.dereference();

			try {
				CsObjectTerm ot = (CsObjectTerm)a1;
				StringWriter sw = (StringWriter)( ot.Object( ) );
				string s = sw.GetStringBuilder( ).ToString( );
				if ( !a2.unify(SymbolTerm.makeSymbol(s), engine.trail) )
					return engine.fail();
				return cont;

			} catch( System.Exception ) {
				return engine.fail();
			}
		}

		public override int arity() { return 1; }

		public override string ToString() {
			return "$result_string_writer(" + arg1 + ", " + arg2 + ")";
		}
	}
}