/*
 *  @(#) dollar_setOutput_1.cs
 *  $B=R8l(B $set_output/1
 */

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	using System.IO;

	public sealed class dollar_setOutput_1 : Predicate {
		private static SymbolTerm SYM_user = SymbolTerm.makeSymbol("user");
		private static SymbolTerm SYM_user_output = SymbolTerm.makeSymbol("user_output");
		private static SymbolTerm SYM_user_error  = SymbolTerm.makeSymbol("user_error");
		Term arg1;

		public dollar_setOutput_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_setOutput_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();
			object obj;
	
			if ( a1.isVariable() ) {
				return engine.abort("{INSTANTIATION  ERROR: " + this + "}\n");
				//	    return null;
			}
			if ( a1.Equals(SYM_user) || a1.Equals(SYM_user_output) ) {
				engine.setOutput(engine.user_output);
				return cont;
			}
			if ( a1.Equals(SYM_user_error) ) {
				engine.setOutput(engine.user_error);
				return cont;
			}
			if ( !a1.isCsObject() ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
				//	    return engine.fail();
			}
			obj = ((CsObjectTerm)a1).Object();
			if ( !(obj is TextWriter) ) {
				return engine.abort("{TYPE ERROR: " + this + 
					" - arg 1: expected stream, found " +
					a1 + "}");
				//	    return null;
				//	    return engine.fail();
			}
			engine.setOutput((TextWriter)obj);
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$set_output(" + arg1 + ")";
		}
	}

}