/*
 *  @(#) dollar_unget_1.cs
 *  $B=R8l(B get0/1
 */
// import java.io.*;

namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_unget_1 : Predicate {
		Term arg1;

		public dollar_unget_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_unget_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1;
			a1 = arg1.dereference();
			int val;

			if( !a1.isInteger() )
				return engine.fail();
			val = ((IntegerTerm)a1).value();
			try { 
				engine.current_input.Unread(val);
			} catch (System.Exception) {
				return engine.abort("{IO Error: " + this + "}\n");
			}
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$unget(" + arg1 + ")";
		}
	}

}