namespace JJC.Psharp.Predicates {

	using JJC.Psharp.Lang;

	public sealed class dollar_waitOn_1 : Predicate {
		Term arg1;

		public dollar_waitOn_1(Term a1, Predicate cont) {
			arg1 = a1;
			this.cont = cont;
		}
		public dollar_waitOn_1() {}
		public override void setArgument(Term[] args, Predicate cont){
			arg1 = args[0];
			this.cont = cont;
		}

		public override Predicate exec( Prolog engine ) {
			Term a1 = arg1.dereference( );
			if( !a1.isCsObject( ) ) 
				return engine.fail( );
			CsObjectTerm cso = (CsObjectTerm)a1;
			//engine.user_output.Write( "Waiting on " + cso.toCsObject( ) + " ");

			ConcurrentVariable cv = (ConcurrentVariable)( cso.toCsObject( ) );

			lock( cv ) {
				if( cv.ShouldRelease( engine ) ) {
					return engine.fail( );
				}
				cv.DeclareWaiting( engine, true );
				if( cv.AllWaiting( ) ) {
					cv.DeclareWaiting( engine, false );
					return engine.fail( );
				} else {
					System.Threading.Monitor.Wait( cv );
					cv.DeclareWaiting( engine, false );
					if( cv.ShouldRelease( engine ) ) {
						return engine.fail( );
					}	
				}
			}
			//engine.user_output.WriteLine( "Wait released" );
			return cont;
		}

		public override int arity() { return 1; }
		public override string ToString() {
			return "$wait_on(" + arg1 + ")";
		}	
	}

}