namespace JJC.Psharp.Lang {

	using System.IO;

	public class PushbackReader {

		int buffer;
		bool full = false;
		TextReader t;

		public PushbackReader( TextReader t ) {
			this.t = t;
		}
		
		public virtual int Read( ) {
			lock( this ) {
				if( full ) {
					full = false;
					return buffer;
				}
				else
					return t.Read( );
			}
		}

		public virtual void Unread( int c ) {
			lock( this ) {
				if( full ) {
					throw new System.Exception( "cannot unread" );
				}
				buffer = c;
				full = true;
			}
		}

		public virtual void Close( ) {
			lock( this ) {
				t.Close( );
			}
		}
	}

}