/*
 * *** Please do not edit ! ***
 * @(#) dollar_dcgExpansion_2.cs
 * @procedure $dcg_expansion/2 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_dcgExpansion_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_dcgExpansion_2_1 = new Predicates.dollar_dcgExpansion_2_1();
    static internal readonly Predicate dollar_dcgExpansion_2_2 = new Predicates.dollar_dcgExpansion_2_2();
    static internal readonly Predicate dollar_dcgExpansion_2_3 = new Predicates.dollar_dcgExpansion_2_3();
    static internal readonly Predicate dollar_dcgExpansion_2_var = new Predicates.dollar_dcgExpansion_2_var();

    public Term arg1, arg2;

    public dollar_dcgExpansion_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_dcgExpansion_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_dcgExpansion_2_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_dcgExpansion_2_var,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$dcg_expansion(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_dcgExpansion_2_var : dollar_dcgExpansion_2 {
    static internal readonly Predicate dollar_dcgExpansion_2_var_1 = new Predicates.dollar_dcgExpansion_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_dcgExpansion_2_1, dollar_dcgExpansion_2_var_1);
    }
}

sealed class dollar_dcgExpansion_2_var_1 : dollar_dcgExpansion_2 {
    static internal readonly Predicate dollar_dcgExpansion_2_var_2 = new Predicates.dollar_dcgExpansion_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_dcgExpansion_2_2, dollar_dcgExpansion_2_var_2);
    }
}

sealed class dollar_dcgExpansion_2_var_2 : dollar_dcgExpansion_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_dcgExpansion_2_3);
    }
}

sealed class dollar_dcgExpansion_2_1 : dollar_dcgExpansion_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            if ( !a3.unify(args[0],  engine.trail) )
                return engine.fail();
            a5 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            Term[] args = {a3, a5};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_dcgExpansion_2(a4, a5, cont);
        p2 = new Predicates.dollar_nonvar_1(a4, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_dcgExpansion_2_2 : dollar_dcgExpansion_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("-->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a6.isStructure() ){
            if (f3 != ((StructureTerm)a6).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a6).args;
            a7 = args[0];
            a8 = args[1];
        } else if (a6.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            Term[] args = {a7, a8};
            if ( !a6.unify(new StructureTerm(f3, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a9 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        Term[] h4 = {a11, a12};
        a10 = new StructureTerm(f3, h4);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        p1 = new Predicates.dollar_dcgTranslateDcg_4(a12, a8, a14, a15, cont);
        p2 = new Predicates.dollar_dcgTranslateDcg_4(a4, a7, a13, a15, p1);
        p3 = new Predicates.dollar_dcgTranslateDcgAtom_4(a11, a5, a13, a14, p2);
        p4 = new Predicates.dollar_cut_1(a9, p3);
        p5 = new Predicates.dollar_unify_2(a3, a10, p4);
        p6 = new Predicates.dollar_nonvar_1(a3, p5);
        return new Predicates.dollar_getLevel_1(a9, p6);
    }
}

sealed class dollar_dcgExpansion_2_3 : dollar_dcgExpansion_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("-->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol(":-", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_dcgTranslateDcg_4(a4, a6, a7, a8, cont);
        return new Predicates.dollar_dcgTranslateDcgAtom_4(a3, a5, a7, a8, p1);
    }
}
}

