/*
 * *** Please do not edit ! ***
 * @(#) dollar_rightType_2.cs
 * @procedure $right_type/2 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_rightType_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_rightType_2_1 = new Predicates.dollar_rightType_2_1();
    static internal readonly Predicate dollar_rightType_2_2 = new Predicates.dollar_rightType_2_2();
    static internal readonly Predicate dollar_rightType_2_3 = new Predicates.dollar_rightType_2_3();
    static internal readonly Predicate dollar_rightType_2_4 = new Predicates.dollar_rightType_2_4();
    static internal readonly Predicate dollar_rightType_2_5 = new Predicates.dollar_rightType_2_5();
    static internal readonly Predicate dollar_rightType_2_6 = new Predicates.dollar_rightType_2_6();
    static internal readonly Predicate dollar_rightType_2_var = new Predicates.dollar_rightType_2_var();

    public Term arg1, arg2;

    public dollar_rightType_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_rightType_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_rightType_2_var,
                                   dollar_fail_0,
                                   dollar_rightType_2_var,
                                   dollar_fail_0,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$right_type(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_rightType_2_var : dollar_rightType_2 {
    static internal readonly Predicate dollar_rightType_2_var_1 = new Predicates.dollar_rightType_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_rightType_2_1, dollar_rightType_2_var_1);
    }
}

sealed class dollar_rightType_2_var_1 : dollar_rightType_2 {
    static internal readonly Predicate dollar_rightType_2_var_2 = new Predicates.dollar_rightType_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_rightType_2_2, dollar_rightType_2_var_2);
    }
}

sealed class dollar_rightType_2_var_2 : dollar_rightType_2 {
    static internal readonly Predicate dollar_rightType_2_var_3 = new Predicates.dollar_rightType_2_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_rightType_2_3, dollar_rightType_2_var_3);
    }
}

sealed class dollar_rightType_2_var_3 : dollar_rightType_2 {
    static internal readonly Predicate dollar_rightType_2_var_4 = new Predicates.dollar_rightType_2_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_rightType_2_4, dollar_rightType_2_var_4);
    }
}

sealed class dollar_rightType_2_var_4 : dollar_rightType_2 {
    static internal readonly Predicate dollar_rightType_2_var_5 = new Predicates.dollar_rightType_2_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_rightType_2_5, dollar_rightType_2_var_5);
    }
}

sealed class dollar_rightType_2_var_5 : dollar_rightType_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_rightType_2_6);
    }
}

sealed class dollar_rightType_2_1 : dollar_rightType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("term");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return cont;
    }
}

sealed class dollar_rightType_2_2 : dollar_rightType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("atom");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_atom_1(a2, cont);
    }
}

sealed class dollar_rightType_2_3 : dollar_rightType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("atomic");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_atomic_1(a2, cont);
    }
}

sealed class dollar_rightType_2_4 : dollar_rightType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("number");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.Number_1(a2, cont);
    }
}

sealed class dollar_rightType_2_5 : dollar_rightType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("integer");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_integer_1(a2, cont);
    }
}

sealed class dollar_rightType_2_6 : dollar_rightType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("float");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.Float_1(a2, cont);
    }
}
}

