/*
 * *** Please do not edit ! ***
 * @(#) dollar_termToList_4.cs
 * @procedure $term_to_list/4 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_termToList_4 : Predicate {
    static internal readonly Predicate dollar_termToList_4_1 = new Predicates.dollar_termToList_4_1();
    static internal readonly Predicate dollar_termToList_4_2 = new Predicates.dollar_termToList_4_2();
    static internal readonly Predicate dollar_termToList_4_sub_1 = new Predicates.dollar_termToList_4_sub_1();

    public Term arg1, arg2, arg3, arg4;

    public dollar_termToList_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_termToList_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_termToList_4_1, dollar_termToList_4_sub_1);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$term_to_list(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_termToList_4_sub_1 : dollar_termToList_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_termToList_4_2);
    }
}

sealed class dollar_termToList_4_1 : dollar_termToList_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a4, engine.trail) ) return engine.fail();
        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.dollar_greaterThan_2(a2, a3, p1);
        return new Predicates.dollar_getLevel_1(a5, p2);
    }
}

sealed class dollar_termToList_4_2 : dollar_termToList_4 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a4.isList() ){
            a5 = ((ListTerm)a4).car;
            a6 = ((ListTerm)a4).cdr;
        } else if ( a4.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_termToList_4(a1, a7, a3, a6, cont);
        p2 = new Predicates.dollar_plus_3(a2, s1, a7, p1);
        return new Predicates.dollar_arg_3(a2, a1, a5, p2);
    }
}
}

