/*
 * *** Please do not edit ! ***
 * @(#) scolon_2.cs
 * @procedure ;/2 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class scolon_2 : Predicate {
    static internal readonly Predicate scolon_2_1 = new Predicates.scolon_2_1();
    static internal readonly Predicate scolon_2_2 = new Predicates.scolon_2_2();
    static internal readonly Predicate scolon_2_3 = new Predicates.scolon_2_3();
    static internal readonly Predicate scolon_2_con = new Predicates.scolon_2_con();
    static internal readonly Predicate scolon_2_int = new Predicates.scolon_2_int();
    static internal readonly Predicate scolon_2_lis = new Predicates.scolon_2_lis();
    static internal readonly Predicate scolon_2_var = new Predicates.scolon_2_var();

    public Term arg1, arg2;

    public scolon_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public scolon_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   scolon_2_var,
                                   scolon_2_int,
                                   scolon_2_con,
                                   scolon_2_var,
                                   scolon_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return ";(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class scolon_2_var : scolon_2 {
    static internal readonly Predicate scolon_2_var_1 = new Predicates.scolon_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(scolon_2_1, scolon_2_var_1);
    }
}

sealed class scolon_2_var_1 : scolon_2 {
    static internal readonly Predicate scolon_2_var_2 = new Predicates.scolon_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(scolon_2_2, scolon_2_var_2);
    }
}

sealed class scolon_2_var_2 : scolon_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(scolon_2_3);
    }
}

sealed class scolon_2_int : scolon_2 {
    static internal readonly Predicate scolon_2_int_1 = new Predicates.scolon_2_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(scolon_2_2, scolon_2_int_1);
    }
}

sealed class scolon_2_int_1 : scolon_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(scolon_2_3);
    }
}

sealed class scolon_2_con : scolon_2 {
    static internal readonly Predicate scolon_2_con_1 = new Predicates.scolon_2_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(scolon_2_2, scolon_2_con_1);
    }
}

sealed class scolon_2_con_1 : scolon_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(scolon_2_3);
    }
}

sealed class scolon_2_lis : scolon_2 {
    static internal readonly Predicate scolon_2_lis_1 = new Predicates.scolon_2_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(scolon_2_2, scolon_2_lis_1);
    }
}

sealed class scolon_2_lis_1 : scolon_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(scolon_2_3);
    }
}

sealed class scolon_2_1 : scolon_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_ifThenElse_3(a3, a4, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class scolon_2_2 : scolon_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_call_1(a1, cont);
    }
}

sealed class scolon_2_3 : scolon_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_call_1(a2, cont);
    }
}
}

