/*
 * *** Please do not edit ! ***
 * @(#) Clause_3.cs
 * @procedure clause/3 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Clause_3 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);

    public Term arg1, arg2, arg3;

    public Clause_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public Clause_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();

        Term[] h2 = {a2, a3};
        a4 = new StructureTerm(f1, h2);
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a6, a9, cont);
        p2 = new Predicates.dollar_memberInReverse_2(a9, a8, p1);
        p3 = new Predicates.dollar_copyTerm_2(a7, a8, p2);
        p4 = new Predicates.dollar_getTerm_3(a1, a5, a7, p3);
        return new Predicates.dollar_canonicalClause_3(a4, a5, a6, p4);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "clause(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}
}

