/*
 * *** Please do not edit ! ***
 * @(#) Sort_2.cs
 * @procedure sort/2 in built.pl
 */

/*
 * @version P# 0.1, on April 10 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Sort_2 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate Sort_2_1 = new Predicates.Sort_2_1();
    static internal readonly Predicate Sort_2_2 = new Predicates.Sort_2_2();
    static internal readonly Predicate Sort_2_var = new Predicates.Sort_2_var();

    public Term arg1, arg2;

    public Sort_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public Sort_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   Sort_2_var,
                                   dollar_fail_0,
                                   Sort_2_1,
                                   dollar_fail_0,
                                   Sort_2_2
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "sort(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class Sort_2_var : Sort_2 {
    static internal readonly Predicate Sort_2_var_1 = new Predicates.Sort_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(Sort_2_1, Sort_2_var_1);
    }
}

sealed class Sort_2_var_1 : Sort_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Sort_2_2);
    }
}

sealed class Sort_2_1 : Sort_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class Sort_2_2 : Sort_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a3 = ((ListTerm)a1).car;
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = new ListTerm(a3, a8);
        p1 = new Predicates.dollar_append_3(a7, a9, a2, cont);
        p2 = new Predicates.Sort_2(a6, a8, p1);
        p3 = new Predicates.Sort_2(a5, a7, p2);
        return new Predicates.dollar_partition_4(a3, a4, a5, a6, p3);
    }
}
}

