/*
 * *** Please do not edit ! ***
 * @(#) dollar_atomType_2.cs
 * @procedure $atom_type/2 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_atomType_2 : Predicate {
    static internal readonly Predicate dollar_atomType_2_1 = new Predicates.dollar_atomType_2_1();
    static internal readonly Predicate dollar_atomType_2_2 = new Predicates.dollar_atomType_2_2();
    static internal readonly Predicate dollar_atomType_2_3 = new Predicates.dollar_atomType_2_3();
    static internal readonly Predicate dollar_atomType_2_4 = new Predicates.dollar_atomType_2_4();
    static internal readonly Predicate dollar_atomType_2_sub_1 = new Predicates.dollar_atomType_2_sub_1();

    public Term arg1, arg2;

    public dollar_atomType_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_atomType_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_atomType_2_1, dollar_atomType_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$atom_type(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_atomType_2_sub_1 : dollar_atomType_2 {
    static internal readonly Predicate dollar_atomType_2_sub_2 = new Predicates.dollar_atomType_2_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_atomType_2_2, dollar_atomType_2_sub_2);
    }
}

sealed class dollar_atomType_2_sub_2 : dollar_atomType_2 {
    static internal readonly Predicate dollar_atomType_2_sub_3 = new Predicates.dollar_atomType_2_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_atomType_2_3, dollar_atomType_2_sub_3);
    }
}

sealed class dollar_atomType_2_sub_3 : dollar_atomType_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_atomType_2_4);
    }
}

sealed class dollar_atomType_2_1 : dollar_atomType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("alpha");
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_atomType0_2(a1, s2, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}

sealed class dollar_atomType_2_2 : dollar_atomType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("symbol");
    static internal readonly IntegerTerm s2 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_atomType0_2(a1, s2, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}

sealed class dollar_atomType_2_3 : dollar_atomType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("punct");
    static internal readonly IntegerTerm s2 = new IntegerTerm(2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_atomType0_2(a1, s2, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}

sealed class dollar_atomType_2_4 : dollar_atomType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("other");
    static internal readonly IntegerTerm s2 = new IntegerTerm(3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_atomType0_2(a1, s2, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}
}

