/*
 * *** Please do not edit ! ***
 * @(#) dollar_fopen_3.cs
 * @procedure $fopen/3 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_fopen_3 : Predicate {
    static internal readonly Predicate dollar_fopen_3_1 = new Predicates.dollar_fopen_3_1();
    static internal readonly Predicate dollar_fopen_3_2 = new Predicates.dollar_fopen_3_2();
    static internal readonly Predicate dollar_fopen_3_sub_1 = new Predicates.dollar_fopen_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_fopen_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_fopen_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_fopen_3_1, dollar_fopen_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$fopen(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_fopen_3_sub_1 : dollar_fopen_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_fopen_3_2);
    }
}

sealed class dollar_fopen_3_1 : dollar_fopen_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a3, a5, cont);
        p2 = new Predicates.dollar_cut_1(a4, p1);
        p3 = new Predicates.dollar_open_3(a1, a2, a5, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_fopen_3_2 : dollar_fopen_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("permission", 4);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("open");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("file");
    static internal readonly IntegerTerm s4 = new IntegerTerm(0);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("open", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        Term[] h5 = {s2, s3, a1, s4};
        a4 = new StructureTerm(f1, h5);
        Term[] h7 = {a1, a2, a3};
        a5 = new StructureTerm(f6, h7);
        return new Predicates.dollar_illarg_3(a4, a5, s4, cont);
    }
}
}

