/*
 * *** Please do not edit ! ***
 * @(#) dollar_op3_3.cs
 * @procedure $op3/3 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_op3_3 : Predicate {
    static internal readonly Predicate dollar_op3_3_1 = new Predicates.dollar_op3_3_1();
    static internal readonly Predicate dollar_op3_3_2 = new Predicates.dollar_op3_3_2();
    static internal readonly Predicate dollar_op3_3_sub_1 = new Predicates.dollar_op3_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_op3_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_op3_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_op3_3_1, dollar_op3_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$op3(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_op3_3_sub_1 : dollar_op3_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_op3_3_2);
    }
}

sealed class dollar_op3_3_1 : dollar_op3_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_retractOpts_2(a1, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_op3_3_2 : dollar_op3_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_assertOpts_3(a1, a2, a3, cont);
    }
}
}

