/*
 * *** Please do not edit ! ***
 * @(#) dollar_parseTokensPostInOps_7.cs
 * @procedure $parse_tokens_post_in_ops/7 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_parseTokensPostInOps_7 : Predicate {
    static internal readonly Predicate dollar_parseTokensPostInOps_7_1 = new Predicates.dollar_parseTokensPostInOps_7_1();
    static internal readonly Predicate dollar_parseTokensPostInOps_7_2 = new Predicates.dollar_parseTokensPostInOps_7_2();
    static internal readonly Predicate dollar_parseTokensPostInOps_7_sub_1 = new Predicates.dollar_parseTokensPostInOps_7_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6, arg7;

    public dollar_parseTokensPostInOps_7(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Term a7, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        arg7 = a7; 
        this.cont = cont;
    }

    public dollar_parseTokensPostInOps_7(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        arg7 = args[6]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.aregs[7] = arg7;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_parseTokensPostInOps_7_1, dollar_parseTokensPostInOps_7_sub_1);
    }

    public override int arity() { return 7; }

    public override string ToString() {
        return "$parse_tokens_post_in_ops(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ", " + arg7 + ")";
    }
}

sealed class dollar_parseTokensPostInOps_7_sub_1 : dollar_parseTokensPostInOps_7 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_parseTokensPostInOps_7_2);
    }
}

sealed class dollar_parseTokensPostInOps_7_1 : dollar_parseTokensPostInOps_7 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        p1 = new Predicates.dollar_parseTokensPostInOps_7(a1, a11, a12, a4, a5, a13, a7, cont);
        p2 = new Predicates.dollar_parseTokensOp_8(a9, a1, a2, a3, a11, a12, a10, a13, p1);
        p3 = new Predicates._C_3(a8, a9, a10, p2);
        return new Predicates.dollar_parseTokensSkipSpaces_2(a6, a8, p3);
    }
}

sealed class dollar_parseTokensPostInOps_7_2 : dollar_parseTokensPostInOps_7 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        a7 = engine.aregs[7].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a4, engine.trail) ) return engine.fail();
        if ( !a3.unify(a5, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a7, a6, cont);
        return new Predicates.dollar_lessOrEqual_2(a3, a1, p1);
    }
}
}

