/*
 * *** Please do not edit ! ***
 * @(#) dollar_readToken1_3.cs
 * @procedure $read_token1/3 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_readToken1_3 : Predicate {
    static internal readonly Predicate dollar_readToken1_3_1 = new Predicates.dollar_readToken1_3_1();
    static internal readonly Predicate dollar_readToken1_3_2 = new Predicates.dollar_readToken1_3_2();
    static internal readonly Predicate dollar_readToken1_3_3 = new Predicates.dollar_readToken1_3_3();
    static internal readonly Predicate dollar_readToken1_3_4 = new Predicates.dollar_readToken1_3_4();
    static internal readonly Predicate dollar_readToken1_3_5 = new Predicates.dollar_readToken1_3_5();
    static internal readonly Predicate dollar_readToken1_3_6 = new Predicates.dollar_readToken1_3_6();
    static internal readonly Predicate dollar_readToken1_3_var = new Predicates.dollar_readToken1_3_var();

    public Term arg1, arg2, arg3;

    public dollar_readToken1_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_readToken1_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_readToken1_3_var,
                                   dollar_readToken1_3_6,
                                   dollar_readToken1_3_6,
                                   dollar_readToken1_3_6,
                                   dollar_readToken1_3_var
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$read_token1(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_readToken1_3_var : dollar_readToken1_3 {
    static internal readonly Predicate dollar_readToken1_3_var_1 = new Predicates.dollar_readToken1_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_readToken1_3_1, dollar_readToken1_3_var_1);
    }
}

sealed class dollar_readToken1_3_var_1 : dollar_readToken1_3 {
    static internal readonly Predicate dollar_readToken1_3_var_2 = new Predicates.dollar_readToken1_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readToken1_3_2, dollar_readToken1_3_var_2);
    }
}

sealed class dollar_readToken1_3_var_2 : dollar_readToken1_3 {
    static internal readonly Predicate dollar_readToken1_3_var_3 = new Predicates.dollar_readToken1_3_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readToken1_3_3, dollar_readToken1_3_var_3);
    }
}

sealed class dollar_readToken1_3_var_3 : dollar_readToken1_3 {
    static internal readonly Predicate dollar_readToken1_3_var_4 = new Predicates.dollar_readToken1_3_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readToken1_3_4, dollar_readToken1_3_var_4);
    }
}

sealed class dollar_readToken1_3_var_4 : dollar_readToken1_3 {
    static internal readonly Predicate dollar_readToken1_3_var_5 = new Predicates.dollar_readToken1_3_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_readToken1_3_5, dollar_readToken1_3_var_5);
    }
}

sealed class dollar_readToken1_3_var_5 : dollar_readToken1_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readToken1_3_6);
    }
}

sealed class dollar_readToken1_3_1 : dollar_readToken1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(-2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("error", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s3.unify(a1, engine.trail) ) return engine.fail();
        if ( a3.isStructure() ){
            if (f4 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a2.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a3.isVariable() ){
            Term[] args = {a2};
            if ( !a3.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readToken1_3_2 : dollar_readToken1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(73);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("number", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s3.unify(a1, engine.trail) ) return engine.fail();
        if ( a3.isStructure() ){
            if (f4 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a2.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a3.isVariable() ){
            Term[] args = {a2};
            if ( !a3.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readToken1_3_3 : dollar_readToken1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(65);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("atom", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s3.unify(a1, engine.trail) ) return engine.fail();
        if ( a3.isStructure() ){
            if (f4 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a2.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a3.isVariable() ){
            Term[] args = {a2};
            if ( !a3.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readToken1_3_4 : dollar_readToken1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(86);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("var", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s3.unify(a1, engine.trail) ) return engine.fail();
        if ( a3.isStructure() ){
            if (f4 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a2.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a3.isVariable() ){
            Term[] args = {a2};
            if ( !a3.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_readToken1_3_5 : dollar_readToken1_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(83);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s3 = new ListTerm(s1, s2);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("string", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s3.unify(a1, engine.trail) ) return engine.fail();
        if ( a3.isStructure() ){
            if (f4 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            a4 = args[0];
        } else if (a3.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a3.unify(new StructureTerm(f4, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.Name_2(a2, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_readToken1_3_6 : dollar_readToken1_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}
}

