/*
 * *** Please do not edit ! ***
 * @(#) dollar_readint_2.cs
 * @procedure $readint/2 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_readint_2 : Predicate {
    static internal readonly Predicate dollar_readint_2_1 = new Predicates.dollar_readint_2_1();
    static internal readonly Predicate dollar_readint_2_2 = new Predicates.dollar_readint_2_2();
    static internal readonly Predicate dollar_readint_2_sub_1 = new Predicates.dollar_readint_2_sub_1();

    public Term arg1, arg2;

    public dollar_readint_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_readint_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_readint_2_1, dollar_readint_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$readint(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_readint_2_sub_1 : dollar_readint_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_readint_2_2);
    }
}

sealed class dollar_readint_2_1 : dollar_readint_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(45);
    static internal readonly IntegerTerm s2 = new IntegerTerm(0);
    static internal readonly IntegerTerm s3 = new IntegerTerm(-1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        p1 = new Predicates.dollar_multi_3(s3, a5, a2, cont);
        p2 = new Predicates.dollar_readint1_3(a4, s2, a5, p1);
        p3 = new Predicates.dollar_get0_1(a4, p2);
        p4 = new Predicates.dollar_cut_1(a3, p3);
        p5 = new Predicates.dollar_arithEqual_2(a1, s1, p4);
        return new Predicates.dollar_getLevel_1(a3, p5);
    }
}

sealed class dollar_readint_2_2 : dollar_readint_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_readint1_3(a1, s1, a2, cont);
    }
}
}

