/*
 * *** Please do not edit ! ***
 * @(#) dollar_skipSpaces1_2.cs
 * @procedure $skip_spaces1/2 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_skipSpaces1_2 : Predicate {
    static internal readonly Predicate dollar_skipSpaces1_2_1 = new Predicates.dollar_skipSpaces1_2_1();
    static internal readonly Predicate dollar_skipSpaces1_2_2 = new Predicates.dollar_skipSpaces1_2_2();
    static internal readonly Predicate dollar_skipSpaces1_2_3 = new Predicates.dollar_skipSpaces1_2_3();
    static internal readonly Predicate dollar_skipSpaces1_2_4 = new Predicates.dollar_skipSpaces1_2_4();
    static internal readonly Predicate dollar_skipSpaces1_2_5 = new Predicates.dollar_skipSpaces1_2_5();
    static internal readonly Predicate dollar_skipSpaces1_2_6 = new Predicates.dollar_skipSpaces1_2_6();
    static internal readonly Predicate dollar_skipSpaces1_2_var = new Predicates.dollar_skipSpaces1_2_var();

    public Term arg1, arg2;

    public dollar_skipSpaces1_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_skipSpaces1_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_skipSpaces1_2_var,
                                   dollar_skipSpaces1_2_var,
                                   dollar_skipSpaces1_2_6,
                                   dollar_skipSpaces1_2_6,
                                   dollar_skipSpaces1_2_6
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$skip_spaces1(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_skipSpaces1_2_var : dollar_skipSpaces1_2 {
    static internal readonly Predicate dollar_skipSpaces1_2_var_1 = new Predicates.dollar_skipSpaces1_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_skipSpaces1_2_1, dollar_skipSpaces1_2_var_1);
    }
}

sealed class dollar_skipSpaces1_2_var_1 : dollar_skipSpaces1_2 {
    static internal readonly Predicate dollar_skipSpaces1_2_var_2 = new Predicates.dollar_skipSpaces1_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_skipSpaces1_2_2, dollar_skipSpaces1_2_var_2);
    }
}

sealed class dollar_skipSpaces1_2_var_2 : dollar_skipSpaces1_2 {
    static internal readonly Predicate dollar_skipSpaces1_2_var_3 = new Predicates.dollar_skipSpaces1_2_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_skipSpaces1_2_3, dollar_skipSpaces1_2_var_3);
    }
}

sealed class dollar_skipSpaces1_2_var_3 : dollar_skipSpaces1_2 {
    static internal readonly Predicate dollar_skipSpaces1_2_var_4 = new Predicates.dollar_skipSpaces1_2_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_skipSpaces1_2_4, dollar_skipSpaces1_2_var_4);
    }
}

sealed class dollar_skipSpaces1_2_var_4 : dollar_skipSpaces1_2 {
    static internal readonly Predicate dollar_skipSpaces1_2_var_5 = new Predicates.dollar_skipSpaces1_2_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_skipSpaces1_2_5, dollar_skipSpaces1_2_var_5);
    }
}

sealed class dollar_skipSpaces1_2_var_5 : dollar_skipSpaces1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_skipSpaces1_2_6);
    }
}

sealed class dollar_skipSpaces1_2_1 : dollar_skipSpaces1_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(9);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_skipSpaces_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_skipSpaces1_2_2 : dollar_skipSpaces1_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_skipSpaces_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_skipSpaces1_2_3 : dollar_skipSpaces1_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(12);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_skipSpaces_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_skipSpaces1_2_4 : dollar_skipSpaces1_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(13);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_skipSpaces_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_skipSpaces1_2_5 : dollar_skipSpaces1_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(32);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_skipSpaces_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_skipSpaces1_2_6 : dollar_skipSpaces1_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !a1.unify(a2, engine.trail) ) return engine.fail();
        return cont;
    }
}
}

