/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeIsOperator_4.cs
 * @procedure $write_is_operator/4 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeIsOperator_4 : Predicate {

    public Term arg1, arg2, arg3, arg4;

    public dollar_writeIsOperator_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_writeIsOperator_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        a5 = engine.makeVariable();
        a6 = engine.makeVariable();
        a7 = new ListTerm(engine.makeVariable(), a3);
        p1 = new Predicates.dollar_cut_1(a5, cont);
        p2 = new Predicates.eq_stop_stop_2(a1, a7, p1);
        p3 = new Predicates.CurrentOp_3(engine.makeVariable(), a4, a2, p2);
        p4 = new Predicates.dollar_writeOpType_2(a6, a4, p3);
        p5 = new Predicates.dollar_functor_3(a1, a2, a6, p4);
        return new Predicates.dollar_getLevel_1(a5, p5);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$write_is_operator(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

