/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeTermInfixOp_4.cs
 * @procedure $write_term_infix_op/4 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeTermInfixOp_4 : Predicate {
    static internal readonly Predicate dollar_writeTermInfixOp_4_1 = new Predicates.dollar_writeTermInfixOp_4_1();
    static internal readonly Predicate dollar_writeTermInfixOp_4_2 = new Predicates.dollar_writeTermInfixOp_4_2();
    static internal readonly Predicate dollar_writeTermInfixOp_4_var = new Predicates.dollar_writeTermInfixOp_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_writeTermInfixOp_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_writeTermInfixOp_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeTermInfixOp_4_var,
                                   dollar_writeTermInfixOp_4_2,
                                   dollar_writeTermInfixOp_4_var,
                                   dollar_writeTermInfixOp_4_2,
                                   dollar_writeTermInfixOp_4_2
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$write_term_infix_op(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_writeTermInfixOp_4_var : dollar_writeTermInfixOp_4 {
    static internal readonly Predicate dollar_writeTermInfixOp_4_var_1 = new Predicates.dollar_writeTermInfixOp_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeTermInfixOp_4_1, dollar_writeTermInfixOp_4_var_1);
    }
}

sealed class dollar_writeTermInfixOp_4_var_1 : dollar_writeTermInfixOp_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeTermInfixOp_4_2);
    }
}

sealed class dollar_writeTermInfixOp_4_1 : dollar_writeTermInfixOp_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol(",");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("punct");
    static internal readonly IntegerTerm s3 = new IntegerTerm(44);
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s5 = new ListTerm(s3, s4);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s2.unify(a3, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_put_1(s5, cont);
        p2 = new Predicates.dollar_writeSpaceIfNeeded_2(a2, s2, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_writeTermInfixOp_4_2 : dollar_writeTermInfixOp_4 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_writeAtom_4(a1, a2, a3, a4, cont);
    }
}
}

