/*
 * *** Please do not edit ! ***
 * @(#) Skip_1.cs
 * @procedure skip/1 in inout.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Skip_1 : Predicate {

    public Term arg1;

    public Skip_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Skip_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2;
        Predicate p1;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_dummyInout__5_2(a1, a2, cont);
        return new Predicates.dollar_is_2(a2, a1, p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "skip(" + arg1 + ")";
    }
}
}

