/*
 * *** Please do not edit ! ***
 * @(#) dollar_checkLeash_1.cs
 * @procedure $check_leash/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_checkLeash_1 : Predicate {
    static internal readonly Predicate dollar_checkLeash_1_1 = new Predicates.dollar_checkLeash_1_1();
    static internal readonly Predicate dollar_checkLeash_1_2 = new Predicates.dollar_checkLeash_1_2();
    static internal readonly Predicate dollar_checkLeash_1_3 = new Predicates.dollar_checkLeash_1_3();
    static internal readonly Predicate dollar_checkLeash_1_con = new Predicates.dollar_checkLeash_1_con();
    static internal readonly Predicate dollar_checkLeash_1_lis = new Predicates.dollar_checkLeash_1_lis();
    static internal readonly Predicate dollar_checkLeash_1_var = new Predicates.dollar_checkLeash_1_var();

    public Term arg1;

    public dollar_checkLeash_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_checkLeash_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_checkLeash_1_var,
                                   dollar_checkLeash_1_2,
                                   dollar_checkLeash_1_con,
                                   dollar_checkLeash_1_2,
                                   dollar_checkLeash_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$check_leash(" + arg1 + ")";
    }
}

sealed class dollar_checkLeash_1_var : dollar_checkLeash_1 {
    static internal readonly Predicate dollar_checkLeash_1_var_1 = new Predicates.dollar_checkLeash_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_checkLeash_1_1, dollar_checkLeash_1_var_1);
    }
}

sealed class dollar_checkLeash_1_var_1 : dollar_checkLeash_1 {
    static internal readonly Predicate dollar_checkLeash_1_var_2 = new Predicates.dollar_checkLeash_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_checkLeash_1_2, dollar_checkLeash_1_var_2);
    }
}

sealed class dollar_checkLeash_1_var_2 : dollar_checkLeash_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_checkLeash_1_3);
    }
}

sealed class dollar_checkLeash_1_con : dollar_checkLeash_1 {
    static internal readonly Predicate dollar_checkLeash_1_con_1 = new Predicates.dollar_checkLeash_1_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_checkLeash_1_1, dollar_checkLeash_1_con_1);
    }
}

sealed class dollar_checkLeash_1_con_1 : dollar_checkLeash_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_checkLeash_1_2);
    }
}

sealed class dollar_checkLeash_1_lis : dollar_checkLeash_1 {
    static internal readonly Predicate dollar_checkLeash_1_lis_1 = new Predicates.dollar_checkLeash_1_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_checkLeash_1_2, dollar_checkLeash_1_lis_1);
    }
}

sealed class dollar_checkLeash_1_lis_1 : dollar_checkLeash_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_checkLeash_1_3);
    }
}

sealed class dollar_checkLeash_1_1 : dollar_checkLeash_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_checkLeash_1_2 : dollar_checkLeash_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a2, cont);
        p2 = new Predicates.dollar_leashMode_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a2, p2);
    }
}

sealed class dollar_checkLeash_1_3 : dollar_checkLeash_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a2 = ((ListTerm)a1).car;
            a3 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a2, a3), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_checkLeash_1(a3, cont);
        return new Predicates.dollar_leashMode_1(a2, p1);
    }
}
}

