/*
 * *** Please do not edit ! ***
 * @(#) dollar_reduce_1.cs
 * @procedure $reduce/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_reduce_1 : Predicate {
    static internal readonly Predicate dollar_ancestor_2_res0 = new Resources.resource_0_Interpreter_dollar_ancestor_2();
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$ancestor", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$reduce", 1);

    public Term arg1;

    public dollar_reduce_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_reduce_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = arg1.dereference();

        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        a4 = engine.makeVariable();
        Term[] h3 = {a1};
        a6 = new StructureTerm(f2, h3);
        Term[] h4 = {a6, a2};
        a5 = new StructureTerm(f1, h4);
        Term[] h5 = {a2, a1};
        a7 = new ClosureTerm( dollar_ancestor_2_res0, h5);
        a8 = engine.makeVariable();
        p1 = new Predicates.dollar_endExpImp_2(a4, a8, cont);
        p2 = new Predicates.dollar_solve_1(a3, p1);
        p3 = new Predicates.dollar_midExpImp_1(a8, p2);
        p4 = new Predicates.dollar_addExpRes_2(a5, a7, p3);
        p5 = new Predicates.dollar_beginImp_1(a4, p4);
        p6 = new Predicates.Clause_2(a1, a3, p5);
        return new Predicates.dollar_getLevel_1(a2, p6);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$reduce(" + arg1 + ")";
    }
}
}

