/*
 * *** Please do not edit ! ***
 * @(#) dollar_solve_1.cs
 * @procedure $solve/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_solve_1 : Predicate {
    static internal readonly Predicate dollar_solve_1_1 = new Predicates.dollar_solve_1_1();
    static internal readonly Predicate dollar_solve_1_2 = new Predicates.dollar_solve_1_2();
    static internal readonly Predicate dollar_solve_1_3 = new Predicates.dollar_solve_1_3();
    static internal readonly Predicate dollar_solve_1_4 = new Predicates.dollar_solve_1_4();
    static internal readonly Predicate dollar_solve_1_5 = new Predicates.dollar_solve_1_5();
    static internal readonly Predicate dollar_solve_1_6 = new Predicates.dollar_solve_1_6();
    static internal readonly Predicate dollar_solve_1_7 = new Predicates.dollar_solve_1_7();
    static internal readonly Predicate dollar_solve_1_8 = new Predicates.dollar_solve_1_8();
    static internal readonly Predicate dollar_solve_1_9 = new Predicates.dollar_solve_1_9();
    static internal readonly Predicate dollar_solve_1_10 = new Predicates.dollar_solve_1_10();
    static internal readonly Predicate dollar_solve_1_11 = new Predicates.dollar_solve_1_11();
    static internal readonly Predicate dollar_solve_1_12 = new Predicates.dollar_solve_1_12();
    static internal readonly Predicate dollar_solve_1_13 = new Predicates.dollar_solve_1_13();
    static internal readonly Predicate dollar_solve_1_14 = new Predicates.dollar_solve_1_14();
    static internal readonly Predicate dollar_solve_1_con = new Predicates.dollar_solve_1_con();
    static internal readonly Predicate dollar_solve_1_int = new Predicates.dollar_solve_1_int();
    static internal readonly Predicate dollar_solve_1_lis = new Predicates.dollar_solve_1_lis();
    static internal readonly Predicate dollar_solve_1_str = new Predicates.dollar_solve_1_str();
    static internal readonly Predicate dollar_solve_1_var = new Predicates.dollar_solve_1_var();

    public Term arg1;

    public dollar_solve_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_solve_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_solve_1_var,
                                   dollar_solve_1_int,
                                   dollar_solve_1_con,
                                   dollar_solve_1_str,
                                   dollar_solve_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$solve(" + arg1 + ")";
    }
}

sealed class dollar_solve_1_var : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_1 = new Predicates.dollar_solve_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_solve_1_1, dollar_solve_1_var_1);
    }
}

sealed class dollar_solve_1_var_1 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_2 = new Predicates.dollar_solve_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_2, dollar_solve_1_var_2);
    }
}

sealed class dollar_solve_1_var_2 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_3 = new Predicates.dollar_solve_1_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_3, dollar_solve_1_var_3);
    }
}

sealed class dollar_solve_1_var_3 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_4 = new Predicates.dollar_solve_1_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_4, dollar_solve_1_var_4);
    }
}

sealed class dollar_solve_1_var_4 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_5 = new Predicates.dollar_solve_1_var_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_5, dollar_solve_1_var_5);
    }
}

sealed class dollar_solve_1_var_5 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_6 = new Predicates.dollar_solve_1_var_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_6, dollar_solve_1_var_6);
    }
}

sealed class dollar_solve_1_var_6 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_7 = new Predicates.dollar_solve_1_var_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_7, dollar_solve_1_var_7);
    }
}

sealed class dollar_solve_1_var_7 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_8 = new Predicates.dollar_solve_1_var_8();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_8, dollar_solve_1_var_8);
    }
}

sealed class dollar_solve_1_var_8 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_9 = new Predicates.dollar_solve_1_var_9();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_9, dollar_solve_1_var_9);
    }
}

sealed class dollar_solve_1_var_9 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_10 = new Predicates.dollar_solve_1_var_10();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_10, dollar_solve_1_var_10);
    }
}

sealed class dollar_solve_1_var_10 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_11 = new Predicates.dollar_solve_1_var_11();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_11, dollar_solve_1_var_11);
    }
}

sealed class dollar_solve_1_var_11 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_12 = new Predicates.dollar_solve_1_var_12();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_12, dollar_solve_1_var_12);
    }
}

sealed class dollar_solve_1_var_12 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_var_13 = new Predicates.dollar_solve_1_var_13();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_13, dollar_solve_1_var_13);
    }
}

sealed class dollar_solve_1_var_13 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_solve_1_14);
    }
}

sealed class dollar_solve_1_int : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_int_1 = new Predicates.dollar_solve_1_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_solve_1_13, dollar_solve_1_int_1);
    }
}

sealed class dollar_solve_1_int_1 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_solve_1_14);
    }
}

sealed class dollar_solve_1_con : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_con_1 = new Predicates.dollar_solve_1_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_solve_1_1, dollar_solve_1_con_1);
    }
}

sealed class dollar_solve_1_con_1 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_con_2 = new Predicates.dollar_solve_1_con_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_2, dollar_solve_1_con_2);
    }
}

sealed class dollar_solve_1_con_2 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_con_3 = new Predicates.dollar_solve_1_con_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_3, dollar_solve_1_con_3);
    }
}

sealed class dollar_solve_1_con_3 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_con_4 = new Predicates.dollar_solve_1_con_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_13, dollar_solve_1_con_4);
    }
}

sealed class dollar_solve_1_con_4 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_solve_1_14);
    }
}

sealed class dollar_solve_1_str : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_1 = new Predicates.dollar_solve_1_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_solve_1_4, dollar_solve_1_str_1);
    }
}

sealed class dollar_solve_1_str_1 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_2 = new Predicates.dollar_solve_1_str_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_5, dollar_solve_1_str_2);
    }
}

sealed class dollar_solve_1_str_2 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_3 = new Predicates.dollar_solve_1_str_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_6, dollar_solve_1_str_3);
    }
}

sealed class dollar_solve_1_str_3 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_4 = new Predicates.dollar_solve_1_str_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_7, dollar_solve_1_str_4);
    }
}

sealed class dollar_solve_1_str_4 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_5 = new Predicates.dollar_solve_1_str_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_8, dollar_solve_1_str_5);
    }
}

sealed class dollar_solve_1_str_5 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_6 = new Predicates.dollar_solve_1_str_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_9, dollar_solve_1_str_6);
    }
}

sealed class dollar_solve_1_str_6 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_7 = new Predicates.dollar_solve_1_str_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_10, dollar_solve_1_str_7);
    }
}

sealed class dollar_solve_1_str_7 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_8 = new Predicates.dollar_solve_1_str_8();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_11, dollar_solve_1_str_8);
    }
}

sealed class dollar_solve_1_str_8 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_9 = new Predicates.dollar_solve_1_str_9();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_12, dollar_solve_1_str_9);
    }
}

sealed class dollar_solve_1_str_9 : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_str_10 = new Predicates.dollar_solve_1_str_10();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_solve_1_13, dollar_solve_1_str_10);
    }
}

sealed class dollar_solve_1_str_10 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_solve_1_14);
    }
}

sealed class dollar_solve_1_lis : dollar_solve_1 {
    static internal readonly Predicate dollar_solve_1_lis_1 = new Predicates.dollar_solve_1_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_solve_1_13, dollar_solve_1_lis_1);
    }
}

sealed class dollar_solve_1_lis_1 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_solve_1_14);
    }
}

sealed class dollar_solve_1_1 : dollar_solve_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("true");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_solve_1_2 : dollar_solve_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("!");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$reduce", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        a2 = engine.makeVariable();
        Term[] h3 = {engine.makeVariable()};
        a3 = new StructureTerm(f2, h3);
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_cut_1(a2, p1);
        p3 = new Predicates.dollar_ancestor_2(a3, a4, p2);
        return new Predicates.dollar_getLevel_1(a2, p3);
    }
}

sealed class dollar_solve_1_3 : dollar_solve_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("!");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_solve_1_4 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("not", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_dummyInterpreter__3_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_5 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("\\+", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_dummyInterpreter__4_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_6 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("once", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$solve", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2};
        a3 = new StructureTerm(f2, h3);
        p1 = new Predicates.Once_1(a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_7 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$solve", 1);
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("fail");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2};
        a4 = new StructureTerm(f2, h3);
        Term[] h4 = {a3};
        a5 = new StructureTerm(f2, h4);
        p1 = new Predicates.dollar_ifThenElse_3(a4, a5, s5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_8 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("->", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("$solve", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f2 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
            a5 = args[1];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            Term[] args = {a4, a5};
            if ( !a2.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h4 = {a4};
        a6 = new StructureTerm(f3, h4);
        Term[] h5 = {a5};
        a7 = new StructureTerm(f3, h5);
        Term[] h6 = {a3};
        a8 = new StructureTerm(f3, h6);
        p1 = new Predicates.dollar_ifThenElse_3(a6, a7, a8, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_9 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("findall", 3);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$solve", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
            a4 = args[2];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a2, a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a3};
        a5 = new StructureTerm(f2, h3);
        p1 = new Predicates.Findall_3(a2, a5, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_10 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_solve_1(a3, cont);
        p2 = new Predicates.dollar_solve_1(a2, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_solve_1_11 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_dummyInterpreter__5_2(a2, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_12 : dollar_solve_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("call", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            Term[] args = {a2};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_solve_1(a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_solve_1_13 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_call_1(a1, cont);
    }
}

sealed class dollar_solve_1_14 : dollar_solve_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_reduce_1(a1, cont);
    }
}
}

