/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeClause_1.cs
 * @procedure $write_clause/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeClause_1 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public Term arg1;

    public dollar_writeClause_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeClause_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1;
        Predicate p1;
        a1 = arg1.dereference();

        p1 = new Predicates.dollar_writeClause0_1(a1, cont);
        return new Predicates.Numbervars_3(a1, s1, engine.makeVariable(), p1);
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_clause(" + arg1 + ")";
    }
}
}

