/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeLeashMode_1.cs
 * @procedure $write_leash_mode/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeLeashMode_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_writeLeashMode_1_1 = new Predicates.dollar_writeLeashMode_1_1();
    static internal readonly Predicate dollar_writeLeashMode_1_2 = new Predicates.dollar_writeLeashMode_1_2();
    static internal readonly Predicate dollar_writeLeashMode_1_3 = new Predicates.dollar_writeLeashMode_1_3();
    static internal readonly Predicate dollar_writeLeashMode_1_4 = new Predicates.dollar_writeLeashMode_1_4();
    static internal readonly Predicate dollar_writeLeashMode_1_var = new Predicates.dollar_writeLeashMode_1_var();

    public Term arg1;

    public dollar_writeLeashMode_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_writeLeashMode_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_writeLeashMode_1_var,
                                   dollar_fail_0,
                                   dollar_writeLeashMode_1_var,
                                   dollar_fail_0,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$write_leash_mode(" + arg1 + ")";
    }
}

sealed class dollar_writeLeashMode_1_var : dollar_writeLeashMode_1 {
    static internal readonly Predicate dollar_writeLeashMode_1_var_1 = new Predicates.dollar_writeLeashMode_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_writeLeashMode_1_1, dollar_writeLeashMode_1_var_1);
    }
}

sealed class dollar_writeLeashMode_1_var_1 : dollar_writeLeashMode_1 {
    static internal readonly Predicate dollar_writeLeashMode_1_var_2 = new Predicates.dollar_writeLeashMode_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeLeashMode_1_2, dollar_writeLeashMode_1_var_2);
    }
}

sealed class dollar_writeLeashMode_1_var_2 : dollar_writeLeashMode_1 {
    static internal readonly Predicate dollar_writeLeashMode_1_var_3 = new Predicates.dollar_writeLeashMode_1_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeLeashMode_1_3, dollar_writeLeashMode_1_var_3);
    }
}

sealed class dollar_writeLeashMode_1_var_3 : dollar_writeLeashMode_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeLeashMode_1_4);
    }
}

sealed class dollar_writeLeashMode_1_1 : dollar_writeLeashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("call");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("Call: ");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.Write_1(s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_writeLeashMode_1_2 : dollar_writeLeashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("exit");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("Exit: ");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.Write_1(s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_writeLeashMode_1_3 : dollar_writeLeashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("redo");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("Redo: ");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.Write_1(s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_writeLeashMode_1_4 : dollar_writeLeashMode_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("fail");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("Fail: ");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.Write_1(s2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}
}

