/*
 * *** Please do not edit ! ***
 * @(#) Cafeteria_0.cs
 * @procedure cafeteria/0 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Cafeteria_0 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("Small Prolog Interpreter");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("| ?- ");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("end_of_file");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("bye");

    public Cafeteria_0(Predicate cont) {
        this.cont = cont;
    }

    public Cafeteria_0(){}
    public override void setArgument(Term[] args, Predicate cont) {
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13, p14;

        a1 = engine.makeVariable();
        a2 = engine.makeVariable();
        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_nl_0(cont);
        p2 = new Predicates.Write_1(s4, p1);
        p3 = new Predicates.dollar_nl_0(p2);
        p4 = new Predicates.dollar_cut_1(a1, p3);
        p5 = new Predicates.dollar_equalityOfTerm_2(a2, s3, p4);
        p6 = new Predicates.dollar_cafeExecute_2(a2, a3, p5);
        p7 = new Predicates.ReadWithVariables_2(a2, a3, p6);
        p8 = new Predicates.dollar_flushOutput_0(p7);
        p9 = new Predicates.Write_1(s2, p8);
        p10 = new Predicates.dollar_dummyInterpreter__0_0(p9);
        p11 = new Predicates.Repeat_0(p10);
        p12 = new Predicates.dollar_nl_0(p11);
        p13 = new Predicates.Write_1(s1, p12);
        p14 = new Predicates.dollar_cafeteriaInit_0(p13);
        return new Predicates.dollar_getLevel_1(a1, p14);
    }

    public override int arity() { return 0; }

    public override string ToString() {
        return "cafeteria";
    }
}
}

