/*
 * *** Please do not edit ! ***
 * @(#) Spy_1.cs
 * @procedure spy/1 in interpreter.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class Spy_1 : Predicate {
    static internal readonly Predicate Spy_1_1 = new Predicates.Spy_1_1();
    static internal readonly Predicate Spy_1_2 = new Predicates.Spy_1_2();
    static internal readonly Predicate Spy_1_var = new Predicates.Spy_1_var();

    public Term arg1;

    public Spy_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public Spy_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   Spy_1_var,
                                   Spy_1_2,
                                   Spy_1_var,
                                   Spy_1_2,
                                   Spy_1_2
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "spy(" + arg1 + ")";
    }
}

sealed class Spy_1_var : Spy_1 {
    static internal readonly Predicate Spy_1_var_1 = new Predicates.Spy_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(Spy_1_1, Spy_1_var_1);
    }
}

sealed class Spy_1_var_1 : Spy_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(Spy_1_2);
    }
}

sealed class Spy_1_1 : Spy_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class Spy_1_2 : Spy_1 {

    public override Predicate exec( Prolog engine ) {
        Term a1;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.Trace_0(cont);
        return new Predicates.dollar_spy_1(a1, p1);
    }
}
}

