/*
 * *** Please do not edit ! ***
 * @(#) dollar_assertDynamicPredicate_1.cs
 * @procedure $assert_dynamic_predicate/1 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assertDynamicPredicate_1 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_assertDynamicPredicate_1_1 = new Predicates.dollar_assertDynamicPredicate_1_1();
    static internal readonly Predicate dollar_assertDynamicPredicate_1_2 = new Predicates.dollar_assertDynamicPredicate_1_2();
    static internal readonly Predicate dollar_assertDynamicPredicate_1_var = new Predicates.dollar_assertDynamicPredicate_1_var();

    public Term arg1;

    public dollar_assertDynamicPredicate_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_assertDynamicPredicate_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_assertDynamicPredicate_1_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_assertDynamicPredicate_1_var,
                                   dollar_fail_0
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$assert_dynamic_predicate(" + arg1 + ")";
    }
}

sealed class dollar_assertDynamicPredicate_1_var : dollar_assertDynamicPredicate_1 {
    static internal readonly Predicate dollar_assertDynamicPredicate_1_var_1 = new Predicates.dollar_assertDynamicPredicate_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertDynamicPredicate_1_1, dollar_assertDynamicPredicate_1_var_1);
    }
}

sealed class dollar_assertDynamicPredicate_1_var_1 : dollar_assertDynamicPredicate_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertDynamicPredicate_1_2);
    }
}

sealed class dollar_assertDynamicPredicate_1_1 : dollar_assertDynamicPredicate_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$dynamic_predicates", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        Term[] h3 = {a2, a3};
        a5 = new StructureTerm(f2, h3);
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.Clause_2(a5, engine.makeVariable(), p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_assertDynamicPredicate_1_2 : dollar_assertDynamicPredicate_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$dynamic_predicates", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2, a3};
        a4 = new StructureTerm(f2, h3);
        return new Predicates.Assert_1(a4, cont);
    }
}
}

