/*
 * *** Please do not edit ! ***
 * @(#) dollar_assertResourcePredicate_1.cs
 * @procedure $assert_resource_predicate/1 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_assertResourcePredicate_1 : Predicate {
    static internal readonly Predicate dollar_assertResourcePredicate_1_1 = new Predicates.dollar_assertResourcePredicate_1_1();
    static internal readonly Predicate dollar_assertResourcePredicate_1_2 = new Predicates.dollar_assertResourcePredicate_1_2();
    static internal readonly Predicate dollar_assertResourcePredicate_1_3 = new Predicates.dollar_assertResourcePredicate_1_3();
    static internal readonly Predicate dollar_assertResourcePredicate_1_con = new Predicates.dollar_assertResourcePredicate_1_con();
    static internal readonly Predicate dollar_assertResourcePredicate_1_int = new Predicates.dollar_assertResourcePredicate_1_int();
    static internal readonly Predicate dollar_assertResourcePredicate_1_lis = new Predicates.dollar_assertResourcePredicate_1_lis();
    static internal readonly Predicate dollar_assertResourcePredicate_1_var = new Predicates.dollar_assertResourcePredicate_1_var();

    public Term arg1;

    public dollar_assertResourcePredicate_1(Term a1, Predicate cont) {
        arg1 = a1; 
        this.cont = cont;
    }

    public dollar_assertResourcePredicate_1(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_assertResourcePredicate_1_var,
                                   dollar_assertResourcePredicate_1_int,
                                   dollar_assertResourcePredicate_1_con,
                                   dollar_assertResourcePredicate_1_var,
                                   dollar_assertResourcePredicate_1_lis
                                   );
    }

    public override int arity() { return 1; }

    public override string ToString() {
        return "$assert_resource_predicate(" + arg1 + ")";
    }
}

sealed class dollar_assertResourcePredicate_1_var : dollar_assertResourcePredicate_1 {
    static internal readonly Predicate dollar_assertResourcePredicate_1_var_1 = new Predicates.dollar_assertResourcePredicate_1_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertResourcePredicate_1_1, dollar_assertResourcePredicate_1_var_1);
    }
}

sealed class dollar_assertResourcePredicate_1_var_1 : dollar_assertResourcePredicate_1 {
    static internal readonly Predicate dollar_assertResourcePredicate_1_var_2 = new Predicates.dollar_assertResourcePredicate_1_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_assertResourcePredicate_1_2, dollar_assertResourcePredicate_1_var_2);
    }
}

sealed class dollar_assertResourcePredicate_1_var_2 : dollar_assertResourcePredicate_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertResourcePredicate_1_3);
    }
}

sealed class dollar_assertResourcePredicate_1_int : dollar_assertResourcePredicate_1 {
    static internal readonly Predicate dollar_assertResourcePredicate_1_int_1 = new Predicates.dollar_assertResourcePredicate_1_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertResourcePredicate_1_2, dollar_assertResourcePredicate_1_int_1);
    }
}

sealed class dollar_assertResourcePredicate_1_int_1 : dollar_assertResourcePredicate_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertResourcePredicate_1_3);
    }
}

sealed class dollar_assertResourcePredicate_1_con : dollar_assertResourcePredicate_1 {
    static internal readonly Predicate dollar_assertResourcePredicate_1_con_1 = new Predicates.dollar_assertResourcePredicate_1_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertResourcePredicate_1_2, dollar_assertResourcePredicate_1_con_1);
    }
}

sealed class dollar_assertResourcePredicate_1_con_1 : dollar_assertResourcePredicate_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertResourcePredicate_1_3);
    }
}

sealed class dollar_assertResourcePredicate_1_lis : dollar_assertResourcePredicate_1 {
    static internal readonly Predicate dollar_assertResourcePredicate_1_lis_1 = new Predicates.dollar_assertResourcePredicate_1_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_assertResourcePredicate_1_2, dollar_assertResourcePredicate_1_lis_1);
    }
}

sealed class dollar_assertResourcePredicate_1_lis_1 : dollar_assertResourcePredicate_1 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_assertResourcePredicate_1_3);
    }
}

sealed class dollar_assertResourcePredicate_1_1 : dollar_assertResourcePredicate_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a2 = args[0];
            a3 = args[1];
        } else if (a1.isVariable() ){
            a2 = engine.makeVariable();
            a3 = engine.makeVariable();
            Term[] args = {a2, a3};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_assertResourcePredicate_1(a3, cont);
        p2 = new Predicates.dollar_assertResourcePredicate_1(a2, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_assertResourcePredicate_1_2 : dollar_assertResourcePredicate_1 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("/", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = engine.makeVariable();
        a4 = engine.makeVariable();
        a5 = engine.makeVariable();
        Term[] h2 = {a4, a5};
        a3 = new StructureTerm(f1, h2);
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_assertPredicate_1(a6, cont);
        p2 = new Predicates.dollar_assertRes_2(a4, a5, p1);
        p3 = new Predicates.dollar_functor_3(a6, a4, a5, p2);
        p4 = new Predicates.dollar_cut_1(a2, p3);
        p5 = new Predicates.dollar_unify_2(a1, a3, p4);
        return new Predicates.dollar_getLevel_1(a2, p5);
    }
}

sealed class dollar_assertResourcePredicate_1_3 : dollar_assertResourcePredicate_1 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("is");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("invalid");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("resource");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("declaration");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly ListTerm s7 = new ListTerm(s3, s6);
    static internal readonly ListTerm s8 = new ListTerm(s2, s7);
    static internal readonly ListTerm s9 = new ListTerm(s1, s8);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        Predicate cont = engine.cont;

        a2 = new ListTerm(a1, s9);
        p1 = new Predicates.dollar_fail_0(cont);
        return new Predicates.dollar_message_1(a2, p1);
    }
}
}

