/*
 * *** Please do not edit ! ***
 * @(#) dollar_binarizeBody_3.cs
 * @procedure $binarize_body/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_binarizeBody_3 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_binarizeBody_3 );
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_binarizeBody_3_1 = new Predicates.dollar_binarizeBody_3_1();
    static internal readonly Predicate dollar_binarizeBody_3_2 = new Predicates.dollar_binarizeBody_3_2();
    static internal readonly Predicate dollar_binarizeBody_3_3 = new Predicates.dollar_binarizeBody_3_3();
    static internal readonly Predicate dollar_binarizeBody_3_lis = new Predicates.dollar_binarizeBody_3_lis();
    static internal readonly Predicate dollar_binarizeBody_3_var = new Predicates.dollar_binarizeBody_3_var();

    public Term arg1, arg2, arg3;

    public dollar_binarizeBody_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_binarizeBody_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_binarizeBody_3_var,
                                   dollar_fail_0,
                                   dollar_binarizeBody_3_1,
                                   dollar_fail_0,
                                   dollar_binarizeBody_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$binarize_body(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_binarizeBody_3_var : dollar_binarizeBody_3 {
    static internal readonly Predicate dollar_binarizeBody_3_var_1 = new Predicates.dollar_binarizeBody_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_binarizeBody_3_1, dollar_binarizeBody_3_var_1);
    }
}

sealed class dollar_binarizeBody_3_var_1 : dollar_binarizeBody_3 {
    static internal readonly Predicate dollar_binarizeBody_3_var_2 = new Predicates.dollar_binarizeBody_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_binarizeBody_3_2, dollar_binarizeBody_3_var_2);
    }
}

sealed class dollar_binarizeBody_3_var_2 : dollar_binarizeBody_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_binarizeBody_3_3);
    }
}

sealed class dollar_binarizeBody_3_lis : dollar_binarizeBody_3 {
    static internal readonly Predicate dollar_binarizeBody_3_lis_1 = new Predicates.dollar_binarizeBody_3_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_binarizeBody_3_2, dollar_binarizeBody_3_lis_1);
    }
}

sealed class dollar_binarizeBody_3_lis_1 : dollar_binarizeBody_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_binarizeBody_3_3);
    }
}

sealed class dollar_binarizeBody_3_1 : dollar_binarizeBody_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("true", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( a3.isStructure() ){
            if (f2 != ((StructureTerm)a3).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a3).args;
            if ( !a2.unify(args[0],  engine.trail) )
                return engine.fail();
        } else if (a3.isVariable() ){
            Term[] args = {a2};
            if ( !a3.unify(new StructureTerm(f2, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_binarizeBody_3_2 : dollar_binarizeBody_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_addCont_3(a4, a2, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_binarizeBody_3_3 : dollar_binarizeBody_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_addCont_3(a4, a6, a3, cont);
        engine.aregs[1] = a5;
        engine.aregs[2] = a2;
        engine.aregs[3] = a6;
        engine.cont = p1;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

