/*
 * *** Please do not edit ! ***
 * @(#) dollar_compileChunk_5.cs
 * @procedure $compile_chunk/5 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_compileChunk_5 : Predicate {
    static internal readonly Predicate dollar_compileChunk_5_1 = new Predicates.dollar_compileChunk_5_1();
    static internal readonly Predicate dollar_compileChunk_5_2 = new Predicates.dollar_compileChunk_5_2();
    static internal readonly Predicate dollar_compileChunk_5_var = new Predicates.dollar_compileChunk_5_var();

    public Term arg1, arg2, arg3, arg4, arg5;

    public dollar_compileChunk_5(Term a1, Term a2, Term a3, Term a4, Term a5, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        this.cont = cont;
    }

    public dollar_compileChunk_5(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_compileChunk_5_var,
                                   dollar_compileChunk_5_2,
                                   dollar_compileChunk_5_var,
                                   dollar_compileChunk_5_2,
                                   dollar_compileChunk_5_2
                                   );
    }

    public override int arity() { return 5; }

    public override string ToString() {
        return "$compile_chunk(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ")";
    }
}

sealed class dollar_compileChunk_5_var : dollar_compileChunk_5 {
    static internal readonly Predicate dollar_compileChunk_5_var_1 = new Predicates.dollar_compileChunk_5_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_compileChunk_5_1, dollar_compileChunk_5_var_1);
    }
}

sealed class dollar_compileChunk_5_var_1 : dollar_compileChunk_5 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_compileChunk_5_2);
    }
}

sealed class dollar_compileChunk_5_1 : dollar_compileChunk_5 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a5, a4, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_compileChunk_5_2 : dollar_compileChunk_5 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        Predicate cont = engine.cont;

        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a13 = new ListTerm(a2, s2);
        a12 = new ListTerm(a8, a13);
        a11 = new ListTerm(a7, a12);
        a10 = new ListTerm(a6, a11);
        p1 = new Predicates.dollar_compChunk_5(a1, a9, a3, a4, a5, cont);
        p2 = new Predicates.dollar_unify_2(a9, a10, p1);
        p3 = new Predicates.dollar_unify_2(a8, s1, p2);
        p4 = new Predicates.dollar_unify_2(a7, s1, p3);
        return new Predicates.dollar_freeXReg_3(a1, s1, a6, p4);
    }
}
}

