/*
 * *** Please do not edit ! ***
 * @(#) dollar_countVariable_3.cs
 * @procedure $count_variable/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_countVariable_3 : Predicate {
    static internal readonly Predicate dollar_countVariable_3_1 = new Predicates.dollar_countVariable_3_1();
    static internal readonly Predicate dollar_countVariable_3_2 = new Predicates.dollar_countVariable_3_2();
    static internal readonly Predicate dollar_countVariable_3_3 = new Predicates.dollar_countVariable_3_3();
    static internal readonly Predicate dollar_countVariable_3_4 = new Predicates.dollar_countVariable_3_4();
    static internal readonly Predicate dollar_countVariable_3_5 = new Predicates.dollar_countVariable_3_5();
    static internal readonly Predicate dollar_countVariable_3_sub_1 = new Predicates.dollar_countVariable_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_countVariable_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_countVariable_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_countVariable_3_1, dollar_countVariable_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$count_variable(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_countVariable_3_sub_1 : dollar_countVariable_3 {
    static internal readonly Predicate dollar_countVariable_3_sub_2 = new Predicates.dollar_countVariable_3_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_countVariable_3_2, dollar_countVariable_3_sub_2);
    }
}

sealed class dollar_countVariable_3_sub_2 : dollar_countVariable_3 {
    static internal readonly Predicate dollar_countVariable_3_sub_3 = new Predicates.dollar_countVariable_3_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_countVariable_3_3, dollar_countVariable_3_sub_3);
    }
}

sealed class dollar_countVariable_3_sub_3 : dollar_countVariable_3 {
    static internal readonly Predicate dollar_countVariable_3_sub_4 = new Predicates.dollar_countVariable_3_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_countVariable_3_4, dollar_countVariable_3_sub_4);
    }
}

sealed class dollar_countVariable_3_sub_4 : dollar_countVariable_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_countVariable_3_5);
    }
}

sealed class dollar_countVariable_3_1 : dollar_countVariable_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_equalityOfTerm_2(a1, a2, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_countVariable_3_2 : dollar_countVariable_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_var_1(a2, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_countVariable_3_3 : dollar_countVariable_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(0);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_atomic_1(a2, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_countVariable_3_4 : dollar_countVariable_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            a5 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_plus_3(a6, a7, a3, cont);
        p2 = new Predicates.dollar_countVariable_3(a1, a5, a7, p1);
        p3 = new Predicates.dollar_countVariable_3(a1, a4, a6, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_countVariable_3_5 : dollar_countVariable_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_countVariable_3(a1, a4, a3, cont);
        return new Predicates.eq_stop_stop_2(a2, a4, p1);
    }
}
}

