/*
 * *** Please do not edit ! ***
 * @(#) dollar_createStrArgs_2.cs
 * @procedure $create_str_args/2 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_createStrArgs_2 : Predicate {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("{");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("};");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s4 = new ListTerm(s2, s3);

    public Term arg1, arg2;

    public dollar_createStrArgs_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_createStrArgs_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = arg1.dereference();
        a2 = arg2.dereference();

        a3 = engine.makeVariable();
        a4 = new ListTerm(s1, a3);
        p1 = new Predicates.dollar_append_3(a4, s4, a2, cont);
        return new Predicates.dollar_createRegArgs_2(a1, a3, p1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$create_str_args(" + arg1 + ", " + arg2 + ")";
    }
}
}

