/*
 * *** Please do not edit ! ***
 * @(#) dollar_decomp__R_2.cs
 * @procedure $decomp_R/2 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_decomp__R_2 : Predicate {
    static internal readonly Predicate dollar_decomp__R_2_1 = new Predicates.dollar_decomp__R_2_1();
    static internal readonly Predicate dollar_decomp__R_2_2 = new Predicates.dollar_decomp__R_2_2();
    static internal readonly Predicate dollar_decomp__R_2_3 = new Predicates.dollar_decomp__R_2_3();
    static internal readonly Predicate dollar_decomp__R_2_con = new Predicates.dollar_decomp__R_2_con();
    static internal readonly Predicate dollar_decomp__R_2_int = new Predicates.dollar_decomp__R_2_int();
    static internal readonly Predicate dollar_decomp__R_2_lis = new Predicates.dollar_decomp__R_2_lis();
    static internal readonly Predicate dollar_decomp__R_2_var = new Predicates.dollar_decomp__R_2_var();

    public Term arg1, arg2;

    public dollar_decomp__R_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_decomp__R_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_decomp__R_2_var,
                                   dollar_decomp__R_2_int,
                                   dollar_decomp__R_2_con,
                                   dollar_decomp__R_2_var,
                                   dollar_decomp__R_2_lis
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$decomp_R(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_decomp__R_2_var : dollar_decomp__R_2 {
    static internal readonly Predicate dollar_decomp__R_2_var_1 = new Predicates.dollar_decomp__R_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_decomp__R_2_1, dollar_decomp__R_2_var_1);
    }
}

sealed class dollar_decomp__R_2_var_1 : dollar_decomp__R_2 {
    static internal readonly Predicate dollar_decomp__R_2_var_2 = new Predicates.dollar_decomp__R_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_decomp__R_2_2, dollar_decomp__R_2_var_2);
    }
}

sealed class dollar_decomp__R_2_var_2 : dollar_decomp__R_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_decomp__R_2_3);
    }
}

sealed class dollar_decomp__R_2_int : dollar_decomp__R_2 {
    static internal readonly Predicate dollar_decomp__R_2_int_1 = new Predicates.dollar_decomp__R_2_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_decomp__R_2_1, dollar_decomp__R_2_int_1);
    }
}

sealed class dollar_decomp__R_2_int_1 : dollar_decomp__R_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_decomp__R_2_3);
    }
}

sealed class dollar_decomp__R_2_con : dollar_decomp__R_2 {
    static internal readonly Predicate dollar_decomp__R_2_con_1 = new Predicates.dollar_decomp__R_2_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_decomp__R_2_1, dollar_decomp__R_2_con_1);
    }
}

sealed class dollar_decomp__R_2_con_1 : dollar_decomp__R_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_decomp__R_2_3);
    }
}

sealed class dollar_decomp__R_2_lis : dollar_decomp__R_2 {
    static internal readonly Predicate dollar_decomp__R_2_lis_1 = new Predicates.dollar_decomp__R_2_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_decomp__R_2_1, dollar_decomp__R_2_lis_1);
    }
}

sealed class dollar_decomp__R_2_lis_1 : dollar_decomp__R_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_decomp__R_2_3);
    }
}

sealed class dollar_decomp__R_2_1 : dollar_decomp__R_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("resource");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("should");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("not");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("be");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("a");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("variable");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s8 = new ListTerm(s6, s7);
    static internal readonly ListTerm s9 = new ListTerm(s5, s8);
    static internal readonly ListTerm s10 = new ListTerm(s4, s9);
    static internal readonly ListTerm s11 = new ListTerm(s3, s10);
    static internal readonly ListTerm s12 = new ListTerm(s2, s11);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        a5 = new ListTerm(a1, s12);
        a4 = new ListTerm(s1, a5);
        p1 = new Predicates.dollar_fail_0(cont);
        p2 = new Predicates.dollar_message_1(a4, p1);
        p3 = new Predicates.dollar_cut_1(a3, p2);
        p4 = new Predicates.dollar_var_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a3, p4);
    }
}

sealed class dollar_decomp__R_2_2 : dollar_decomp__R_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(",", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a2.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_decomp__R_2(a4, a6, cont);
        p2 = new Predicates.dollar_decomp__R_2(a3, a5, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_decomp__R_2_3 : dollar_decomp__R_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        return new Predicates.dollar_decomp__S_2(a1, a2, cont);
    }
}
}

