/*
 * *** Please do not edit ! ***
 * @(#) dollar_genGet_6.cs
 * @procedure $gen_get/6 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genGet_6 : Predicate {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("=", 2);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("[]");

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_genGet_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_genGet_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();
        a5 = arg5.dereference();
        a6 = arg6.dereference();

        Term[] h2 = {a2, a1};
        a8 = new StructureTerm(f1, h2);
        a7 = new ListTerm(a8, s3);
        return new Predicates.dollar_genGet_5(a7, a3, a4, a5, a6, cont);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$gen_get(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}
}

