/*
 * *** Please do not edit ! ***
 * @(#) dollar_genPutArgs_6.cs
 * @procedure $gen_put_args/6 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genPutArgs_6 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_genPutArgs_6_1 = new Predicates.dollar_genPutArgs_6_1();
    static internal readonly Predicate dollar_genPutArgs_6_2 = new Predicates.dollar_genPutArgs_6_2();
    static internal readonly Predicate dollar_genPutArgs_6_var = new Predicates.dollar_genPutArgs_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_genPutArgs_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_genPutArgs_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_genPutArgs_6_var,
                                   dollar_fail_0,
                                   dollar_genPutArgs_6_1,
                                   dollar_fail_0,
                                   dollar_genPutArgs_6_2
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$gen_put_args(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_genPutArgs_6_var : dollar_genPutArgs_6 {
    static internal readonly Predicate dollar_genPutArgs_6_var_1 = new Predicates.dollar_genPutArgs_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_genPutArgs_6_1, dollar_genPutArgs_6_var_1);
    }
}

sealed class dollar_genPutArgs_6_var_1 : dollar_genPutArgs_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genPutArgs_6_2);
    }
}

sealed class dollar_genPutArgs_6_1 : dollar_genPutArgs_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        if ( !a3.unify(a4, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_genPutArgs_6_2 : dollar_genPutArgs_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a2.isList() ){
            a9 = ((ListTerm)a2).car;
            a10 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a9 = engine.makeVariable();
            a10 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a9, a10), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        p1 = new Predicates.dollar_genPutArgs_6(a8, a10, a11, a4, a12, a6, cont);
        return new Predicates.dollar_genPut_6(a7, a9, a3, a11, a5, a12, p1);
    }
}
}

