/*
 * *** Please do not edit ! ***
 * @(#) dollar_genPut_6.cs
 * @procedure $gen_put/6 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_genPut_6 : Predicate {
    static internal readonly Predicate dollar_genPut_6_1 = new Predicates.dollar_genPut_6_1();
    static internal readonly Predicate dollar_genPut_6_2 = new Predicates.dollar_genPut_6_2();
    static internal readonly Predicate dollar_genPut_6_3 = new Predicates.dollar_genPut_6_3();
    static internal readonly Predicate dollar_genPut_6_4 = new Predicates.dollar_genPut_6_4();
    static internal readonly Predicate dollar_genPut_6_5 = new Predicates.dollar_genPut_6_5();
    static internal readonly Predicate dollar_genPut_6_6 = new Predicates.dollar_genPut_6_6();
    static internal readonly Predicate dollar_genPut_6_7 = new Predicates.dollar_genPut_6_7();
    static internal readonly Predicate dollar_genPut_6_8 = new Predicates.dollar_genPut_6_8();
    static internal readonly Predicate dollar_genPut_6_sub_1 = new Predicates.dollar_genPut_6_sub_1();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_genPut_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_genPut_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_genPut_6_1, dollar_genPut_6_sub_1);
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$gen_put(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_genPut_6_sub_1 : dollar_genPut_6 {
    static internal readonly Predicate dollar_genPut_6_sub_2 = new Predicates.dollar_genPut_6_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genPut_6_2, dollar_genPut_6_sub_2);
    }
}

sealed class dollar_genPut_6_sub_2 : dollar_genPut_6 {
    static internal readonly Predicate dollar_genPut_6_sub_3 = new Predicates.dollar_genPut_6_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genPut_6_3, dollar_genPut_6_sub_3);
    }
}

sealed class dollar_genPut_6_sub_3 : dollar_genPut_6 {
    static internal readonly Predicate dollar_genPut_6_sub_4 = new Predicates.dollar_genPut_6_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genPut_6_4, dollar_genPut_6_sub_4);
    }
}

sealed class dollar_genPut_6_sub_4 : dollar_genPut_6 {
    static internal readonly Predicate dollar_genPut_6_sub_5 = new Predicates.dollar_genPut_6_sub_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genPut_6_5, dollar_genPut_6_sub_5);
    }
}

sealed class dollar_genPut_6_sub_5 : dollar_genPut_6 {
    static internal readonly Predicate dollar_genPut_6_sub_6 = new Predicates.dollar_genPut_6_sub_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genPut_6_6, dollar_genPut_6_sub_6);
    }
}

sealed class dollar_genPut_6_sub_6 : dollar_genPut_6 {
    static internal readonly Predicate dollar_genPut_6_sub_7 = new Predicates.dollar_genPut_6_sub_7();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_genPut_6_7, dollar_genPut_6_sub_7);
    }
}

sealed class dollar_genPut_6_sub_7 : dollar_genPut_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_genPut_6_8);
    }
}

sealed class dollar_genPut_6_1 : dollar_genPut_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("should");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("be");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("an");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("unbound");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("variable");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s7 = new ListTerm(s5, s6);
    static internal readonly ListTerm s8 = new ListTerm(s4, s7);
    static internal readonly ListTerm s9 = new ListTerm(s3, s8);
    static internal readonly ListTerm s10 = new ListTerm(s2, s9);
    static internal readonly ListTerm s11 = new ListTerm(s1, s10);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a8 = new ListTerm(a2, s11);
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        p3 = new Predicates.dollar_message_1(a8, p2);
        p4 = new Predicates.dollar_cut_1(a7, p3);
        p5 = new Predicates.dollar_nonvar_1(a2, p4);
        return new Predicates.dollar_getLevel_1(a7, p5);
    }
}

sealed class dollar_genPut_6_2 : dollar_genPut_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_genPutVar_5(a8, a9, a2, a5, a6, cont);
        p2 = new Predicates.dollar_assignReg_5(a1, a8, a9, a3, a4, p1);
        p3 = new Predicates.dollar_cut_1(a7, p2);
        p4 = new Predicates.dollar_var_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_genPut_6_3 : dollar_genPut_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("floating");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("point");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("numbers");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("are");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("not");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("supported");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s8 = new ListTerm(s6, s7);
    static internal readonly ListTerm s9 = new ListTerm(s5, s8);
    static internal readonly ListTerm s10 = new ListTerm(s4, s9);
    static internal readonly ListTerm s11 = new ListTerm(s3, s10);
    static internal readonly ListTerm s12 = new ListTerm(s2, s11);
    static internal readonly ListTerm s13 = new ListTerm(s1, s12);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a6, a5, cont);
        p2 = new Predicates.dollar_fail_0(p1);
        p3 = new Predicates.dollar_message_1(s13, p2);
        p4 = new Predicates.dollar_cut_1(a7, p3);
        p5 = new Predicates.Float_1(a1, p4);
        return new Predicates.dollar_getLevel_1(a7, p5);
    }
}

sealed class dollar_genPut_6_4 : dollar_genPut_6 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        p1 = new Predicates.dollar_genPutGround_5(a8, a9, a2, a5, a6, cont);
        p2 = new Predicates.dollar_assignReg_5(a1, a8, a9, a3, a4, p1);
        p3 = new Predicates.dollar_cut_1(a7, p2);
        p4 = new Predicates.dollar_atomic_1(a1, p3);
        return new Predicates.dollar_getLevel_1(a7, p4);
    }
}

sealed class dollar_genPut_6_5 : dollar_genPut_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16;
        Predicate p1, p2, p3, p4, p5, p6;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a8 = new ListTerm(a9, a10);
        a12 = new ListTerm(a10, s1);
        a11 = new ListTerm(a9, a12);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        p1 = new Predicates.dollar_genPutGround_5(a15, a16, a2, a14, a6, cont);
        p2 = new Predicates.dollar_assignReg_5(a1, a15, a16, a13, a4, p1);
        p3 = new Predicates.dollar_genPutArgs_6(a11, engine.makeVariable(), a3, a13, a5, a14, p2);
        p4 = new Predicates.dollar_cut_1(a7, p3);
        p5 = new Predicates.dollar_unify_2(a1, a8, p4);
        p6 = new Predicates.Ground_1(a1, p5);
        return new Predicates.dollar_getLevel_1(a7, p6);
    }
}

sealed class dollar_genPut_6_6 : dollar_genPut_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("$f_n", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a8 = new ListTerm(a9, a10);
        a11 = engine.makeVariable();
        Term[] h2 = {a9, a11};
        a12 = new StructureTerm(f1, h2);
        a13 = engine.makeVariable();
        a14 = engine.makeVariable();
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        p1 = new Predicates.dollar_genPutGround_5(a16, a17, a2, a15, a6, cont);
        p2 = new Predicates.dollar_assignReg_5(a1, a16, a17, a14, a4, p1);
        p3 = new Predicates.dollar_genPutArgs_6(a10, engine.makeVariable(), a13, a14, a5, a15, p2);
        p4 = new Predicates.dollar_assignFunctor_4(a12, engine.makeVariable(), a3, a13, p3);
        p5 = new Predicates.dollar_cut_1(a7, p4);
        p6 = new Predicates.dollar_functor_3(a1, engine.makeVariable(), a11, p5);
        p7 = new Predicates.eq_stop_stop_2(a1, a8, p6);
        p8 = new Predicates.Ground_1(a1, p7);
        return new Predicates.dollar_getLevel_1(a7, p8);
    }
}

sealed class dollar_genPut_6_7 : dollar_genPut_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("put_list", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21;
        Predicate p1, p2, p3, p4, p5, p6, p7;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        a8 = new ListTerm(a9, a10);
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a13 = engine.makeVariable();
        a15 = new ListTerm(a10, s2);
        a14 = new ListTerm(a9, a15);
        a17 = engine.makeVariable();
        a19 = engine.makeVariable();
        a18 = new ListTerm(a19, s2);
        a16 = new ListTerm(a17, a18);
        a20 = engine.makeVariable();
        Term[] h4 = {a17, a19, a11};
        a21 = new StructureTerm(f3, h4);
        p1 = new Predicates._C_3(a20, a21, a6, cont);
        p2 = new Predicates.dollar_genPutArgs_6(a14, a16, a13, a4, a5, a20, p1);
        p3 = new Predicates.dollar_unify_2(a2, a11, p2);
        p4 = new Predicates.dollar_unify_2(a12, s1, p3);
        p5 = new Predicates.dollar_assignReg_5(engine.makeVariable(), a11, a12, a3, a13, p4);
        p6 = new Predicates.dollar_cut_1(a7, p5);
        p7 = new Predicates.dollar_unify_2(a1, a8, p6);
        return new Predicates.dollar_getLevel_1(a7, p7);
    }
}

sealed class dollar_genPut_6_8 : dollar_genPut_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("yes");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("$f_n", 2);
    static internal readonly IntegerTerm s4 = new IntegerTerm(1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("put_str_args", 2);
    static internal readonly SymbolTerm f6 = SymbolTerm.makeSymbol("h", 1);
    static internal readonly SymbolTerm f9 = SymbolTerm.makeSymbol("put_str", 3);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29, a30, a31, a32;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        a7 = engine.makeVariable();
        a8 = engine.makeVariable();
        a9 = engine.makeVariable();
        a11 = engine.makeVariable();
        a12 = engine.makeVariable();
        a10 = new ListTerm(a11, a12);
        a13 = engine.makeVariable();
        Term[] h3 = {a11, a13};
        a14 = new StructureTerm(f2, h3);
        a15 = engine.makeVariable();
        a16 = engine.makeVariable();
        a17 = engine.makeVariable();
        a18 = engine.makeVariable();
        a19 = engine.makeVariable();
        a21 = engine.makeVariable();
        a23 = engine.makeVariable();
        a24 = engine.makeVariable();
        a22 = new ListTerm(a23, a24);
        a20 = new ListTerm(a21, a22);
        a25 = engine.makeVariable();
        a27 = new ListTerm(a25, a24);
        a26 = new ListTerm(a21, a27);
        Term[] h7 = {a23};
        a29 = new StructureTerm(f6, h7);
        Term[] h8 = {a17, a29};
        a28 = new StructureTerm(f5, h8);
        a30 = engine.makeVariable();
        Term[] h10 = {a23};
        a32 = new StructureTerm(f6, h10);
        Term[] h11 = {a15, a32, a7};
        a31 = new StructureTerm(f9, h11);
        p1 = new Predicates._C_3(a30, a31, a6, cont);
        p2 = new Predicates._C_3(a19, a28, a30, p1);
        p3 = new Predicates.dollar_unify_2(a4, a26, p2);
        p4 = new Predicates.dollar_plus_3(a23, s4, a25, p3);
        p5 = new Predicates.dollar_unify_2(a18, a20, p4);
        p6 = new Predicates.dollar_genPutArgs_6(a12, a17, a16, a18, a5, a19, p5);
        p7 = new Predicates.dollar_assignFunctor_4(a14, a15, a9, a16, p6);
        p8 = new Predicates.dollar_functor_3(a1, engine.makeVariable(), a13, p7);
        p9 = new Predicates.eq_stop_stop_2(a1, a10, p8);
        p10 = new Predicates.dollar_unify_2(a2, a7, p9);
        p11 = new Predicates.dollar_unify_2(a8, s1, p10);
        return new Predicates.dollar_assignReg_5(engine.makeVariable(), a7, a8, a3, a9, p11);
    }
}
}

