/*
 * *** Please do not edit ! ***
 * @(#) dollar_generateTries2_6.cs
 * @procedure $generate_tries2/6 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_generateTries2_6 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_generateTries2_6_1 = new Predicates.dollar_generateTries2_6_1();
    static internal readonly Predicate dollar_generateTries2_6_2 = new Predicates.dollar_generateTries2_6_2();
    static internal readonly Predicate dollar_generateTries2_6_var = new Predicates.dollar_generateTries2_6_var();

    public Term arg1, arg2, arg3, arg4, arg5, arg6;

    public dollar_generateTries2_6(Term a1, Term a2, Term a3, Term a4, Term a5, Term a6, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        arg5 = a5; 
        arg6 = a6; 
        this.cont = cont;
    }

    public dollar_generateTries2_6(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        arg5 = args[4]; 
        arg6 = args[5]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.aregs[5] = arg5;
        engine.aregs[6] = arg6;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_generateTries2_6_var,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_fail_0,
                                   dollar_generateTries2_6_var
                                   );
    }

    public override int arity() { return 6; }

    public override string ToString() {
        return "$generate_tries2(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ", " + arg5 + ", " + arg6 + ")";
    }
}

sealed class dollar_generateTries2_6_var : dollar_generateTries2_6 {
    static internal readonly Predicate dollar_generateTries2_6_var_1 = new Predicates.dollar_generateTries2_6_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_generateTries2_6_1, dollar_generateTries2_6_var_1);
    }
}

sealed class dollar_generateTries2_6_var_1 : dollar_generateTries2_6 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_generateTries2_6_2);
    }
}

sealed class dollar_generateTries2_6_1 : dollar_generateTries2_6 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("exec_method", 4);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("trust");
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("trust", 1);
    static internal readonly SymbolTerm f5 = SymbolTerm.makeSymbol("+", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            if ( !s1.unify(((ListTerm)a1).cdr, engine.trail) )
                return engine.fail();
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h6 = {a2, a7};
        a11 = new StructureTerm(f5, h6);
        Term[] h7 = {a11};
        a10 = new StructureTerm(f4, h7);
        a9 = new ListTerm(a10, s1);
        Term[] h8 = {a2, s1, s3, a9};
        a8 = new StructureTerm(f2, h8);
        p1 = new Predicates._C_3(a5, a8, a6, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_generateTries2_6_2 : dollar_generateTries2_6 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("put_static_pred", 1);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("+", 2);
    static internal readonly SymbolTerm f3 = SymbolTerm.makeSymbol("/", 2);
    static internal readonly SymbolTerm f7 = SymbolTerm.makeSymbol("exec_method", 4);
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm s9 = SymbolTerm.makeSymbol("retry");
    static internal readonly SymbolTerm f10 = SymbolTerm.makeSymbol("retry", 2);
    static internal readonly SymbolTerm f16 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly IntegerTerm s20 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24;
        Predicate p1, p2, p3, p4, p5;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        a5 = engine.aregs[5].dereference();
        a6 = engine.aregs[6].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a7 = ((ListTerm)a1).car;
            a8 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a7 = engine.makeVariable();
            a8 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a7, a8), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h4 = {a3, a4};
        a11 = new StructureTerm(f3, h4);
        Term[] h5 = {a2, a11};
        a10 = new StructureTerm(f2, h5);
        Term[] h6 = {a10};
        a9 = new StructureTerm(f1, h6);
        a12 = engine.makeVariable();
        Term[] h11 = {a2, a7};
        a16 = new StructureTerm(f2, h11);
        Term[] h12 = {a3, a4};
        a18 = new StructureTerm(f3, h12);
        Term[] h13 = {a2, a18};
        a17 = new StructureTerm(f2, h13);
        Term[] h14 = {a16, a17};
        a15 = new StructureTerm(f10, h14);
        a14 = new ListTerm(a15, s8);
        Term[] h15 = {a2, s8, s9, a14};
        a13 = new StructureTerm(f7, h15);
        a19 = engine.makeVariable();
        Term[] h17 = {a3, a4};
        a22 = new StructureTerm(f3, h17);
        Term[] h18 = {a2, a22};
        a21 = new StructureTerm(f2, h18);
        Term[] h19 = {a21, s8};
        a20 = new StructureTerm(f16, h19);
        a23 = engine.makeVariable();
        a24 = engine.makeVariable();
        p1 = new Predicates.dollar_generateTries2_6(a8, a2, a3, a24, a23, a6, cont);
        p2 = new Predicates.dollar_plus_3(a4, s20, a24, p1);
        p3 = new Predicates._C_3(a19, a20, a23, p2);
        p4 = new Predicates._C_3(a12, a13, a19, p3);
        p5 = new Predicates._C_3(a5, a9, a12, p4);
        return new Predicates.dollar_neckCut_0(p5);
    }
}
}

