/*
 * *** Please do not edit ! ***
 * @(#) dollar_makeDummyClauses_4.cs
 * @procedure $make_dummy_clauses/4 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_makeDummyClauses_4 : Predicate {
    static internal readonly Predicate dollar_makeDummyClauses_4_1 = new Predicates.dollar_makeDummyClauses_4_1();
    static internal readonly Predicate dollar_makeDummyClauses_4_2 = new Predicates.dollar_makeDummyClauses_4_2();
    static internal readonly Predicate dollar_makeDummyClauses_4_var = new Predicates.dollar_makeDummyClauses_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_makeDummyClauses_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_makeDummyClauses_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_makeDummyClauses_4_var,
                                   dollar_makeDummyClauses_4_2,
                                   dollar_makeDummyClauses_4_2,
                                   dollar_makeDummyClauses_4_var,
                                   dollar_makeDummyClauses_4_2
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$make_dummy_clauses(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_makeDummyClauses_4_var : dollar_makeDummyClauses_4 {
    static internal readonly Predicate dollar_makeDummyClauses_4_var_1 = new Predicates.dollar_makeDummyClauses_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_makeDummyClauses_4_1, dollar_makeDummyClauses_4_var_1);
    }
}

sealed class dollar_makeDummyClauses_4_var_1 : dollar_makeDummyClauses_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_makeDummyClauses_4_2);
    }
}

sealed class dollar_makeDummyClauses_4_1 : dollar_makeDummyClauses_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(";", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a5 = args[0];
            a6 = args[1];
        } else if (a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a5, a6};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a7 = engine.makeVariable();
        p1 = new Predicates.dollar_makeDummyClauses_4(a6, a2, a7, a4, cont);
        p2 = new Predicates.dollar_makeDummyClauses_4(a5, a2, a3, a7, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_makeDummyClauses_4_2 : dollar_makeDummyClauses_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        Term[] h2 = {a2, a1};
        a5 = new StructureTerm(f1, h2);
        a6 = engine.makeVariable();
        p1 = new Predicates._C_3(a3, a6, a4, cont);
        return new Predicates.dollar_copyTerm_2(a5, a6, p1);
    }
}
}

