/*
 * *** Please do not edit ! ***
 * @(#) dollar_matchType1_2.cs
 * @procedure $match_type1/2 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_matchType1_2 : Predicate {
    static internal readonly Predicate dollar_matchType1_2_1 = new Predicates.dollar_matchType1_2_1();
    static internal readonly Predicate dollar_matchType1_2_2 = new Predicates.dollar_matchType1_2_2();
    static internal readonly Predicate dollar_matchType1_2_3 = new Predicates.dollar_matchType1_2_3();
    static internal readonly Predicate dollar_matchType1_2_4 = new Predicates.dollar_matchType1_2_4();
    static internal readonly Predicate dollar_matchType1_2_5 = new Predicates.dollar_matchType1_2_5();
    static internal readonly Predicate dollar_matchType1_2_con = new Predicates.dollar_matchType1_2_con();
    static internal readonly Predicate dollar_matchType1_2_int = new Predicates.dollar_matchType1_2_int();
    static internal readonly Predicate dollar_matchType1_2_str = new Predicates.dollar_matchType1_2_str();
    static internal readonly Predicate dollar_matchType1_2_var = new Predicates.dollar_matchType1_2_var();

    public Term arg1, arg2;

    public dollar_matchType1_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_matchType1_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_matchType1_2_var,
                                   dollar_matchType1_2_int,
                                   dollar_matchType1_2_con,
                                   dollar_matchType1_2_str,
                                   dollar_matchType1_2_var
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$match_type1(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_matchType1_2_var : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_var_1 = new Predicates.dollar_matchType1_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_matchType1_2_1, dollar_matchType1_2_var_1);
    }
}

sealed class dollar_matchType1_2_var_1 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_var_2 = new Predicates.dollar_matchType1_2_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_2, dollar_matchType1_2_var_2);
    }
}

sealed class dollar_matchType1_2_var_2 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_var_3 = new Predicates.dollar_matchType1_2_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_3, dollar_matchType1_2_var_3);
    }
}

sealed class dollar_matchType1_2_var_3 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_var_4 = new Predicates.dollar_matchType1_2_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_4, dollar_matchType1_2_var_4);
    }
}

sealed class dollar_matchType1_2_var_4 : dollar_matchType1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_matchType1_2_5);
    }
}

sealed class dollar_matchType1_2_int : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_int_1 = new Predicates.dollar_matchType1_2_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_matchType1_2_1, dollar_matchType1_2_int_1);
    }
}

sealed class dollar_matchType1_2_int_1 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_int_2 = new Predicates.dollar_matchType1_2_int_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_2, dollar_matchType1_2_int_2);
    }
}

sealed class dollar_matchType1_2_int_2 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_int_3 = new Predicates.dollar_matchType1_2_int_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_3, dollar_matchType1_2_int_3);
    }
}

sealed class dollar_matchType1_2_int_3 : dollar_matchType1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_matchType1_2_5);
    }
}

sealed class dollar_matchType1_2_con : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_con_1 = new Predicates.dollar_matchType1_2_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_matchType1_2_1, dollar_matchType1_2_con_1);
    }
}

sealed class dollar_matchType1_2_con_1 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_con_2 = new Predicates.dollar_matchType1_2_con_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_2, dollar_matchType1_2_con_2);
    }
}

sealed class dollar_matchType1_2_con_2 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_con_3 = new Predicates.dollar_matchType1_2_con_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_3, dollar_matchType1_2_con_3);
    }
}

sealed class dollar_matchType1_2_con_3 : dollar_matchType1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_matchType1_2_5);
    }
}

sealed class dollar_matchType1_2_str : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_str_1 = new Predicates.dollar_matchType1_2_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_matchType1_2_1, dollar_matchType1_2_str_1);
    }
}

sealed class dollar_matchType1_2_str_1 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_str_2 = new Predicates.dollar_matchType1_2_str_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_2, dollar_matchType1_2_str_2);
    }
}

sealed class dollar_matchType1_2_str_2 : dollar_matchType1_2 {
    static internal readonly Predicate dollar_matchType1_2_str_3 = new Predicates.dollar_matchType1_2_str_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_matchType1_2_3, dollar_matchType1_2_str_3);
    }
}

sealed class dollar_matchType1_2_str_3 : dollar_matchType1_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_matchType1_2_5);
    }
}

sealed class dollar_matchType1_2_1 : dollar_matchType1_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a3, cont);
        p2 = new Predicates.dollar_var_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a3, p2);
    }
}

sealed class dollar_matchType1_2_2 : dollar_matchType1_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("int");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a2, s1, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_integer_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class dollar_matchType1_2_3 : dollar_matchType1_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("con");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a2, s1, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_atom_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}

sealed class dollar_matchType1_2_4 : dollar_matchType1_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("lis");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
        } else if ( a1.isVariable() ){
            if ( !a1.unify(new ListTerm(engine.makeVariable(), engine.makeVariable()), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unify_2(a2, s1, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_matchType1_2_5 : dollar_matchType1_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("str");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        a3 = engine.makeVariable();
        p1 = new Predicates.dollar_unify_2(a2, s1, cont);
        p2 = new Predicates.dollar_cut_1(a3, p1);
        p3 = new Predicates.dollar_functor_3(a1, engine.makeVariable(), engine.makeVariable(), p2);
        return new Predicates.dollar_getLevel_1(a3, p3);
    }
}
}

