/*
 * *** Please do not edit ! ***
 * @(#) dollar_matchType_2.cs
 * @procedure $match_type/2 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_matchType_2 : Predicate {
    static internal readonly Predicate dollar_matchType_2_1 = new Predicates.dollar_matchType_2_1();
    static internal readonly Predicate dollar_matchType_2_2 = new Predicates.dollar_matchType_2_2();
    static internal readonly Predicate dollar_matchType_2_var = new Predicates.dollar_matchType_2_var();

    public Term arg1, arg2;

    public dollar_matchType_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_matchType_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_matchType_2_var,
                                   dollar_matchType_2_1,
                                   dollar_matchType_2_1,
                                   dollar_matchType_2_var,
                                   dollar_matchType_2_1
                                   );
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$match_type(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_matchType_2_var : dollar_matchType_2 {
    static internal readonly Predicate dollar_matchType_2_var_1 = new Predicates.dollar_matchType_2_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_matchType_2_1, dollar_matchType_2_var_1);
    }
}

sealed class dollar_matchType_2_var_1 : dollar_matchType_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_matchType_2_2);
    }
}

sealed class dollar_matchType_2_1 : dollar_matchType_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("var");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_matchType_2_2 : dollar_matchType_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":-", 2);
    static internal readonly IntegerTerm s2 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a1.isStructure() ){
            if (f1 != ((StructureTerm)a1).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a1).args;
            a3 = args[0];
        } else if (a1.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3, engine.makeVariable()};
            if ( !a1.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_matchType1_2(a4, a2, cont);
        return new Predicates.dollar_arg_3(s2, a3, a4, p1);
    }
}
}

