/*
 * *** Please do not edit ! ***
 * @(#) dollar_pickupGround_3.cs
 * @procedure $pickup_ground/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_pickupGround_3 : Predicate, FcoPredicate {
    static internal readonly System.Type EntryCodeType = typeof( dollar_pickupGround_3 );
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_pickupGround_3_1 = new Predicates.dollar_pickupGround_3_1();
    static internal readonly Predicate dollar_pickupGround_3_2 = new Predicates.dollar_pickupGround_3_2();
    static internal readonly Predicate dollar_pickupGround_3_3 = new Predicates.dollar_pickupGround_3_3();
    static internal readonly Predicate dollar_pickupGround_3_4 = new Predicates.dollar_pickupGround_3_4();
    static internal readonly Predicate dollar_pickupGround_3_lis = new Predicates.dollar_pickupGround_3_lis();
    static internal readonly Predicate dollar_pickupGround_3_var = new Predicates.dollar_pickupGround_3_var();

    public Term arg1, arg2, arg3;

    public dollar_pickupGround_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_pickupGround_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.SetEntryCode( EntryCodeType, this );
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_pickupGround_3_var,
                                   dollar_fail_0,
                                   dollar_pickupGround_3_1,
                                   dollar_fail_0,
                                   dollar_pickupGround_3_lis
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$pickup_ground(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_pickupGround_3_var : dollar_pickupGround_3 {
    static internal readonly Predicate dollar_pickupGround_3_var_1 = new Predicates.dollar_pickupGround_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_pickupGround_3_1, dollar_pickupGround_3_var_1);
    }
}

sealed class dollar_pickupGround_3_var_1 : dollar_pickupGround_3 {
    static internal readonly Predicate dollar_pickupGround_3_var_2 = new Predicates.dollar_pickupGround_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_pickupGround_3_2, dollar_pickupGround_3_var_2);
    }
}

sealed class dollar_pickupGround_3_var_2 : dollar_pickupGround_3 {
    static internal readonly Predicate dollar_pickupGround_3_var_3 = new Predicates.dollar_pickupGround_3_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_pickupGround_3_3, dollar_pickupGround_3_var_3);
    }
}

sealed class dollar_pickupGround_3_var_3 : dollar_pickupGround_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_pickupGround_3_4);
    }
}

sealed class dollar_pickupGround_3_lis : dollar_pickupGround_3 {
    static internal readonly Predicate dollar_pickupGround_3_lis_1 = new Predicates.dollar_pickupGround_3_lis_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_pickupGround_3_2, dollar_pickupGround_3_lis_1);
    }
}

sealed class dollar_pickupGround_3_lis_1 : dollar_pickupGround_3 {
    static internal readonly Predicate dollar_pickupGround_3_lis_2 = new Predicates.dollar_pickupGround_3_lis_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_pickupGround_3_3, dollar_pickupGround_3_lis_2);
    }
}

sealed class dollar_pickupGround_3_lis_2 : dollar_pickupGround_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_pickupGround_3_4);
    }
}

sealed class dollar_pickupGround_3_1 : dollar_pickupGround_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a3, a2, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_pickupGround_3_2 : dollar_pickupGround_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("s", 1);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isList() ){
            a6 = ((ListTerm)a4).car;
            a7 = ((ListTerm)a4).cdr;
        } else if ( a4.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.isList() ){
            a8 = ((ListTerm)a7).car;
            a9 = ((ListTerm)a7).cdr;
        } else if ( a7.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a7.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.isList() ){
            if ( !s1.unify(((ListTerm)a9).cdr, engine.trail) )
                return engine.fail();
        } else if ( a9.isVariable() ){
            if ( !a9.unify(new ListTerm(engine.makeVariable(), s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        Term[] h3 = {engine.makeVariable()};
        a11 = new StructureTerm(f2, h3);
        a12 = engine.makeVariable();
        Term[] h5 = {a6, a8};
        a13 = new StructureTerm(f4, h5);
        p1 = new Predicates._C_3(a12, a13, a3, cont);
        p2 = new Predicates.dollar_pickupGround_3(a5, a2, a12, p1);
        p3 = new Predicates.dollar_cut_1(a10, p2);
        p4 = new Predicates.dollar_unify_2(a8, a11, p3);
        return new Predicates.dollar_getLevel_1(a10, p4);
    }
}

sealed class dollar_pickupGround_3_3 : dollar_pickupGround_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("f", 1);
    static internal readonly SymbolTerm f4 = SymbolTerm.makeSymbol("=", 2);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a4.isList() ){
            a6 = ((ListTerm)a4).car;
            a7 = ((ListTerm)a4).cdr;
        } else if ( a4.isVariable() ){
            a6 = engine.makeVariable();
            a7 = engine.makeVariable();
            if ( !a4.unify(new ListTerm(a6, a7), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a7.isList() ){
            a8 = ((ListTerm)a7).car;
            a9 = ((ListTerm)a7).cdr;
        } else if ( a7.isVariable() ){
            a8 = engine.makeVariable();
            a9 = engine.makeVariable();
            if ( !a7.unify(new ListTerm(a8, a9), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        if ( a9.isList() ){
            if ( !s1.unify(((ListTerm)a9).cdr, engine.trail) )
                return engine.fail();
        } else if ( a9.isVariable() ){
            if ( !a9.unify(new ListTerm(engine.makeVariable(), s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a10 = engine.makeVariable();
        Term[] h3 = {engine.makeVariable()};
        a11 = new StructureTerm(f2, h3);
        a12 = engine.makeVariable();
        Term[] h5 = {a6, a8};
        a13 = new StructureTerm(f4, h5);
        p1 = new Predicates._C_3(a12, a13, a3, cont);
        p2 = new Predicates.dollar_pickupGround_3(a5, a2, a12, p1);
        p3 = new Predicates.dollar_cut_1(a10, p2);
        p4 = new Predicates.dollar_unify_2(a8, a11, p3);
        return new Predicates.dollar_getLevel_1(a10, p4);
    }
}

sealed class dollar_pickupGround_3_4 : dollar_pickupGround_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(engine.makeVariable(), a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        engine.aregs[1] = a4;
        engine.aregs[2] = a2;
        engine.aregs[3] = a3;
        engine.cont = cont;
        return engine.GetEntryCode( EntryCodeType ).call( engine );
    }
}
}

