/*
 * *** Please do not edit ! ***
 * @(#) dollar_precompHead_4.cs
 * @procedure $precomp_head/4 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_precompHead_4 : Predicate {
    static internal readonly Predicate dollar_fail_0 = new Predicates.dollar_fail_0();
    static internal readonly Predicate dollar_precompHead_4_1 = new Predicates.dollar_precompHead_4_1();
    static internal readonly Predicate dollar_precompHead_4_2 = new Predicates.dollar_precompHead_4_2();
    static internal readonly Predicate dollar_precompHead_4_var = new Predicates.dollar_precompHead_4_var();

    public Term arg1, arg2, arg3, arg4;

    public dollar_precompHead_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_precompHead_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.aregs[4] = arg4;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_precompHead_4_var,
                                   dollar_fail_0,
                                   dollar_precompHead_4_1,
                                   dollar_fail_0,
                                   dollar_precompHead_4_2
                                   );
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$precomp_head(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}

sealed class dollar_precompHead_4_var : dollar_precompHead_4 {
    static internal readonly Predicate dollar_precompHead_4_var_1 = new Predicates.dollar_precompHead_4_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_precompHead_4_1, dollar_precompHead_4_var_1);
    }
}

sealed class dollar_precompHead_4_var_1 : dollar_precompHead_4 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_precompHead_4_2);
    }
}

sealed class dollar_precompHead_4_1 : dollar_precompHead_4 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a1, engine.trail) ) return engine.fail();
        p1 = new Predicates.dollar_unify_2(a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_precompHead_4_2 : dollar_precompHead_4 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("get", 2);
    static internal readonly SymbolTerm f2 = SymbolTerm.makeSymbol("a", 1);
    static internal readonly IntegerTerm s5 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        a4 = engine.aregs[4].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a5 = ((ListTerm)a1).car;
            a6 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a5, a6), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        Term[] h3 = {a2};
        a8 = new StructureTerm(f2, h3);
        Term[] h4 = {a5, a8};
        a7 = new StructureTerm(f1, h4);
        a9 = engine.makeVariable();
        a10 = engine.makeVariable();
        p1 = new Predicates.dollar_precompHead_4(a6, a10, a9, a4, cont);
        p2 = new Predicates.dollar_plus_3(a2, s5, a10, p1);
        return new Predicates._C_3(a3, a7, a9, p2);
    }
}
}

