/*
 * *** Please do not edit ! ***
 * @(#) dollar_unifyListR4_4.cs
 * @procedure $unify_list_r4/4 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_unifyListR4_4 : Predicate {
    static internal readonly IntegerTerm s1 = new IntegerTerm(12);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("if ( !");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(".unify(((ListTerm)");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(").");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol(", ");
    static internal readonly SymbolTerm s7 = SymbolTerm.makeSymbol("engine.trail) )");
    static internal readonly SymbolTerm s8 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s9 = new ListTerm(s7, s8);
    static internal readonly ListTerm s10 = new ListTerm(s6, s9);
    static internal readonly ListTerm s11 = new ListTerm(s5, s10);
    static internal readonly IntegerTerm s12 = new IntegerTerm(16);
    static internal readonly SymbolTerm s13 = SymbolTerm.makeSymbol("return engine.fail();");
    static internal readonly ListTerm s14 = new ListTerm(s13, s8);

    public Term arg1, arg2, arg3, arg4;

    public dollar_unifyListR4_4(Term a1, Term a2, Term a3, Term a4, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        arg4 = a4; 
        this.cont = cont;
    }

    public dollar_unifyListR4_4(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        arg4 = args[3]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.setB0();
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2;
        a1 = arg1.dereference();
        a2 = arg2.dereference();
        a3 = arg3.dereference();
        a4 = arg4.dereference();

        a5 = engine.makeVariable();
        a11 = new ListTerm(a2, s11);
        a10 = new ListTerm(s4, a11);
        a9 = new ListTerm(a3, a10);
        a8 = new ListTerm(s3, a9);
        a7 = new ListTerm(a5, a8);
        a6 = new ListTerm(s2, a7);
        p1 = new Predicates.dollar_writelnStream_3(a1, s12, s14, cont);
        p2 = new Predicates.dollar_writelnStream_3(a1, s1, a6, p1);
        return new Predicates.dollar_createRegName_2(a4, a5, p2);
    }

    public override int arity() { return 4; }

    public override string ToString() {
        return "$unify_list_r4(" + arg1 + ", " + arg2 + ", " + arg3 + ", " + arg4 + ")";
    }
}
}

