/*
 * *** Please do not edit ! ***
 * @(#) dollar_unifyStrR_3.cs
 * @procedure $unify_str_r/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_unifyStrR_3 : Predicate {
    static internal readonly Predicate dollar_unifyStrR_3_1 = new Predicates.dollar_unifyStrR_3_1();
    static internal readonly Predicate dollar_unifyStrR_3_2 = new Predicates.dollar_unifyStrR_3_2();
    static internal readonly Predicate dollar_unifyStrR_3_3 = new Predicates.dollar_unifyStrR_3_3();
    static internal readonly Predicate dollar_unifyStrR_3_4 = new Predicates.dollar_unifyStrR_3_4();
    static internal readonly Predicate dollar_unifyStrR_3_5 = new Predicates.dollar_unifyStrR_3_5();
    static internal readonly Predicate dollar_unifyStrR_3_6 = new Predicates.dollar_unifyStrR_3_6();
    static internal readonly Predicate dollar_unifyStrR_3_sub_1 = new Predicates.dollar_unifyStrR_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_unifyStrR_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_unifyStrR_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_unifyStrR_3_1, dollar_unifyStrR_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$unify_str_r(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_unifyStrR_3_sub_1 : dollar_unifyStrR_3 {
    static internal readonly Predicate dollar_unifyStrR_3_sub_2 = new Predicates.dollar_unifyStrR_3_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyStrR_3_2, dollar_unifyStrR_3_sub_2);
    }
}

sealed class dollar_unifyStrR_3_sub_2 : dollar_unifyStrR_3 {
    static internal readonly Predicate dollar_unifyStrR_3_sub_3 = new Predicates.dollar_unifyStrR_3_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyStrR_3_3, dollar_unifyStrR_3_sub_3);
    }
}

sealed class dollar_unifyStrR_3_sub_3 : dollar_unifyStrR_3 {
    static internal readonly Predicate dollar_unifyStrR_3_sub_4 = new Predicates.dollar_unifyStrR_3_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyStrR_3_4, dollar_unifyStrR_3_sub_4);
    }
}

sealed class dollar_unifyStrR_3_sub_4 : dollar_unifyStrR_3 {
    static internal readonly Predicate dollar_unifyStrR_3_sub_5 = new Predicates.dollar_unifyStrR_3_sub_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_unifyStrR_3_5, dollar_unifyStrR_3_sub_5);
    }
}

sealed class dollar_unifyStrR_3_sub_5 : dollar_unifyStrR_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_unifyStrR_3_6);
    }
}

sealed class dollar_unifyStrR_3_1 : dollar_unifyStrR_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_void", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
        } else if (a2.isVariable() ){
            Term[] args = {engine.makeVariable()};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_unifyStrR_3_2 : dollar_unifyStrR_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_var", 1);
    static internal readonly IntegerTerm s2 = new IntegerTerm(12);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol(" = args[");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol("];");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        a8 = new ListTerm(a3, s6);
        a7 = new ListTerm(s3, a8);
        a6 = new ListTerm(a5, a7);
        p1 = new Predicates.dollar_writelnStream_3(a1, s2, a6, cont);
        p2 = new Predicates.dollar_createRegName_2(a4, a5, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_unifyStrR_3_3 : dollar_unifyStrR_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_val", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyStrR4_3(a1, a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyStrR_3_4 : dollar_unifyStrR_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_int", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyStrR4_3(a1, a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyStrR_3_5 : dollar_unifyStrR_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_con", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyStrR4_3(a1, a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}

sealed class dollar_unifyStrR_3_6 : dollar_unifyStrR_3 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("unify_ground", 1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a4 = args[0];
        } else if (a2.isVariable() ){
            a4 = engine.makeVariable();
            Term[] args = {a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_unifyStrR4_3(a1, a4, a3, cont);
        return new Predicates.dollar_neckCut_0(p1);
    }
}
}

