/*
 * *** Please do not edit ! ***
 * @(#) dollar_variables_3.cs
 * @procedure $variables/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_variables_3 : Predicate {
    static internal readonly Predicate dollar_variables_3_1 = new Predicates.dollar_variables_3_1();
    static internal readonly Predicate dollar_variables_3_2 = new Predicates.dollar_variables_3_2();
    static internal readonly Predicate dollar_variables_3_3 = new Predicates.dollar_variables_3_3();
    static internal readonly Predicate dollar_variables_3_4 = new Predicates.dollar_variables_3_4();
    static internal readonly Predicate dollar_variables_3_5 = new Predicates.dollar_variables_3_5();
    static internal readonly Predicate dollar_variables_3_con = new Predicates.dollar_variables_3_con();
    static internal readonly Predicate dollar_variables_3_int = new Predicates.dollar_variables_3_int();
    static internal readonly Predicate dollar_variables_3_str = new Predicates.dollar_variables_3_str();
    static internal readonly Predicate dollar_variables_3_var = new Predicates.dollar_variables_3_var();

    public Term arg1, arg2, arg3;

    public dollar_variables_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_variables_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.switch_on_term(
                                   dollar_variables_3_var,
                                   dollar_variables_3_int,
                                   dollar_variables_3_con,
                                   dollar_variables_3_str,
                                   dollar_variables_3_var
                                   );
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$variables(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_variables_3_var : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_var_1 = new Predicates.dollar_variables_3_var_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_variables_3_1, dollar_variables_3_var_1);
    }
}

sealed class dollar_variables_3_var_1 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_var_2 = new Predicates.dollar_variables_3_var_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_2, dollar_variables_3_var_2);
    }
}

sealed class dollar_variables_3_var_2 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_var_3 = new Predicates.dollar_variables_3_var_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_3, dollar_variables_3_var_3);
    }
}

sealed class dollar_variables_3_var_3 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_var_4 = new Predicates.dollar_variables_3_var_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_4, dollar_variables_3_var_4);
    }
}

sealed class dollar_variables_3_var_4 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_variables_3_5);
    }
}

sealed class dollar_variables_3_int : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_int_1 = new Predicates.dollar_variables_3_int_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_variables_3_1, dollar_variables_3_int_1);
    }
}

sealed class dollar_variables_3_int_1 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_int_2 = new Predicates.dollar_variables_3_int_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_2, dollar_variables_3_int_2);
    }
}

sealed class dollar_variables_3_int_2 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_int_3 = new Predicates.dollar_variables_3_int_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_3, dollar_variables_3_int_3);
    }
}

sealed class dollar_variables_3_int_3 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_variables_3_5);
    }
}

sealed class dollar_variables_3_con : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_con_1 = new Predicates.dollar_variables_3_con_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_variables_3_1, dollar_variables_3_con_1);
    }
}

sealed class dollar_variables_3_con_1 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_con_2 = new Predicates.dollar_variables_3_con_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_2, dollar_variables_3_con_2);
    }
}

sealed class dollar_variables_3_con_2 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_con_3 = new Predicates.dollar_variables_3_con_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_3, dollar_variables_3_con_3);
    }
}

sealed class dollar_variables_3_con_3 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_variables_3_5);
    }
}

sealed class dollar_variables_3_str : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_str_1 = new Predicates.dollar_variables_3_str_1();

    public override Predicate exec( Prolog engine ) {
        return engine.jtry(dollar_variables_3_1, dollar_variables_3_str_1);
    }
}

sealed class dollar_variables_3_str_1 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_str_2 = new Predicates.dollar_variables_3_str_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_2, dollar_variables_3_str_2);
    }
}

sealed class dollar_variables_3_str_2 : dollar_variables_3 {
    static internal readonly Predicate dollar_variables_3_str_3 = new Predicates.dollar_variables_3_str_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_variables_3_3, dollar_variables_3_str_3);
    }
}

sealed class dollar_variables_3_str_3 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_variables_3_5);
    }
}

sealed class dollar_variables_3_1 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_memq_2(a1, a2, p1);
        p3 = new Predicates.dollar_var_1(a1, p2);
        return new Predicates.dollar_getLevel_1(a4, p3);
    }
}

sealed class dollar_variables_3_2 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a3.isList() ){
            if ( !a1.unify(((ListTerm)a3).car, engine.trail) )
                return engine.fail();
            if ( !a2.unify(((ListTerm)a3).cdr, engine.trail) )
                return engine.fail();
        } else if ( a3.isVariable() ){
            if ( !a3.unify(new ListTerm(a1, a2), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_var_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_variables_3_3 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( !a2.unify(a3, engine.trail) ) return engine.fail();
        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_cut_1(a4, cont);
        p2 = new Predicates.dollar_atomic_1(a1, p1);
        return new Predicates.dollar_getLevel_1(a4, p2);
    }
}

sealed class dollar_variables_3_4 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a1.isList() ){
            a4 = ((ListTerm)a1).car;
            a5 = ((ListTerm)a1).cdr;
        } else if ( a1.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a1.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        p1 = new Predicates.dollar_variables_3(a5, a6, a3, cont);
        p2 = new Predicates.dollar_variables_3(a4, a2, a6, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_variables_3_5 : dollar_variables_3 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        a4 = engine.makeVariable();
        p1 = new Predicates.dollar_variables_3(a4, a2, a3, cont);
        return new Predicates.eq_stop_stop_2(a1, a4, p1);
    }
}
}

