/*
 * *** Please do not edit ! ***
 * @(#) dollar_wjFcoCont_3.cs
 * @procedure $wj_fco_cont/3 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_wjFcoCont_3 : Predicate {
    static internal readonly Predicate dollar_wjFcoCont_3_1 = new Predicates.dollar_wjFcoCont_3_1();
    static internal readonly Predicate dollar_wjFcoCont_3_2 = new Predicates.dollar_wjFcoCont_3_2();
    static internal readonly Predicate dollar_wjFcoCont_3_sub_1 = new Predicates.dollar_wjFcoCont_3_sub_1();

    public Term arg1, arg2, arg3;

    public dollar_wjFcoCont_3(Term a1, Term a2, Term a3, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        arg3 = a3; 
        this.cont = cont;
    }

    public dollar_wjFcoCont_3(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        arg3 = args[2]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.aregs[3] = arg3;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_wjFcoCont_3_1, dollar_wjFcoCont_3_sub_1);
    }

    public override int arity() { return 3; }

    public override string ToString() {
        return "$wj_fco_cont(" + arg1 + ", " + arg2 + ", " + arg3 + ")";
    }
}

sealed class dollar_wjFcoCont_3_sub_1 : dollar_wjFcoCont_3 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_wjFcoCont_3_2);
    }
}

sealed class dollar_wjFcoCont_3_1 : dollar_wjFcoCont_3 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("engine.cont = ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(";");
    static internal readonly ListTerm s5 = new ListTerm(s4, s1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            if ( !s1.unify(((ListTerm)a2).cdr, engine.trail) )
                return engine.fail();
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, s1), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a5 = engine.makeVariable();
        a7 = new ListTerm(a5, s5);
        a6 = new ListTerm(s3, a7);
        p1 = new Predicates.dollar_writelnStream_3(a1, s2, a6, cont);
        p2 = new Predicates.dollar_createRegName_2(a4, a5, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_wjFcoCont_3_2 : dollar_wjFcoCont_3 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(8);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("engine.aregs[");
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("] = ");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(";");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol("[]");
    static internal readonly ListTerm s6 = new ListTerm(s4, s5);
    static internal readonly IntegerTerm s7 = new IntegerTerm(1);

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        a3 = engine.aregs[3].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a4 = ((ListTerm)a2).car;
            a5 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a4, a5), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        a6 = engine.makeVariable();
        a10 = new ListTerm(a6, s6);
        a9 = new ListTerm(s3, a10);
        a8 = new ListTerm(a3, a9);
        a7 = new ListTerm(s2, a8);
        a11 = engine.makeVariable();
        p1 = new Predicates.dollar_wjFcoCont_3(a1, a5, a11, cont);
        p2 = new Predicates.dollar_plus_3(a3, s7, a11, p1);
        p3 = new Predicates.dollar_writelnStream_3(a1, s1, a7, p2);
        return new Predicates.dollar_createRegName_2(a4, a6, p3);
    }
}
}

