/*
 * *** Please do not edit ! ***
 * @(#) dollar_writeIntermediate_2.cs
 * @procedure $write_intermediate/2 in plcs.pl
 */

/*
 * @version P# 0.1, on March 18 2002;  Prolog Cafe 0.44, on November 12 1999
 * @author Mutsunori Banbara (banbara@pascal.seg.kobe-u.ac.jp)
 * @author Naoyuki Tamura    (tamura@kobe-u.ac.jp)
 * Modified by Jonathan Cook (jjc@dcs.ed.ac.uk)
 */
namespace JJC.Psharp.Predicates {

using JJC.Psharp.Lang;
using JJC.Psharp.Lang.Resource;
using Predicates = JJC.Psharp.Predicates;
using Resources = JJC.Psharp.Resources;

public class dollar_writeIntermediate_2 : Predicate {
    static internal readonly Predicate dollar_writeIntermediate_2_1 = new Predicates.dollar_writeIntermediate_2_1();
    static internal readonly Predicate dollar_writeIntermediate_2_2 = new Predicates.dollar_writeIntermediate_2_2();
    static internal readonly Predicate dollar_writeIntermediate_2_3 = new Predicates.dollar_writeIntermediate_2_3();
    static internal readonly Predicate dollar_writeIntermediate_2_4 = new Predicates.dollar_writeIntermediate_2_4();
    static internal readonly Predicate dollar_writeIntermediate_2_5 = new Predicates.dollar_writeIntermediate_2_5();
    static internal readonly Predicate dollar_writeIntermediate_2_6 = new Predicates.dollar_writeIntermediate_2_6();
    static internal readonly Predicate dollar_writeIntermediate_2_7 = new Predicates.dollar_writeIntermediate_2_7();
    static internal readonly Predicate dollar_writeIntermediate_2_sub_1 = new Predicates.dollar_writeIntermediate_2_sub_1();

    public Term arg1, arg2;

    public dollar_writeIntermediate_2(Term a1, Term a2, Predicate cont) {
        arg1 = a1; 
        arg2 = a2; 
        this.cont = cont;
    }

    public dollar_writeIntermediate_2(){}
    public override void setArgument(Term[] args, Predicate cont) {
        arg1 = args[0]; 
        arg2 = args[1]; 
        this.cont = cont;
    }

    public override Predicate exec( Prolog engine ) {
        engine.aregs[1] = arg1;
        engine.aregs[2] = arg2;
        engine.cont = cont;
        return call( engine );
    }

    public virtual Predicate call( Prolog engine ) {
        engine.setB0();
        return engine.jtry(dollar_writeIntermediate_2_1, dollar_writeIntermediate_2_sub_1);
    }

    public override int arity() { return 2; }

    public override string ToString() {
        return "$write_intermediate(" + arg1 + ", " + arg2 + ")";
    }
}

sealed class dollar_writeIntermediate_2_sub_1 : dollar_writeIntermediate_2 {
    static internal readonly Predicate dollar_writeIntermediate_2_sub_2 = new Predicates.dollar_writeIntermediate_2_sub_2();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeIntermediate_2_2, dollar_writeIntermediate_2_sub_2);
    }
}

sealed class dollar_writeIntermediate_2_sub_2 : dollar_writeIntermediate_2 {
    static internal readonly Predicate dollar_writeIntermediate_2_sub_3 = new Predicates.dollar_writeIntermediate_2_sub_3();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeIntermediate_2_3, dollar_writeIntermediate_2_sub_3);
    }
}

sealed class dollar_writeIntermediate_2_sub_3 : dollar_writeIntermediate_2 {
    static internal readonly Predicate dollar_writeIntermediate_2_sub_4 = new Predicates.dollar_writeIntermediate_2_sub_4();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeIntermediate_2_4, dollar_writeIntermediate_2_sub_4);
    }
}

sealed class dollar_writeIntermediate_2_sub_4 : dollar_writeIntermediate_2 {
    static internal readonly Predicate dollar_writeIntermediate_2_sub_5 = new Predicates.dollar_writeIntermediate_2_sub_5();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeIntermediate_2_5, dollar_writeIntermediate_2_sub_5);
    }
}

sealed class dollar_writeIntermediate_2_sub_5 : dollar_writeIntermediate_2 {
    static internal readonly Predicate dollar_writeIntermediate_2_sub_6 = new Predicates.dollar_writeIntermediate_2_sub_6();

    public override Predicate exec( Prolog engine ) {
        return engine.retry(dollar_writeIntermediate_2_6, dollar_writeIntermediate_2_sub_6);
    }
}

sealed class dollar_writeIntermediate_2_sub_6 : dollar_writeIntermediate_2 {

    public override Predicate exec( Prolog engine ) {
        return engine.trust(dollar_writeIntermediate_2_7);
    }
}

sealed class dollar_writeIntermediate_2_1 : dollar_writeIntermediate_2 {
    static internal readonly SymbolTerm s1 = SymbolTerm.makeSymbol("[]");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( !s1.unify(a2, engine.trail) ) return engine.fail();
        return new Predicates.dollar_neckCut_0(cont);
    }
}

sealed class dollar_writeIntermediate_2_2 : dollar_writeIntermediate_2 {

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isList() ){
            a3 = ((ListTerm)a2).car;
            a4 = ((ListTerm)a2).cdr;
        } else if ( a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            if ( !a2.unify(new ListTerm(a3, a4), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_writeIntermediate_2(a1, a4, cont);
        p2 = new Predicates.dollar_writeIntermediate_2(a1, a3, p1);
        return new Predicates.dollar_neckCut_0(p2);
    }
}

sealed class dollar_writeIntermediate_2_3 : dollar_writeIntermediate_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("comment", 1);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol("%%% ");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.Writeq_2(a1, a3, p1);
        p3 = new Predicates.Write_2(a1, s2, p2);
        return new Predicates.dollar_neckCut_0(p3);
    }
}

sealed class dollar_writeIntermediate_2_4 : dollar_writeIntermediate_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("debug", 1);
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("%%% ");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            Term[] args = {a3};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.Writeq_2(a1, a3, p1);
        p3 = new Predicates.Write_2(a1, s3, p2);
        p4 = new Predicates.dollar_tab_2(a1, s2, p3);
        return new Predicates.dollar_neckCut_0(p4);
    }
}

sealed class dollar_writeIntermediate_2_5 : dollar_writeIntermediate_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol(":", 2);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(" :");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4;
        Predicate p1, p2, p3, p4;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            Term[] args = {a3, a4};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_writeIntermediate_2(a1, a4, cont);
        p2 = new Predicates.dollar_nl_1(a1, p1);
        p3 = new Predicates.Write_2(a1, s2, p2);
        p4 = new Predicates.Writeq_2(a1, a3, p3);
        return new Predicates.dollar_neckCut_0(p4);
    }
}

sealed class dollar_writeIntermediate_2_6 : dollar_writeIntermediate_2 {
    static internal readonly SymbolTerm f1 = SymbolTerm.makeSymbol("exec_method", 4);
    static internal readonly IntegerTerm s2 = new IntegerTerm(8);
    static internal readonly SymbolTerm s3 = SymbolTerm.makeSymbol("exec_method(");
    static internal readonly SymbolTerm s4 = SymbolTerm.makeSymbol(",");
    static internal readonly SymbolTerm s5 = SymbolTerm.makeSymbol(",[");
    static internal readonly SymbolTerm s6 = SymbolTerm.makeSymbol("].");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2, a3, a4, a5, a6;
        Predicate p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12, p13;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        if ( a2.isStructure() ){
            if (f1 != ((StructureTerm)a2).functor )
                return engine.fail();
            Term[] args = ((StructureTerm)a2).args;
            a3 = args[0];
            a4 = args[1];
            a5 = args[2];
            a6 = args[3];
        } else if (a2.isVariable() ){
            a3 = engine.makeVariable();
            a4 = engine.makeVariable();
            a5 = engine.makeVariable();
            a6 = engine.makeVariable();
            Term[] args = {a3, a4, a5, a6};
            if ( !a2.unify(new StructureTerm(f1, args), engine.trail) )
                return engine.fail();
        } else {
            return engine.fail();
        }
        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.Write_2(a1, s6, p1);
        p3 = new Predicates.dollar_tab_2(a1, s2, p2);
        p4 = new Predicates.WriteImdExec_2(a1, a6, p3);
        p5 = new Predicates.dollar_nl_1(a1, p4);
        p6 = new Predicates.Write_2(a1, s5, p5);
        p7 = new Predicates.Writeq_2(a1, a5, p6);
        p8 = new Predicates.Write_2(a1, s4, p7);
        p9 = new Predicates.Writeq_2(a1, a4, p8);
        p10 = new Predicates.Write_2(a1, s4, p9);
        p11 = new Predicates.Writeq_2(a1, a3, p10);
        p12 = new Predicates.Write_2(a1, s3, p11);
        p13 = new Predicates.dollar_tab_2(a1, s2, p12);
        return new Predicates.dollar_neckCut_0(p13);
    }
}

sealed class dollar_writeIntermediate_2_7 : dollar_writeIntermediate_2 {
    static internal readonly IntegerTerm s1 = new IntegerTerm(8);
    static internal readonly SymbolTerm s2 = SymbolTerm.makeSymbol(".");

    public override Predicate exec( Prolog engine ) {
        Term a1, a2;
        Predicate p1, p2, p3;
        a1 = engine.aregs[1].dereference();
        a2 = engine.aregs[2].dereference();
        Predicate cont = engine.cont;

        p1 = new Predicates.dollar_nl_1(a1, cont);
        p2 = new Predicates.Write_2(a1, s2, p1);
        p3 = new Predicates.Writeq_2(a1, a2, p2);
        return new Predicates.dollar_tab_2(a1, s1, p3);
    }
}
}

